
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.unitesMesure.UniteMesure;


@Entity
@Name("article")
public class Article implements Serializable
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -7865959933059425942L;


	@Id
	@GeneratedValue
    private Long idArticle;


	@NotNull
	@Length(max=100)
    private String designation;

	@NotNull
	private long stockInitial;
	
	
    private String description;

    
	@NotNull
	@ManyToOne
	@JoinColumn(name="idUom")
    private UniteMesure  uniteMesure;
	
	
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="article")
    private Set<ArticleFournisseur> listeFournisseursArticles = new HashSet<ArticleFournisseur>();
	
	
	public Article() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	public Article(String designation, long stockInitial, String description,
			UniteMesure uniteMesure,
			Set<ArticleFournisseur> listeFournisseursArticles) {
		super();
		this.designation = designation;
		this.stockInitial = stockInitial;
		this.description = description;
		this.uniteMesure = uniteMesure;
		this.listeFournisseursArticles = listeFournisseursArticles;
	}

	
	public UniteMesure getUniteMesure() {
		return uniteMesure;
	}

	public void setUniteMesure(UniteMesure uniteMesure) {
		this.uniteMesure = uniteMesure;
	}

	public String getInstanceOfArticle()
	{
			String instanceType="";
		
		
			if(this instanceof Intrant)
			{
				if(this instanceof Pesticide)
				{
					instanceType="Pesticide";
				}
				else if(this instanceof Engrais)
				{
					instanceType="Engrais";
				}	
				else if(this instanceof LutteBiologique)
				{
					instanceType="Lutte Biologique";
				}
				else if(this instanceof PorteGreffe)
				{
					instanceType="Porte-greffe";
				}
				else
				{
					instanceType="Intrant";
				}
			}
			else if(this instanceof Equipement)
			{
				if(this instanceof Materiel)
				{
					instanceType="Matériel";
				}
				else if(this instanceof Outillage)
				{
					instanceType="Outillage";
				}
			}
			else if(this instanceof CaisseRamassage)
			{
				instanceType="Caisse/Palette";
			}
			
			else if(this instanceof Variete)
			{
				instanceType="Variété";
			}
			
			else if(this instanceof PorteGreffe)
			{
				instanceType="Porte-greffe";
			}
			
			else
			{
				instanceType="Autre Article";
			}
		
		return instanceType;
	}
	
	public String getDesignation() {
		return designation;
	}


	public void setDesignation(String designation) {
		this.designation = designation;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public Set<ArticleFournisseur> getListeFournisseursArticles() {
		return listeFournisseursArticles;
	}


	public void setListeFournisseursArticles(
			Set<ArticleFournisseur> listeFournisseursArticles) {
		this.listeFournisseursArticles = listeFournisseursArticles;
	}


	public Long getIdArticle() {
		return idArticle;
	}

	public long getStockInitial() {
		return stockInitial;
	}


	public void setStockInitial(long stockInitial) {
		this.stockInitial = stockInitial;
	}

	
	
    
 }
