
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.unitesMesure.UniteMesure;

@Entity
@Name("caisseRamassage")
@DiscriminatorValue("CaisseRamassage")
public class CaisseRamassage extends Article implements Serializable
{
	
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 6725902858529809424L;
	
	
	@NotNull
	private double poidsBrute;
	
	
	@NotNull
	private double tare;

	
	@NotNull
	@Length(max=7)
	private String caissePalette;    ////'C' : caisse , 'P' : Palette
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="caisseRamassage")
    private Set<InventaireClientCaisses> listeInventairesClientCaisses = new HashSet<InventaireClientCaisses>();
	
	
	public CaisseRamassage() {
		super();
		// TODO Auto-generated constructor stub
	}
	

	public CaisseRamassage(String designation, long stockInitial,
			String description, UniteMesure uniteMesure,
			Set<ArticleFournisseur> listeFournisseursArticles) {
		super(designation, stockInitial, description, uniteMesure,
				listeFournisseursArticles);
		// TODO Auto-generated constructor stub
	}


	public CaisseRamassage(double poidsBrute, double tare,
			String caissePalette,
			Set<InventaireClientCaisses> listeInventairesClientCaisses) {
		super();
		this.poidsBrute = poidsBrute;
		this.tare = tare;
		this.caissePalette = caissePalette;
		this.listeInventairesClientCaisses = listeInventairesClientCaisses;
	}



	public String getCaissePalette() {
		return caissePalette;
	}


	public void setCaissePalette(String caissePalette) {
		this.caissePalette = caissePalette;
	}


	public Set<InventaireClientCaisses> getListeInventairesClientCaisses() {
		return listeInventairesClientCaisses;
	}


	public void setListeInventairesClientCaisses(
			Set<InventaireClientCaisses> listeInventairesClientCaisses) {
		this.listeInventairesClientCaisses = listeInventairesClientCaisses;
	}


	public double getPoidsBrute() {
		return poidsBrute;
	}


	public void setPoidsBrute(double poidsBrute) {
		this.poidsBrute = poidsBrute;
	}


	public double getTare() {
		return tare;
	}


	public void setTare(double tare) {
		this.tare = tare;
	}

	

 }
