
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

@Entity
@Name("ciblesPesticides")
public class CiblesPesticides implements Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -3533526825244280598L;

	

	@Id
	@GeneratedValue(strategy=GenerationType.AUTO)
    private Long idCiblesPesticides;

	
	@ManyToOne
	@JoinColumn(name="idCulture")
    private Culture culture;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private Pesticide pesticide;

	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEnnemiCulture")
    private EnnemisCulture ennemisCulture;
	
	
	/*
	@ManyToOne
	@JoinColumn(name="idUom")
    private UniteMesure uniteMesure;
	*/
	
	private String uniteDose; //// choix d'un valeur parmi une liste énuméré auparavant : {g/ha, g/hl, cc/hl, cc/ha, l/ha, l/hl}
	
	
    private int dar;

	
	@Column(precision=4, scale=2)
    private BigDecimal lmr;

    
	
	@Column(precision=6, scale=2)
	private BigDecimal dose;


	public CiblesPesticides() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	

	public CiblesPesticides(Culture culture, Pesticide pesticide,
			EnnemisCulture ennemisCulture, String uniteDose, int dar,
			BigDecimal lmr, BigDecimal dose) {
		super();
		this.culture = culture;
		this.pesticide = pesticide;
		this.ennemisCulture = ennemisCulture;
		this.uniteDose = uniteDose;
		this.dar = dar;
		this.lmr = lmr;
		this.dose = dose;
	}




	public String getUniteDose() {
		return uniteDose;
	}


	public void setUniteDose(String uniteDose) {
		this.uniteDose = uniteDose;
	}


	public Culture getCulture() {
		return culture;
	}

	public void setCulture(Culture culture) {
		this.culture = culture;
	}

	public EnnemisCulture getEnnemisCulture() {
		return ennemisCulture;
	}

	public void setEnnemisCulture(EnnemisCulture ennemisCulture) {
		this.ennemisCulture = ennemisCulture;
	}

	public Pesticide getPesticide() {
		return pesticide;
	}


	public void setPesticide(Pesticide pesticide) {
		this.pesticide = pesticide;
	}


	public BigDecimal getDose() {
		return dose;
	}


	public void setDose(BigDecimal dose) {
		this.dose = dose;
	}

	
	public Long getIdCiblesPesticides() {
		return idCiblesPesticides;
	}



	public int getDar() {
		return dar;
	}



	public void setDar(int dar) {
		this.dar = dar;
	}

	public BigDecimal getLmr() {
		return lmr;
	}

	public void setLmr(BigDecimal lmr) {
		this.lmr = lmr;
	}

	
 }
