
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;



@Entity
@Name("culture")
public class Culture implements Serializable
{
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6945747267612919123L;


	@Id
	@GeneratedValue
    private Long idCulture;

	@NotNull
	@Length(max=100)
    private String designationCulture;

	
    private String description;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEspece")
	private Espece espece;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="culture")
    private Set<TypeCulture> listeTypesCultures = new HashSet<TypeCulture>();

	
	public Culture() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Culture(String designationCulture, String description,
			Espece espece, Set<TypeCulture> listeTypesCultures) {
		super();
		this.designationCulture = designationCulture;
		this.description = description;
		this.espece = espece;
		this.listeTypesCultures = listeTypesCultures;
	}

	
	public Set<TypeCulture> getListeTypesCultures() {
		return listeTypesCultures;
	}

	public void setListeTypesCultures(Set<TypeCulture> listeTypesCultures) {
		this.listeTypesCultures = listeTypesCultures;
	}

	public Long getIdCulture() {
		return idCulture;
	}


	public String getDesignationCulture() {
		return designationCulture;
	}


	public void setDesignationCulture(String designationCulture) {
		this.designationCulture = designationCulture;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public Espece getEspece() {
		return espece;
	}


	public void setEspece(Espece espece) {
		this.espece = espece;
	}
	
	
    
 }
