
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.unitesMesure.UniteMesure;



@Entity
@Name("engrais")
@DiscriminatorValue("Engrais")
public class Engrais extends Intrant implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1395377497530181733L;

	@NotNull
	@Column(precision=4, scale=2)
	private BigDecimal tauxN;

	
	@NotNull
	@Column(precision=4, scale=2)
    private BigDecimal tauxP;

	
	@NotNull
	@Column(precision=4, scale=2)
    private BigDecimal tauxK;

	
	@Column(precision=4, scale=2)
    private BigDecimal tauxMg;

	
	@Column(precision=4, scale=2)
    private BigDecimal tauxCa;

	
    @NotNull
	@Length(max=20)
	private String natureEngrais;   ////Organique , Minéral, Organo-minéral  
    
   


	public Engrais() {
		super();
		// TODO Auto-generated constructor stub
	}


	public Engrais(String designation, long stockInitial, String description,
			UniteMesure uniteMesure,
			Set<ArticleFournisseur> listeFournisseursArticles) {
		super(designation, stockInitial, description, uniteMesure,
				listeFournisseursArticles);
		// TODO Auto-generated constructor stub
	}


	public Engrais(BigDecimal tauxN, BigDecimal tauxP, BigDecimal tauxK,
			BigDecimal tauxMg, BigDecimal tauxCa, String natureEngrais) {
		super();
		this.tauxN = tauxN;
		this.tauxP = tauxP;
		this.tauxK = tauxK;
		this.tauxMg = tauxMg;
		this.tauxCa = tauxCa;
		this.natureEngrais = natureEngrais;
	}


	public BigDecimal getTauxN() {
		return tauxN;
	}


	public void setTauxN(BigDecimal tauxN) {
		this.tauxN = tauxN;
	}


	public BigDecimal getTauxP() {
		return tauxP;
	}


	public void setTauxP(BigDecimal tauxP) {
		this.tauxP = tauxP;
	}


	public BigDecimal getTauxK() {
		return tauxK;
	}


	public void setTauxK(BigDecimal tauxK) {
		this.tauxK = tauxK;
	}


	public BigDecimal getTauxMg() {
		return tauxMg;
	}


	public void setTauxMg(BigDecimal tauxMg) {
		this.tauxMg = tauxMg;
	}


	public BigDecimal getTauxCa() {
		return tauxCa;
	}


	public void setTauxCa(BigDecimal tauxCa) {
		this.tauxCa = tauxCa;
	}


	public String getNatureEngrais() {
		return natureEngrais;
	}


	public void setNatureEngrais(String natureEngrais) {
		this.natureEngrais = natureEngrais;
	}
	
	


	
 }
