
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.unitesMesure.UniteMesure;


@Entity
@Name("equipement")
@DiscriminatorValue("Equipement")
public class Equipement extends Article implements Serializable
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 543234592028721342L;


	@Length(max=10)
	private String numeroEquipement;
	
	
	
	@ManyToOne
	@JoinColumn(name="idTypeEquipement")
	private TypeEquipement typeEquipement;

	
	
	@ManyToOne
	@JoinColumn(name="idMarquesEquipement")
	private MarqueEquipement marqueEquipement;



	public Equipement() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Equipement(String designation, long stockInitial,
			String description, UniteMesure uniteMesure,
			Set<ArticleFournisseur> listeFournisseursArticles) {
		super(designation, stockInitial, description, uniteMesure,
				listeFournisseursArticles);
		// TODO Auto-generated constructor stub
	}


	public Equipement(String numeroEquipement, TypeEquipement typeEquipement,
			MarqueEquipement marqueEquipement) {
		super();
		this.numeroEquipement = numeroEquipement;
		this.typeEquipement = typeEquipement;
		this.marqueEquipement = marqueEquipement;
	}



	public String getNumeroEquipement() {
		return numeroEquipement;
	}



	public void setNumeroEquipement(String numeroEquipement) {
		this.numeroEquipement = numeroEquipement;
	}



	public TypeEquipement getTypeEquipement() {
		return typeEquipement;
	}



	public void setTypeEquipement(TypeEquipement typeEquipement) {
		this.typeEquipement = typeEquipement;
	}



	public MarqueEquipement getMarqueEquipement() {
		return marqueEquipement;
	}



	public void setMarqueEquipement(MarqueEquipement marqueEquipement) {
		this.marqueEquipement = marqueEquipement;
	}
	
 }
