
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;



@Entity
@Name("espece")
public class Espece implements Serializable
{
	


	/**
	 * 
	 */
	private static final long serialVersionUID = -8807048363059575751L;


	@Id
	@GeneratedValue
    private Long idEspece;

	
	@NotNull
	@Length(max=100)
    private String designationEspece;

	
    private String description;


	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="espece")
    private Set<Culture> listeCultures = new HashSet<Culture>();
	
	
	
	public Espece() {
		super();
		// TODO Auto-generated constructor stub
	}


	public Espece(String designationEspece, String description,
			Set<Culture> listeCultures) {
		super();
		this.designationEspece = designationEspece;
		this.description = description;
		this.listeCultures = listeCultures;
	}


	public String getDesignationEspece() {
		return designationEspece;
	}


	public void setDesignationEspece(String designationEspece) {
		this.designationEspece = designationEspece;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public Long getIdEspece() {
		return idEspece;
	}


	public Set<Culture> getListeCultures() {
		return listeCultures;
	}


	public void setListeCultures(Set<Culture> listeCultures) {
		this.listeCultures = listeCultures;
	}
	
	

    
 }
