

package com.agritrace.entity.articles;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.entrepots.Entrepot;



@Entity
@Name("inventaire")
public class Inventaire implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -3705062175910294539L;


	@Id
	@GeneratedValue
	private Long idInventaire;

	
	@NotNull
	@Length(max=30)
    private String numeroInventaire;
	
	
	@NotNull
	@Column(precision=11, scale=2)
    private BigDecimal quantiteStock;
	
	
	@NotNull
	@Temporal(TemporalType.DATE)
	private Date dateInventaire;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private Entrepot entrepot;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private Article article;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;
	
    @NotNull
    @ManyToOne 
    @JoinColumn(name="idDomaine")
    private Domaine domaine;
    
	
	private String commentaire;
	
	
	public Inventaire() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	public Inventaire(String numeroInventaire, BigDecimal quantiteStock,
			Date dateInventaire, Entrepot entrepot, Article article,
			Campagne campagne, Domaine domaine, String commentaire) {
		super();
		this.numeroInventaire = numeroInventaire;
		this.quantiteStock = quantiteStock;
		this.dateInventaire = dateInventaire;
		this.entrepot = entrepot;
		this.article = article;
		this.campagne = campagne;
		this.domaine = domaine;
		this.commentaire = commentaire;
	}


	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}

	public Campagne getCampagne() {
		return campagne;
	}


	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}


	public Entrepot getEntrepot() {
		return entrepot;
	}


	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}


	public String getNumeroInventaire() {
		return numeroInventaire;
	}


	public void setNumeroInventaire(String numeroInventaire) {
		this.numeroInventaire = numeroInventaire;
	}


	public BigDecimal getQuantiteStock() {
		return quantiteStock;
	}


	public void setQuantiteStock(BigDecimal quantiteStock) {
		this.quantiteStock = quantiteStock;
	}


	public Date getDateInventaire() {
		return dateInventaire;
	}


	public void setDateInventaire(Date dateInventaire) {
		this.dateInventaire = dateInventaire;
	}


	public String getCommentaire() {
		return commentaire;
	}


	public void setCommentaire(String commentaire) {
		this.commentaire = commentaire;
	}


	public Article getArticle() {
		return article;
	}


	public void setArticle(Article article) {
		this.article = article;
	}


	public Long getIdInventaire() {
		return idInventaire;
	}

 }
