
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Client;


@Entity
@Name("inventaireClientCaisses")
public class InventaireClientCaisses implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 2916269098793742086L;


	@Id
	@GeneratedValue
    private Long idInventaireClientCaisses;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
    private Client client;

	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private CaisseRamassage caisseRamassage;

	
	@NotNull
	private long qtiteARemettre;
	
	
	@NotNull
	@Temporal(TemporalType.DATE)
	private Date dateInventaire;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;

    @NotNull
    @ManyToOne 
    @JoinColumn(name="idDomaine")
    private Domaine domaine;
    
    
	public InventaireClientCaisses() {
		super();
		// TODO Auto-generated constructor stub
	}

	public InventaireClientCaisses(Client client,
			CaisseRamassage caisseRamassage, long qtiteARemettre,
			Date dateInventaire, Campagne campagne, Domaine domaine) {
		super();
		this.client = client;
		this.caisseRamassage = caisseRamassage;
		this.qtiteARemettre = qtiteARemettre;
		this.dateInventaire = dateInventaire;
		this.campagne = campagne;
		this.domaine = domaine;
	}

	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}

	public Campagne getCampagne() {
		return campagne;
	}

	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}

	public Client getClient() {
		return client;
	}


	public void setClient(Client client) {
		this.client = client;
	}


	public CaisseRamassage getCaisseRamassage() {
		return caisseRamassage;
	}


	public void setCaisseRamassage(CaisseRamassage caisseRamassage) {
		this.caisseRamassage = caisseRamassage;
	}


	public long getQtiteARemettre() {
		return qtiteARemettre;
	}


	public void setQtiteARemettre(long qtiteARemettre) {
		this.qtiteARemettre = qtiteARemettre;
	}


	public Date getDateInventaire() {
		return dateInventaire;
	}


	public void setDateInventaire(Date dateInventaire) {
		this.dateInventaire = dateInventaire;
	}


	public Long getIdInventaireClientCaisses() {
		return idInventaireClientCaisses;
	}
	

 }
