
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.unitesMesure.UniteMesure;



@Entity
@Name("pesticide")
@DiscriminatorValue("Pesticide")
public class Pesticide extends Intrant implements Serializable 
{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 8126638923608258802L;


	@NotNull
	@Length(max=20)
    private String typePesticide;
	

	@NotNull
	@Length(max=50)
    private String matiereActive;
	
	
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="pesticide")
    private Set<CiblesPesticides> listeCiblesPesticides = new HashSet<CiblesPesticides>();

    
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="pesticide")
    private Set<CompatibiliteLutteBiologique> listeCompatibiliteLutteBio =  new HashSet<CompatibiliteLutteBiologique>();
    

	public Pesticide() {
		super();
		// TODO Auto-generated constructor stub
	}
	

	public Pesticide(String designation, long stockInitial, String description,
			UniteMesure uniteMesure,
			Set<ArticleFournisseur> listeFournisseursArticles) {
		super(designation, stockInitial, description, uniteMesure,
				listeFournisseursArticles);
		// TODO Auto-generated constructor stub
	}

	

	public Pesticide(String typePesticide, String matiereActive,
			Set<CiblesPesticides> listeCiblesPesticides,
			Set<CompatibiliteLutteBiologique> listeCompatibiliteLutteBio) {
		super();
		this.typePesticide = typePesticide;
		this.matiereActive = matiereActive;
		this.listeCiblesPesticides = listeCiblesPesticides;
		this.listeCompatibiliteLutteBio = listeCompatibiliteLutteBio;
	}


	public String getTypePesticide() {
		return typePesticide;
	}


	public void setTypePesticide(String typePesticide) {
		this.typePesticide = typePesticide;
	}


	public String getMatiereActive() {
		return matiereActive;
	}


	public void setMatiereActive(String matiereActive) {
		this.matiereActive = matiereActive;
	}


	public Set<CiblesPesticides> getListeCiblesPesticides() {
		return listeCiblesPesticides;
	}


	public void setListeCiblesPesticides(Set<CiblesPesticides> listeCiblesPesticides) {
		this.listeCiblesPesticides = listeCiblesPesticides;
	}


	public Set<CompatibiliteLutteBiologique> getListeCompatibiliteLutteBio() {
		return listeCompatibiliteLutteBio;
	}


	public void setListeCompatibiliteLutteBio(
			Set<CompatibiliteLutteBiologique> listeCompatibiliteLutteBio) {
		this.listeCompatibiliteLutteBio = listeCompatibiliteLutteBio;
	}
    
 }
