package com.agritrace.entity.articles;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;


@Entity
public class TypeCulture {
	
	@Version
	private Integer version;
	
	@Id
	@GeneratedValue
    private Long idTypeCulture;

	@NotNull
	@Length(max=50)
    private String typeCulture;

	
    private String description;
	
    
    @NotNull
    @ManyToOne
    @JoinColumn(name="idCulture")
    private Culture culture;

    
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="typeCulture")
    private Set<Variete> listeVarietes = new HashSet<Variete>();


	public TypeCulture() {
		super();
		// TODO Auto-generated constructor stub
	}


	public TypeCulture(String typeCulture, String description, Culture culture,
			Set<Variete> listeVarietes) {
		super();
		this.typeCulture = typeCulture;
		this.description = description;
		this.culture = culture;
		this.listeVarietes = listeVarietes;
	}

	public Integer getVersion() {
		return version;
	}


	public void setVersion(Integer version) {
		this.version = version;
	}


	public String getTypeCulture() {
		return typeCulture;
	}


	public void setTypeCulture(String typeCulture) {
		this.typeCulture = typeCulture;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public Culture getCulture() {
		return culture;
	}


	public void setCulture(Culture culture) {
		this.culture = culture;
	}


	public Set<Variete> getListeVarietes() {
		return listeVarietes;
	}


	public void setListeVarietes(Set<Variete> listeVarietes) {
		this.listeVarietes = listeVarietes;
	}


	public Long getIdTypeCulture() {
		return idTypeCulture;
	}

}
