
package com.agritrace.entity.articles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;
import com.agritrace.entity.unitesMesure.UniteMesure;


@Entity
@Name("variete")
@DiscriminatorValue("Variete")
public class Variete extends Article implements Serializable { 

	
	/**
	 * 
	 */
	private static final long serialVersionUID = -8591453726535145486L;
	

	@NotNull
	private int tauxN;
	
	@NotNull
	private int tauxP;
	
	@NotNull
	private int tauxK;
	
	private int tauxMg;
	
	private int tauxCa;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTypeCulture")
	private TypeCulture typeCulture;

	
	@Lob
	@Column(length=214783647)
	@Basic(fetch=FetchType.LAZY)
	private byte[] photoVariete;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="variete")
    private Set<PorteGreffe> listePortesGreffe = new HashSet<PorteGreffe>();
	
	
	@Transient
	private String culture;
	
	
	public Variete() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	public Variete(String designation, long stockInitial, String description,
			UniteMesure uniteMesure,
			Set<ArticleFournisseur> listeFournisseursArticles) {
		super(designation, stockInitial, description, uniteMesure,
				listeFournisseursArticles);
		// TODO Auto-generated constructor stub
	}

	public Variete(TypeCulture typeCulture, byte[] photoVariete, int tauxN,
			int tauxP, int tauxK, int tauxMg, int tauxCa,
			Set<PorteGreffe> listePortesGreffe) {
		super();
		this.typeCulture = typeCulture;
		this.photoVariete = photoVariete;
		this.tauxN = tauxN;
		this.tauxP = tauxP;
		this.tauxK = tauxK;
		this.tauxMg = tauxMg;
		this.tauxCa = tauxCa;
		this.listePortesGreffe = listePortesGreffe;
	}

	

	public String getCulture() {
		return culture;
	}


	public void setCulture(String culture) {
		this.culture = culture;
	}


	public Set<PorteGreffe> getListePortesGreffe() {
		return listePortesGreffe;
	}


	public void setListePortesGreffe(Set<PorteGreffe> listePortesGreffe) {
		this.listePortesGreffe = listePortesGreffe;
	}

	
	public TypeCulture getTypeCulture() {
		return typeCulture;
	}


	public void setTypeCulture(TypeCulture typeCulture) {
		this.typeCulture = typeCulture;
	}


	public byte[] getPhotoVariete() {
		return photoVariete;
	}


	public void setPhotoVariete(byte[] photoVariete) {
		this.photoVariete = photoVariete;
	}


	public int getTauxN() {
		return tauxN;
	}


	public void setTauxN(int tauxN) {
		this.tauxN = tauxN;
	}


	public int getTauxP() {
		return tauxP;
	}


	public void setTauxP(int tauxP) {
		this.tauxP = tauxP;
	}


	public int getTauxK() {
		return tauxK;
	}


	public void setTauxK(int tauxK) {
		this.tauxK = tauxK;
	}


	public int getTauxMg() {
		return tauxMg;
	}


	public void setTauxMg(int tauxMg) {
		this.tauxMg = tauxMg;
	}


	public int getTauxCa() {
		return tauxCa;
	}


	public void setTauxCa(int tauxCa) {
		this.tauxCa = tauxCa;
	}


 }
