
package com.agritrace.entity.convention;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.hibernate.validator.Past;
import org.jboss.seam.annotations.Name;


@Entity
@Name("campagne")
public class Campagne implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 8223089705496676740L;


	@Id
	@GeneratedValue
    private Long idCampagne;

	
	@NotNull
	@Length(max=20)
    private String campagne;

	
	@NotNull
	@Past
	@Temporal(TemporalType.DATE)
    private Date dateDebut;


	@Temporal(TemporalType.DATE)
    private Date dateFin;

	
    private String description;

    
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="campagne")
    private Set<Semaine> listeSemaines = new java.util.HashSet<Semaine>();
    
	public Campagne() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Campagne(String campagne, Date dateDebut, Date dateFin,
			String description, Set<Semaine> listeSemaines) {
		super();
		this.campagne = campagne;
		this.dateDebut = dateDebut;
		this.dateFin = dateFin;
		this.description = description;
		this.listeSemaines = listeSemaines;
	}
	
	public Set<Semaine> getListeSemaines() {
		return listeSemaines;
	}

	public void setListeSemaines(Set<Semaine> listeSemaines) {
		this.listeSemaines = listeSemaines;
	}

	public String getCampagne() {
		return campagne;
	}


	public void setCampagne(String campagne) {
		this.campagne = campagne;
	}


	public Date getDateDebut() {
		return dateDebut;
	}


	public void setDateDebut(Date dateDebut) {
		this.dateDebut = dateDebut;
	}


	public Date getDateFin() {
		return dateFin;
	}


	public void setDateFin(Date dateFin) {
		this.dateFin = dateFin;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public Long getIdCampagne() {
		return idCampagne;
	}


 }
