
package com.agritrace.entity.convention;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Client;



@Entity
@Name("convention")
public class Convention implements Serializable
{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 3140372499371081828L;

	@Id
	@GeneratedValue
    private Long idConvention;

	@NotNull
	@Length(max=30)
    private String numeroConvention;

	@NotNull
	@Temporal(TemporalType.DATE)
    private Date dateConvention;


	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
    private Client client;
	
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="convention")
    private Set<LignesConvention> lignesConvention = new java.util.HashSet<LignesConvention>();
	
	
	
	public Convention() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Convention(String numeroConvention, Date dateConvention,
			Campagne campagne, Domaine domaine, Client client,
			Set<LignesConvention> lignesConvention) {
		super();
		this.numeroConvention = numeroConvention;
		this.dateConvention = dateConvention;
		this.campagne = campagne;
		this.domaine = domaine;
		this.client = client;
		this.lignesConvention = lignesConvention;
	}


	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}

	public Long getIdConvention() {
		return idConvention;
	}


	public void setIdConvention(Long idConvention) {
		this.idConvention = idConvention;
	}


	public String getNumeroConvention() {
		return numeroConvention;
	}


	public void setNumeroConvention(String numeroConvention) {
		this.numeroConvention = numeroConvention;
	}


	public Date getDateConvention() {
		return dateConvention;
	}


	public void setDateConvention(Date dateConvention) {
		this.dateConvention = dateConvention;
	}


	public Set<LignesConvention> getLignesConvention() {
		return lignesConvention;
	}


	public void setLignesConvention(Set<LignesConvention> lignesConvention) {
		this.lignesConvention = lignesConvention;
	}


	public Campagne getCampagne() {
		return campagne;
	}


	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}


	public Client getClient() {
		return client;
	}


	public void setClient(Client client) {
		this.client = client;
	}

	
 }
