
package com.agritrace.entity.convention;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.TypeCulture;
import com.agritrace.entity.devise.Devise;




@Entity
@Name("lignesConvention")
public class LignesConvention implements Serializable{


	/**
	 * 
	 */
	private static final long serialVersionUID = 3922546742160478903L;

	
	@Id
	@GeneratedValue
	private Long idLigneConvention;
	
	
	@NotNull
    private long qtePrevue;

	
	@Column(precision=9, scale=2)
    private BigDecimal prixUnitaire;
	

	@NotNull
	@ManyToOne
	@JoinColumn(name="idDevise")
	private Devise devise;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idConvention")
	private Convention convention;
	
	
	/*
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
	private Variete variete;
	*/
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTypeCulture")
	private TypeCulture typeCulture;
	
	
	@Column(precision=9, scale=2)
    private BigDecimal avancePaimentProduit;
	 

    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="lignesConvention")
    private Set<PesticidesHomologues> listePesticidesHomologues = new java.util.HashSet<PesticidesHomologues>();
    


	public LignesConvention() {
		super();
		// TODO Auto-generated constructor stub
	}

	

	public LignesConvention(long qtePrevue, BigDecimal prixUnitaire,
			Devise devise, Convention convention, TypeCulture typeCulture,
			BigDecimal avancePaimentProduit,
			Set<PesticidesHomologues> listePesticidesHomologues) {
		super();
		this.qtePrevue = qtePrevue;
		this.prixUnitaire = prixUnitaire;
		this.devise = devise;
		this.convention = convention;
		this.typeCulture = typeCulture;
		this.avancePaimentProduit = avancePaimentProduit;
		this.listePesticidesHomologues = listePesticidesHomologues;
	}


	public TypeCulture getTypeCulture() {
		return typeCulture;
	}



	public void setTypeCulture(TypeCulture typeCulture) {
		this.typeCulture = typeCulture;
	}



	public long getQtePrevue() {
		return qtePrevue;
	}


	public void setQtePrevue(long qtePrevue) {
		this.qtePrevue = qtePrevue;
	}


	public BigDecimal getPrixUnitaire() {
		return prixUnitaire;
	}


	public void setPrixUnitaire(BigDecimal prixUnitaire) {
		this.prixUnitaire = prixUnitaire;
	}

	public Devise getDevise() {
		return devise;
	}


	public void setDevise(Devise devise) {
		this.devise = devise;
	}


	public Convention getConvention() {
		return convention;
	}


	public void setConvention(Convention convention) {
		this.convention = convention;
	}


	public BigDecimal getAvancePaimentProduit() {
		return avancePaimentProduit;
	}


	public void setAvancePaimentProduit(BigDecimal avancePaimentProduit) {
		this.avancePaimentProduit = avancePaimentProduit;
	}


	public Set<PesticidesHomologues> getListePesticidesHomologues() {
		return listePesticidesHomologues;
	}


	public void setListePesticidesHomologues(
			Set<PesticidesHomologues> listePesticidesHomologues) {
		this.listePesticidesHomologues = listePesticidesHomologues;
	}

	public Long getIdLigneConvention() {
		return idLigneConvention;
	}
	
	
 }
