
package com.agritrace.entity.convention;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.Pesticide;



@Entity
@Name("pesticidesHomologues")
public class PesticidesHomologues implements Serializable
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 7185478243426668167L;


	@Id
	@GeneratedValue
    private Long idHomologation;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idLigneConvention")
	private LignesConvention lignesConvention;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
	private Pesticide pesticide;
	
	
	@Length(max=20)
    private String numeroHomologation;
	
	
	@NotNull
    private int dar;

	
	@NotNull
	@Column(precision=4, scale=2)
    private BigDecimal lmr;

    
	@Column(precision=6, scale=2)
	private BigDecimal dose;


	/*
	@NotNull
	@ManyToOne
	@JoinColumn(name="idUom")
    private UniteMesure uniteMesure;
	*/
	

	private String uniteDose; //// choix d'un valeur parmi une liste énuméré auparavant : {g/ha, g/hl, cc/hl, cc/ha, l/ha, l/hl}


	public PesticidesHomologues() {
		super();
		// TODO Auto-generated constructor stub
	}


	public PesticidesHomologues(LignesConvention lignesConvention,
			Pesticide pesticide, String numeroHomologation, int dar,
			BigDecimal lmr, BigDecimal dose, String uniteDose) {
		super();
		this.lignesConvention = lignesConvention;
		this.pesticide = pesticide;
		this.numeroHomologation = numeroHomologation;
		this.dar = dar;
		this.lmr = lmr;
		this.dose = dose;
		this.uniteDose = uniteDose;
	}


	public String getUniteDose() {
		return uniteDose;
	}


	public void setUniteDose(String uniteDose) {
		this.uniteDose = uniteDose;
	}


	public int getDar() {
		return dar;
	}


	public void setDar(int dar) {
		this.dar = dar;
	}


	public BigDecimal getLmr() {
		return lmr;
	}


	public void setLmr(BigDecimal lmr) {
		this.lmr = lmr;
	}


	public BigDecimal getDose() {
		return dose;
	}


	public void setDose(BigDecimal dose) {
		this.dose = dose;
	}


	public String getNumeroHomologation() {
		return numeroHomologation;
	}


	public void setNumeroHomologation(String numeroHomologation) {
		this.numeroHomologation = numeroHomologation;
	}


	public LignesConvention getLignesConvention() {
		return lignesConvention;
	}


	public void setLignesConvention(LignesConvention lignesConvention) {
		this.lignesConvention = lignesConvention;
	}


	public Pesticide getPesticide() {
		return pesticide;
	}


	public void setPesticide(Pesticide pesticide) {
		this.pesticide = pesticide;
	}


	public Long getIdHomologation() {
		return idHomologation;
	}


}
