
package com.agritrace.entity.convention;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;


@Entity
@Name("semaine")
public class Semaine implements Serializable{


	/**
	 * 
	 */
	private static final long serialVersionUID = 9092322341007112740L;
	
	

	@Id
	@GeneratedValue
    private Long idSemaine;

	@NotNull
    private String numeroSemaine;
	

    @NotNull
    @Temporal(TemporalType.DATE)
    private Date semaineDu;
    
    
    @NotNull
    @Temporal(TemporalType.DATE)
    private Date semaineAu;

    @ManyToOne
    @JoinColumn(name="idCampagne")
    private Campagne campagne;

	public Semaine() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Semaine(String numeroSemaine, Date semaineDu, Date semaineAu,
			Campagne campagne) {
		super();
		this.numeroSemaine = numeroSemaine;
		this.semaineDu = semaineDu;
		this.semaineAu = semaineAu;
		this.campagne = campagne;
	}



	public Campagne getCampagne() {
		return campagne;
	}

	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}


	public String getNumeroSemaine() {
		return numeroSemaine;
	}

	public void setNumeroSemaine(String numeroSemaine) {
		this.numeroSemaine = numeroSemaine;
	}

	public Date getSemaineDu() {
		return semaineDu;
	}


	public void setSemaineDu(Date semaineDu) {
		this.semaineDu = semaineDu;
	}


	public Date getSemaineAu() {
		return semaineAu;
	}


	public void setSemaineAu(Date semaineAu) {
		this.semaineAu = semaineAu;
	}


	public Long getIdSemaine() {
		return idSemaine;
	}

 }
