
package com.agritrace.entity.domaine;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;


@Entity
@Name("certificationsDomaine")
public class CertificationsDomaine implements Serializable{


	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6564717113687082752L;

	
	@Id
	@GeneratedValue
	private int idCertificationsDomaine;
	
	
	@NotNull
	@Length(max=4)
    private String anneeObtention;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;


	@NotNull
	@ManyToOne
	@JoinColumn(name="idCertification")
	private Certification certification;


	public CertificationsDomaine() {
		super();
		// TODO Auto-generated constructor stub
	}


	public CertificationsDomaine(String anneeObtention, Domaine domaine,
			Certification certification) {
		super();
		this.anneeObtention = anneeObtention;
		this.domaine = domaine;
		this.certification = certification;
	}


	public String getAnneeObtention() {
		return anneeObtention;
	}


	public void setAnneeObtention(String anneeObtention) {
		this.anneeObtention = anneeObtention;
	}


	public Domaine getDomaine() {
		return domaine;
	}


	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}


	public Certification getCertification() {
		return certification;
	}


	public void setCertification(Certification certification) {
		this.certification = certification;
	}


	public static long getSerialversionuid() {
		return serialVersionUID;
	}


	public int getIdCertificationsDomaine() {
		return idCertificationsDomaine;
	}

	
 }
