
package com.agritrace.entity.domaine;

import java.io.Serializable;

import javax.persistence.*;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

@Entity
@Name("chateauEau")
public class ChateauEau implements Serializable 
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1805695491903407936L;


	@Id
	@GeneratedValue	
    private Long idChateauEau;
	

    @NotNull
    @Length(max=10)
    private String numeroChateauEau;
    

    @NotNull
    @ManyToOne 
    @JoinColumn(name="idDomaine")
    private Domaine domaine;
    
    
    private String description;


	public ChateauEau() {
		super();
		// TODO Auto-generated constructor stub
	}


	public ChateauEau(String numeroChateauEau, Domaine domaine,
			String description) {
		super();
		this.numeroChateauEau = numeroChateauEau;
		this.domaine = domaine;
		this.description = description;
	}


	public String getNumeroChateauEau() {
		return numeroChateauEau;
	}


	public void setNumeroChateauEau(String numeroChateauEau) {
		this.numeroChateauEau = numeroChateauEau;
	}


	public Domaine getDomaine() {
		return domaine;
	}


	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public Long getIdChateauEau() {
		return idChateauEau;
	}

    
 }
