
package com.agritrace.entity.domaine;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

@Entity
@Name("parcelle")
public class Parcelle implements Serializable {



	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1174180602909712154L;


	@Id
	@GeneratedValue	
    private Long idParcelle;

	
    @NotNull
    @Length(max=20)
    private String numeroParcelle;

    
    @NotNull
    private double surface;

    
    @NotNull
	@Length(max=20)
    private String referencesCadastrale;

    
    @ManyToOne 
    @JoinColumn(name="idTypeParcelle")
    private TypeParcelle typeParcelle;
    
    
    @ManyToOne 
    @JoinColumn(name="idSecteur")
    private Secteur secteur;
    
    
    @NotNull
    @ManyToOne 
    @JoinColumn(name="idDomaine")
    private Domaine domaine;
    
    
    @ManyToOne 
    @JoinColumn(name="idTypeIrrigation")
    private TypeIrrigation typeIrrigation;
    
    
    public Parcelle() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Parcelle(String numeroParcelle, double surface,
			String referencesCadastrale, TypeParcelle typeParcelle,
			Secteur secteur, Domaine domaine, TypeIrrigation typeIrrigation) {
		super();
		this.numeroParcelle = numeroParcelle;
		this.surface = surface;
		this.referencesCadastrale = referencesCadastrale;
		this.typeParcelle = typeParcelle;
		this.secteur = secteur;
		this.domaine = domaine;
		this.typeIrrigation = typeIrrigation;
	}

	
	public double getSurface() {
		return surface;
	}

	public void setSurface(double surface) {
		this.surface = surface;
	}

	public TypeIrrigation getTypeIrrigation() {
		return typeIrrigation;
	}

	public void setTypeIrrigation(TypeIrrigation typeIrrigation) {
		this.typeIrrigation = typeIrrigation;
	}

	public String getNumeroParcelle() {
		return numeroParcelle;
	}


	public void setNumeroParcelle(String numeroParcelle) {
		this.numeroParcelle = numeroParcelle;
	}

	
	public String getReferencesCadastrale() {
		return referencesCadastrale;
	}


	public void setReferencesCadastrale(String referencesCadastrale) {
		this.referencesCadastrale = referencesCadastrale;
	}


	public TypeParcelle getTypeParcelle() {
		return typeParcelle;
	}


	public void setTypeParcelle(TypeParcelle typeParcelle) {
		this.typeParcelle = typeParcelle;
	}


	public Secteur getSecteur() {
		return secteur;
	}


	public void setSecteur(Secteur secteur) {
		this.secteur = secteur;
	}


	public Domaine getDomaine() {
		return domaine;
	}


	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}


	public Long getIdParcelle() {
		return idParcelle;
	}

	
 }
