
package com.agritrace.entity.entrepots;

import java.io.*;
import javax.persistence.*;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;



@Entity
@Name("emplacement")
public class Emplacement implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 6148064639511184157L;


	@Id
    @GeneratedValue
    private Long idEmplacement;
     

	@NotNull
	@Length(max=20)
	private String numeroEmplacement;
	
	
	@NotNull
    private int range;

	@NotNull
	private int allee;

	@NotNull
    private int niveau;


    
    @NotNull
    @ManyToOne 
    @JoinColumn(name="idEntrepot")
    private Entrepot entrepot;



	public Emplacement() {
		super();
		// TODO Auto-generated constructor stub
	}



	public Emplacement(String numeroEmplacement, int range, int allee,
			int niveau, Entrepot entrepot) {
		super();
		this.numeroEmplacement = numeroEmplacement;
		this.range = range;
		this.allee = allee;
		this.niveau = niveau;
		this.entrepot = entrepot;
	}



	public String getNumeroEmplacement() {
		return numeroEmplacement;
	}



	public void setNumeroEmplacement(String numeroEmplacement) {
		this.numeroEmplacement = numeroEmplacement;
	}



	public int getRange() {
		return range;
	}



	public void setRange(int range) {
		this.range = range;
	}



	public int getAllee() {
		return allee;
	}



	public void setAllee(int allee) {
		this.allee = allee;
	}



	public int getNiveau() {
		return niveau;
	}



	public void setNiveau(int niveau) {
		this.niveau = niveau;
	}



	public Entrepot getEntrepot() {
		return entrepot;
	}



	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}



	public Long getIdEmplacement() {
		return idEmplacement;
	}

   
 }
