
package com.agritrace.entity.entrepots;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;

@Entity
@Name("entrepot")
public class Entrepot implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -6525749686680723904L;

	
	@Id
    @GeneratedValue
    private Long idEntrepot;
	
	
	@NotNull
	@Length(max=10)
	private String numeroEntrepot;
	 

    @NotNull
    @Length(max=30)
    private String denomination;

    
    @NotNull
    @Length(max=40)
    private String typeEntreport;   ///Exemple : "Dépot pesticide, engrais, outillage...etc"
    
    
    @Column(precision=6, scale=1)
    private BigDecimal superficieTotal;

    
    @NotNull
    @ManyToOne 
    @JoinColumn(name="idDomaine")
    private Domaine domaine;
    
    
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="entrepot")
    private Set<Emplacement> listeEmplacements = new HashSet<Emplacement>();


	public Entrepot() {
		super();
		// TODO Auto-generated constructor stub
	}


	public Entrepot(String numeroEntrepot, String denomination,
			String typeEntreport, BigDecimal superficieTotal, Domaine domaine,
			Set<Emplacement> listeEmplacements) {
		super();
		this.numeroEntrepot = numeroEntrepot;
		this.denomination = denomination;
		this.typeEntreport = typeEntreport;
		this.superficieTotal = superficieTotal;
		this.domaine = domaine;
		this.listeEmplacements = listeEmplacements;
	}


	public String getNumeroEntrepot() {
		return numeroEntrepot;
	}


	public void setNumeroEntrepot(String numeroEntrepot) {
		this.numeroEntrepot = numeroEntrepot;
	}


	public String getDenomination() {
		return denomination;
	}


	public void setDenomination(String denomination) {
		this.denomination = denomination;
	}


	public String getTypeEntreport() {
		return typeEntreport;
	}


	public void setTypeEntreport(String typeEntreport) {
		this.typeEntreport = typeEntreport;
	}


	public BigDecimal getSuperficieTotal() {
		return superficieTotal;
	}


	public void setSuperficieTotal(BigDecimal superficieTotal) {
		this.superficieTotal = superficieTotal;
	}


	public Domaine getDomaine() {
		return domaine;
	}


	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}


	public Set<Emplacement> getListeEmplacements() {
		return listeEmplacements;
	}


	public void setListeEmplacements(Set<Emplacement> listeEmplacements) {
		this.listeEmplacements = listeEmplacements;
	}


	public Long getIdEntrepot() {
		return idEntrepot;
	}
    
 }
