
package com.agritrace.entity.entrepots;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.Article;
import com.agritrace.entity.entrepots.Entrepot;


@Entity
@Name("ligneMouvementInterEntrepots")
public class LigneMouvementInterEntrepots implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 5515857201606806318L;


	@Id
	@GeneratedValue
	private Long idLigneMouvementInterEntrepots;
	
	
	@ManyToOne
	@JoinColumn(name="idArticle")
    private  Article article;
	
	
	@NotNull
	private double quantiteMouvement;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idMouvementInterEntrepots")
	private MouvementInterEntrepots mouvementInterEntrepots;

	
	@NotNull
	@Length(max=30)
    private String numeroLot;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepotSource")
    private Entrepot entrepotSource;

	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepotDestination")
    private Entrepot entrepotDestination;

	
	public LigneMouvementInterEntrepots() {
		super();
		// TODO Auto-generated constructor stub
	}


	public LigneMouvementInterEntrepots(Article article,
			double quantiteMouvement,
			MouvementInterEntrepots mouvementInterEntrepots, String numeroLot,
			Entrepot entrepotSource, Entrepot entrepotDestination) {
		super();
		this.article = article;
		this.quantiteMouvement = quantiteMouvement;
		this.mouvementInterEntrepots = mouvementInterEntrepots;
		this.numeroLot = numeroLot;
		this.entrepotSource = entrepotSource;
		this.entrepotDestination = entrepotDestination;
	}


	public Article getArticle() {
		return article;
	}


	public void setArticle(Article article) {
		this.article = article;
	}


	public double getQuantiteMouvement() {
		return quantiteMouvement;
	}


	public void setQuantiteMouvement(double quantiteMouvement) {
		this.quantiteMouvement = quantiteMouvement;
	}


	public MouvementInterEntrepots getMouvementInterEntrepots() {
		return mouvementInterEntrepots;
	}


	public void setMouvementInterEntrepots(
			MouvementInterEntrepots mouvementInterEntrepots) {
		this.mouvementInterEntrepots = mouvementInterEntrepots;
	}


	public String getNumeroLot() {
		return numeroLot;
	}


	public void setNumeroLot(String numeroLot) {
		this.numeroLot = numeroLot;
	}


	public Entrepot getEntrepotSource() {
		return entrepotSource;
	}


	public void setEntrepotSource(Entrepot entrepotSource) {
		this.entrepotSource = entrepotSource;
	}


	public Entrepot getEntrepotDestination() {
		return entrepotDestination;
	}


	public void setEntrepotDestination(Entrepot entrepotDestination) {
		this.entrepotDestination = entrepotDestination;
	}


	public Long getIdLigneMouvementInterEntrepots() {
		return idLigneMouvementInterEntrepots;
	}
	
 }
