
package com.agritrace.entity.entrepots;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;

@Entity
@Name("mouvementInterEntrepots")
public class MouvementInterEntrepots implements Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 9180213620271438931L;


	@Id
	@GeneratedValue
    private Long idMouvementInterEntrepots;

	
	@NotNull
	@Length(max=20)
    private String numeroMouvementInterEntrepots;

	
	
	@NotNull
	@Temporal(TemporalType.TIMESTAMP)
    private Date dateMouvement;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;

	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
    private Domaine domaine;
	
	
	@OneToMany(cascade = {CascadeType.ALL} , fetch = FetchType.LAZY , mappedBy="mouvementInterEntrepots")
    private Set<LigneMouvementInterEntrepots> lignesMouvementInterEntrepots = new HashSet<LigneMouvementInterEntrepots>();

	

	public MouvementInterEntrepots() {
		super();
		// TODO Auto-generated constructor stub
	}

	public MouvementInterEntrepots(String numeroMouvementInterEntrepots,
			Date dateMouvement, Campagne campagne, Domaine domaine,
			Set<LigneMouvementInterEntrepots> lignesMouvementInterEntrepots) {
		super();
		this.numeroMouvementInterEntrepots = numeroMouvementInterEntrepots;
		this.dateMouvement = dateMouvement;
		this.campagne = campagne;
		this.domaine = domaine;
		this.lignesMouvementInterEntrepots = lignesMouvementInterEntrepots;
	}

	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}

	public String getNumeroMouvementInterEntrepots() {
		return numeroMouvementInterEntrepots;
	}



	public void setNumeroMouvementInterEntrepots(
			String numeroMouvementInterEntrepots) {
		this.numeroMouvementInterEntrepots = numeroMouvementInterEntrepots;
	}



	public Date getDateMouvement() {
		return dateMouvement;
	}



	public void setDateMouvement(Date dateMouvement) {
		this.dateMouvement = dateMouvement;
	}



	public Campagne getCampagne() {
		return campagne;
	}



	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}



	public Set<LigneMouvementInterEntrepots> getLignesMouvementInterEntrepots() {
		return lignesMouvementInterEntrepots;
	}



	public void setLignesMouvementInterEntrepots(
			Set<LigneMouvementInterEntrepots> lignesMouvementInterEntrepots) {
		this.lignesMouvementInterEntrepots = lignesMouvementInterEntrepots;
	}



	public Long getIdMouvementInterEntrepots() {
		return idMouvementInterEntrepots;
	}

 }
