
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.CaisseRamassage;
import com.agritrace.entity.entrepots.Entrepot;


@Entity
@Name("caissesRamassageLivraison")
public class CaissesRamassageLivraison implements Serializable {

	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1166188604443709674L;
	
	
	@Id
	@GeneratedValue
	private Long idCaissesRamassageLivraison;
	
	
	@NotNull
	private int qteCaisses;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idLivraison")
    private Livraison livraison;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private CaisseRamassage caisseRamassage;
	

	
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private  Entrepot entrepot;

	

	public CaissesRamassageLivraison() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	public CaissesRamassageLivraison(int qteCaisses, Livraison livraison,
			CaisseRamassage caisseRamassage, Entrepot entrepot) {
		super();
		this.qteCaisses = qteCaisses;
		this.livraison = livraison;
		this.caisseRamassage = caisseRamassage;
		this.entrepot = entrepot;
	}

	public Entrepot getEntrepot() {
		return entrepot;
	}


	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}


	public int getQteCaisses() {
		return qteCaisses;
	}


	public void setQteCaisses(int qteCaisses) {
		this.qteCaisses = qteCaisses;
	}


	public Long getIdCaissesRamassageLivraison() {
		return idCaissesRamassageLivraison;
	}


	public Livraison getLivraison() {
		return livraison;
	}



	public void setLivraison(Livraison livraison) {
		this.livraison = livraison;
	}



	public CaisseRamassage getCaisseRamassage() {
		return caisseRamassage;
	}



	public void setCaisseRamassage(CaisseRamassage caisseRamassage) {
		this.caisseRamassage = caisseRamassage;
	}
	
	
 }
