package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.tiers.Client;




@Entity
@Name("detailslVentes")
public class DetailslVentes implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -959816006100959019L;
	
	@Id
	@GeneratedValue
	private Long idDetailslVentes;

	@NotNull
	@Column(precision=9, scale=2)
    private BigDecimal prixUnitaireExport;
	
	@NotNull
	@Column(precision=9, scale=2)
    private BigDecimal prixUnitaireEcart;
	
	@NotNull
    private long qteExport;
	
	@NotNull
    private long qteEcart;

	@NotNull
	@ManyToOne
	@JoinColumn(name="idLivraison")
    private Livraison livraison;
	
	@Transient
	private Client client;


	public DetailslVentes() {
		super();
		// TODO Auto-generated constructor stub
	}


	public DetailslVentes(BigDecimal prixUnitaireExport,
			BigDecimal prixUnitaireEcart, long qteExport, long qteEcart,
			Livraison livraison) {
		super();
		this.prixUnitaireExport = prixUnitaireExport;
		this.prixUnitaireEcart = prixUnitaireEcart;
		this.qteExport = qteExport;
		this.qteEcart = qteEcart;
		this.livraison = livraison;
	}

	public Livraison getLivraison() {
		return livraison;
	}


	public Client getClient() {
		return client;
	}


	public void setClient(Client client) {
		this.client = client;
	}


	public void setLivraison(Livraison livraison) {
		this.livraison = livraison;
	}


	public BigDecimal getPrixUnitaireExport() {
		return prixUnitaireExport;
	}


	public void setPrixUnitaireExport(BigDecimal prixUnitaireExport) {
		this.prixUnitaireExport = prixUnitaireExport;
	}


	public BigDecimal getPrixUnitaireEcart() {
		return prixUnitaireEcart;
	}


	public void setPrixUnitaireEcart(BigDecimal prixUnitaireEcart) {
		this.prixUnitaireEcart = prixUnitaireEcart;
	}


	public long getQteExport() {
		return qteExport;
	}


	public void setQteExport(long qteExport) {
		this.qteExport = qteExport;
	}


	public long getQteEcart() {
		return qteEcart;
	}


	public void setQteEcart(long qteEcart) {
		this.qteEcart = qteEcart;
	}

	
	public Long getIdDetailslVentes() {
		return idDetailslVentes;
	}
	
}
