
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.Article;


@Entity
@Name("ligneCommande")
public class LigneCommande implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 3761962887666236156L;


	@Id
	@GeneratedValue
	private Long idLigneCommande;
	
	
	@NotNull        
    private double qteCommandee;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCommande")
    private Commande commande;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private Article article;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="ligneCommande")
    private Set<LigneReception> listeLignesReception = new HashSet<LigneReception>();
	

	public LigneCommande() {
		super();
		// TODO Auto-generated constructor stub
	}

	public LigneCommande(double qteCommandee, Commande commande,
			Article article, Set<LigneReception> listeLignesReception) {
		super();
		this.qteCommandee = qteCommandee;
		this.commande = commande;
		this.article = article;
		this.listeLignesReception = listeLignesReception;
	}

	public double getTotalReception()
	{
		double total = 0.0;
		
		if(this.getListeLignesReception().size()>0)
		{
			for(LigneReception ligneReception : this.getListeLignesReception())
			{
				total +=ligneReception.getQteReceptionnee();
			}
			
			return total;
		}
		else
		{
			return 0.0;
		}
		
	}
	
	public double getQteCommandee() {
		return qteCommandee;
	}

	public void setQteCommandee(double qteCommandee) {
		this.qteCommandee = qteCommandee;
	}

	public Set<LigneReception> getListeLignesReception() {
		return listeLignesReception;
	}

	public void setListeLignesReception(Set<LigneReception> listeLignesReception) {
		this.listeLignesReception = listeLignesReception;
	}


	public Commande getCommande() {
		return commande;
	}


	public void setCommande(Commande commande) {
		this.commande = commande;
	}


	public Article getArticle() {
		return article;
	}


	public void setArticle(Article article) {
		this.article = article;
	}


	public Long getIdLigneCommande() {
		return idLigneCommande;
	}

 }
