
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.Article;
import com.agritrace.entity.entrepots.Entrepot;



@Entity
@Name("ligneReception")
public class LigneReception implements Serializable{


	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6202258436626883580L;

	@Id
	@GeneratedValue
	private Long idLigneReception;
	
	
	@NotNull
	private double qteReceptionnee;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idReception")
	private Reception reception;

	
	@NotNull
	@Length(max=30)
    private String numeroLotReception;
	
	
	@NotNull
    private double prixUnitaire;
	

	@ManyToOne
	@JoinColumn(name="idLigneCommande")
    private LigneCommande ligneCommande;
	
	
	@ManyToOne
	@JoinColumn(name="idArticle")
    private  Article article;
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private Entrepot entrepot;


	public LigneReception() {
		super();
		// TODO Auto-generated constructor stub
	}

	public LigneReception(double qteReceptionnee, Reception reception,
			String numeroLotReception, double prixUnitaire,
			LigneCommande ligneCommande, Article article, Entrepot entrepot) {
		super();
		this.qteReceptionnee = qteReceptionnee;
		this.reception = reception;
		this.numeroLotReception = numeroLotReception;
		this.prixUnitaire = prixUnitaire;
		this.ligneCommande = ligneCommande;
		this.article = article;
		this.entrepot = entrepot;
	}


	public Article getArticle() {
		return article;
	}

	public void setArticle(Article article) {
		this.article = article;
	}

	public double getPrixUnitaire() {
		return prixUnitaire;
	}

	public void setPrixUnitaire(double prixUnitaire) {
		this.prixUnitaire = prixUnitaire;
	}

	public Entrepot getEntrepot() {
		return entrepot;
	}

	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}

	public double getQteReceptionnee() {
		return qteReceptionnee;
	}


	public void setQteReceptionnee(double qteReceptionnee) {
		this.qteReceptionnee = qteReceptionnee;
	}


	public Long getIdLigneReception() {
		return idLigneReception;
	}


	public Reception getReception() {
		return reception;
	}


	public void setReception(Reception reception) {
		this.reception = reception;
	}


	public String getNumeroLotReception() {
		return numeroLotReception;
	}


	public void setNumeroLotReception(String numeroLotReception) {
		this.numeroLotReception = numeroLotReception;
	}


	public LigneCommande getLigneCommande() {
		return ligneCommande;
	}


	public void setLigneCommande(LigneCommande ligneCommande) {
		this.ligneCommande = ligneCommande;
	}

 }
