
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.CaisseRamassage;
import com.agritrace.entity.entrepots.Entrepot;




@Entity
@Name("ligneRetourCaisses")
public class LigneRetourCaisses implements Serializable{
	
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 3711842409273497073L;


	@Id
	@GeneratedValue
	private Long idLigneRetourCaisses;
	
	
	@NotNull
	private int qteRetournee;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idRetour")
    private RetourCaisses retourCaisses;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private CaisseRamassage caisseRamassage;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private Entrepot entrepot;


	public LigneRetourCaisses() {
		super();
		// TODO Auto-generated constructor stub
	}

	public LigneRetourCaisses(int qteRetournee, RetourCaisses retourCaisses,
			CaisseRamassage caisseRamassage, Entrepot entrepot) {
		super();
		this.qteRetournee = qteRetournee;
		this.retourCaisses = retourCaisses;
		this.caisseRamassage = caisseRamassage;
		this.entrepot = entrepot;
	}

	
	public Entrepot getEntrepot() {
		return entrepot;
	}

	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}

	public int getQteRetournee() {
		return qteRetournee;
	}


	public void setQteRetournee(int qteRetournee) {
		this.qteRetournee = qteRetournee;
	}


	public RetourCaisses getRetourCaisses() {
		return retourCaisses;
	}


	public void setRetourCaisses(RetourCaisses retourCaisses) {
		this.retourCaisses = retourCaisses;
	}


	public CaisseRamassage getCaisseRamassage() {
		return caisseRamassage;
	}


	public void setCaisseRamassage(CaisseRamassage caisseRamassage) {
		this.caisseRamassage = caisseRamassage;
	}
	
	public Long getIdLigneRetourCaisses() {
		return idLigneRetourCaisses;
	}

	
 }
