
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.entrepots.Entrepot;



@Entity
@Name("ligneRetourFournisseur")
public class LigneRetourFournisseur implements Serializable {



	/**
	 * 
	 */
	private static final long serialVersionUID = 8654624292503613897L;

	
	@Id
	@GeneratedValue
	private Long idLigneRetourFournisseur;
	
	
	@NotNull
	private double qteRetournee;
	

	@NotNull
	@ManyToOne
	@JoinColumn(name="idRetour")
	private RetourFournisseur retourFournisseur;

    
	@NotNull
	@ManyToOne
	@JoinColumn(name="idLigneReception")
	private LigneReception ligneReception;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private Entrepot entrepot;

	

	public LigneRetourFournisseur() {
		super();
		// TODO Auto-generated constructor stub
	}

	public LigneRetourFournisseur(double qteRetournee,
			RetourFournisseur retourFournisseur, LigneReception ligneReception,
			Entrepot entrepot) {
		super();
		this.qteRetournee = qteRetournee;
		this.retourFournisseur = retourFournisseur;
		this.ligneReception = ligneReception;
		this.entrepot = entrepot;
	}

	public Entrepot getEntrepot() {
		return entrepot;
	}

	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}

	public double getQteRetournee() {
		return qteRetournee;
	}


	public void setQteRetournee(double qteRetournee) {
		this.qteRetournee = qteRetournee;
	}


	public RetourFournisseur getRetourFournisseur() {
		return retourFournisseur;
	}


	public void setRetourFournisseur(RetourFournisseur retourFournisseur) {
		this.retourFournisseur = retourFournisseur;
	}


	public LigneReception getLigneReception() {
		return ligneReception;
	}


	public void setLigneReception(LigneReception ligneReception) {
		this.ligneReception = ligneReception;
	}


	public static long getSerialversionuid() {
		return serialVersionUID;
	}


	public Long getIdLigneRetourFournisseur() {
		return idLigneRetourFournisseur;
	}


 }
