
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.production.Recolte;
import com.agritrace.entity.tiers.Client;


@Entity
@Name("livraison")
public class Livraison implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4860636587298622057L;


	@Id
	@GeneratedValue
    private Long idLivraison;

	
	@NotNull
	@Length(max=30)
    private String numeroLivraison;

	
	@NotNull
	@Temporal(TemporalType.TIMESTAMP)
    private Date dateLivraison;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
    private Client client;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idRecolte")
    private Recolte recolte;
	
	
	@NotNull
	@Length(max=100)
    private String chauffeur;
	
	
	@NotNull
	@Length(max=30)
    private String matriculeCamion;

	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="livraison")
    private Set<CaissesRamassageLivraison> caissesRamassageLivraison = new HashSet<CaissesRamassageLivraison>();

	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="livraison")
    private Set<DetailslVentes> detailslVentes = new HashSet<DetailslVentes>();
	
	
	public Livraison() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Livraison(String numeroLivraison, Date dateLivraison,
			Campagne campagne, Domaine domaine, Client client, Recolte recolte,
			String chauffeur, String matriculeCamion,
			Set<CaissesRamassageLivraison> caissesRamassageLivraison,
			Set<DetailslVentes> detailslVentes) {
		super();
		this.numeroLivraison = numeroLivraison;
		this.dateLivraison = dateLivraison;
		this.campagne = campagne;
		this.domaine = domaine;
		this.client = client;
		this.recolte = recolte;
		this.chauffeur = chauffeur;
		this.matriculeCamion = matriculeCamion;
		this.caissesRamassageLivraison = caissesRamassageLivraison;
		this.detailslVentes = detailslVentes;
	}

	
	public Set<DetailslVentes> getDetailslVentes() {
		return detailslVentes;
	}

	public void setDetailslVentes(Set<DetailslVentes> detailslVentes) {
		this.detailslVentes = detailslVentes;
	}

	public Recolte getRecolte() {
		return recolte;
	}

	public void setRecolte(Recolte recolte) {
		this.recolte = recolte;
	}



	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}



	public Campagne getCampagne() {
		return campagne;
	}

	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}

	public String getNumeroLivraison() {
		return numeroLivraison;
	}



	public void setNumeroLivraison(String numeroLivraison) {
		this.numeroLivraison = numeroLivraison;
	}



	public Date getDateLivraison() {
		return dateLivraison;
	}



	public void setDateLivraison(Date dateLivraison) {
		this.dateLivraison = dateLivraison;
	}



	public Client getClient() {
		return client;
	}



	public void setClient(Client client) {
		this.client = client;
	}



	public String getChauffeur() {
		return chauffeur;
	}



	public void setChauffeur(String chauffeur) {
		this.chauffeur = chauffeur;
	}



	public String getMatriculeCamion() {
		return matriculeCamion;
	}


	public void setMatriculeCamion(String matriculeCamion) {
		this.matriculeCamion = matriculeCamion;
	}

	public Set<CaissesRamassageLivraison> getCaissesRamassageLivraison() {
		return caissesRamassageLivraison;
	}



	public void setCaissesRamassageLivraison(
			Set<CaissesRamassageLivraison> caissesRamassageLivraison) {
		this.caissesRamassageLivraison = caissesRamassageLivraison;
	}

	public Long getIdLivraison() {
		return idLivraison;
	}


 }
