
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Fournisseur;



@Entity
@Name("Reception")
public class Reception implements Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 9180213620271438931L;


	@Id
	@GeneratedValue
    private Long idReception;

	
	@NotNull
	@Length(max=20)
    private String numeroReception;

	
	@NotNull
	@Length(max=20)
    private String numeroBL;
	
	
	@NotNull
	@Temporal(TemporalType.TIMESTAMP)
    private Date dateReception;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
    private Fournisseur fournisseur;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;

	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="reception")
    private Set<LigneReception> lignesReception = new HashSet<LigneReception>();

	

	public Reception() {
		super();
		// TODO Auto-generated constructor stub
	}
	

	public Reception(String numeroReception, String numeroBL,
			Date dateReception, Fournisseur fournisseur, Campagne campagne,
			Domaine domaine, Set<LigneReception> lignesReception) {
		super();
		this.numeroReception = numeroReception;
		this.numeroBL = numeroBL;
		this.dateReception = dateReception;
		this.fournisseur = fournisseur;
		this.campagne = campagne;
		this.domaine = domaine;
		this.lignesReception = lignesReception;
	}

	public String getNumeroBL() {
		return numeroBL;
	}


	public void setNumeroBL(String numeroBL) {
		this.numeroBL = numeroBL;
	}


	public Fournisseur getFournisseur() {
		return fournisseur;
	}

	public void setFournisseur(Fournisseur fournisseur) {
		this.fournisseur = fournisseur;
	}

	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}



	public Campagne getCampagne() {
		return campagne;
	}

	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}

	public String getNumeroReception() {
		return numeroReception;
	}



	public void setNumeroReception(String numeroReception) {
		this.numeroReception = numeroReception;
	}



	public Date getDateReception() {
		return dateReception;
	}



	public void setDateReception(Date dateReception) {
		this.dateReception = dateReception;
	}



	public Set<LigneReception> getLignesReception() {
		return lignesReception;
	}



	public void setLignesReception(Set<LigneReception> lignesReception) {
		this.lignesReception = lignesReception;
	}



	public Long getIdReception() {
		return idReception;
	}

 }
