
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;




@Entity
@Name("retour")
public class Retour implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -6696252932658932114L;


	@Id
	@GeneratedValue
    private Long idRetour;


	@NotNull
	@Length(max=20)
    private String numeroRetour;

	
	@NotNull
	@Temporal(TemporalType.TIMESTAMP)
    private Date dateRetour;

	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
    private Campagne campagne;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;
	
	
	public Retour() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Retour(String numeroRetour, Date dateRetour, Campagne campagne,
			Domaine domaine) {
		super();
		this.numeroRetour = numeroRetour;
		this.dateRetour = dateRetour;
		this.campagne = campagne;
		this.domaine = domaine;
	}

	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}

	public Campagne getCampagne() {
		return campagne;
	}



	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}



	public String getNumeroRetour() {
		return numeroRetour;
	}



	public void setNumeroRetour(String numeroRetour) {
		this.numeroRetour = numeroRetour;
	}



	public Date getDateRetour() {
		return dateRetour;
	}



	public void setDateRetour(Date dateRetour) {
		this.dateRetour = dateRetour;
	}



	public Long getIdRetour() {
		return idRetour;
	}


 }
