
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Client;



@Entity
@Name("retourCaisses")
@DiscriminatorValue("RetourCaisses")
public class RetourCaisses extends Retour implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1062872268606839911L;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
    private Client client;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="retourCaisses")
	private Set<LigneRetourCaisses> lignesRetourCaisses = new HashSet<LigneRetourCaisses>();

	

	public RetourCaisses() {
		super();
		// TODO Auto-generated constructor stub
	}


	public RetourCaisses(String numeroRetour, Date dateRetour,
			Campagne campagne, Domaine domaine) {
		super(numeroRetour, dateRetour, campagne, domaine);
		// TODO Auto-generated constructor stub
	}


	public RetourCaisses(Client client,
			Set<LigneRetourCaisses> lignesRetourCaisses) {
		super();
		this.client = client;
		this.lignesRetourCaisses = lignesRetourCaisses;
	}


	public Client getClient() {
		return client;
	}


	public void setClient(Client client) {
		this.client = client;
	}


	public Set<LigneRetourCaisses> getLignesRetourCaisses() {
		return lignesRetourCaisses;
	}


	public void setLignesRetourCaisses(Set<LigneRetourCaisses> lignesRetourCaisses) {
		this.lignesRetourCaisses = lignesRetourCaisses;
	}


	
	
}
