
package com.agritrace.entity.gestionCommercial;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Fournisseur;


@Entity
@Name("retourFournisseur")
@DiscriminatorValue("RetourFournisseur")
public class RetourFournisseur extends Retour implements Serializable{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1374147725399383898L;


	@NotNull
	@ManyToOne
	@JoinColumn(name="idFournisseur")
    private Fournisseur fournisseur;
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="retourFournisseur")
	private Set<LigneRetourFournisseur> lignesRetourFournisseur = new HashSet<LigneRetourFournisseur>();

	
	
	public RetourFournisseur() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public Fournisseur getFournisseur() {
		return fournisseur;
	}

	public void setFournisseur(Fournisseur fournisseur) {
		this.fournisseur = fournisseur;
	}



	public RetourFournisseur(String numeroRetour, Date dateRetour,
			Campagne campagne, Domaine domaine) {
		super(numeroRetour, dateRetour, campagne, domaine);
		// TODO Auto-generated constructor stub
	}



	public RetourFournisseur(Set<LigneRetourFournisseur> lignesRetourFournisseur) {
		super();
		this.lignesRetourFournisseur = lignesRetourFournisseur;
	}



	public Set<LigneRetourFournisseur> getLignesRetourFournisseur() {
		return lignesRetourFournisseur;
	}



	public void setLignesRetourFournisseur(
			Set<LigneRetourFournisseur> lignesRetourFournisseur) {
		this.lignesRetourFournisseur = lignesRetourFournisseur;
	}

	
	
 }
