
package com.agritrace.entity.location;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;
import com.agritrace.entity.tiers.Tiers;


@Entity
@Name("adresse")
public class Adresse implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 2351774479490559728L;

	@Id
	@GeneratedValue
    private int idAdresse;

	@NotNull
    private String adresse;

	@Length(max=20)
    private String tel;
	
	@Length(max=20)
    private String fax;

	@NotNull
	@Length(max=20)
    private String ville;
	
	
	@Length(max=20)
    private String pays;
	
	@ManyToOne
	@JoinColumn(name="idTiers")
	private Tiers tiers;


	public Adresse() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Adresse(int idAdresse, String adresse, String tel, String fax,
			String ville, String pays, Tiers tiers) {
		super();
		this.idAdresse = idAdresse;
		this.adresse = adresse;
		this.tel = tel;
		this.fax = fax;
		this.ville = ville;
		this.pays = pays;
		this.tiers = tiers;
	}

	public Tiers getTiers() {
		return tiers;
	}

	public void setTiers(Tiers tiers) {
		this.tiers = tiers;
	}

	public int getIdAdresse() {
		return idAdresse;
	}

	public String getAdresse() {
		return adresse;
	}

	public void setAdresse(String adresse) {
		this.adresse = adresse;
	}

	public String getTel() {
		return tel;
	}

	public void setTel(String tel) {
		this.tel = tel;
	}

	public String getFax() {
		return fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	public String getVille() {
		return ville;
	}

	public void setVille(String ville) {
		this.ville = ville;
	}


	public String getPays() {
		return pays;
	}


	public void setPays(String pays) {
		this.pays = pays;
	}
	
	
	
 }
