
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;



@Entity
@Name("analyse")
public class Analyse extends Intervention implements Serializable{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5692074838657019063L;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="analyse")
    private Set<OrdreIntervention> listeOrdresIntervention = new HashSet<OrdreIntervention>();


	public Analyse() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	

	public Analyse(
			String numeroIntervention,
			Date heureDebutIntervention,
			Date heureFinIntervention,
			double debitEau,
			String stadePhenologique,
			int pluviometrie,
			int temperature,
			int hygrometrie,
			int vitesseVent,
			Campagne campagne,
			Domaine domaine,
			OrdreIntervention ordreIntervention,
			Operation operation,
			Set<DetailsInterventionParcelleCulturale> detailsInterventionParcelleCulturales,
			Set<DetailsInterventionMo> detailsInterventionMo,
			Set<DetailsInterventionCategorieMo> detailsInterventionCategorieMo,
			Set<DetailsInterventionMateriel> detailsInterventionMateriel,
			Set<DetailsInterventionOutillage> detailsInterventioOutillage,
			Set<DetailsInterventionProduits> detailsInterventionProduits,
			Set<CiblesTraitementPhyto> ciblesTraitementPhytos,
			String observation) {
		super(numeroIntervention, heureDebutIntervention, heureFinIntervention,
				debitEau, stadePhenologique, pluviometrie, temperature, hygrometrie,
				vitesseVent, campagne, domaine, ordreIntervention, operation,
				detailsInterventionParcelleCulturales, detailsInterventionMo,
				detailsInterventionCategorieMo, detailsInterventionMateriel,
				detailsInterventioOutillage, detailsInterventionProduits,
				ciblesTraitementPhytos, observation);
		// TODO Auto-generated constructor stub
	}



	public Analyse(Set<OrdreIntervention> listeOrdresIntervention) {
		super();
		this.listeOrdresIntervention = listeOrdresIntervention;
	}


	public Set<OrdreIntervention> getListeOrdresIntervention() {
		return listeOrdresIntervention;
	}


	public void setListeOrdresIntervention(
			Set<OrdreIntervention> listeOrdresIntervention) {
		this.listeOrdresIntervention = listeOrdresIntervention;
	}


	
	
 }
