
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;



@Entity
@Name("analysePlantes")
@DiscriminatorValue("AnalysePlantes")
public class AnalysePlantes extends Analyse implements Serializable{



	/**
	 * 
	 */
	private static final long serialVersionUID = 7576406263113937944L;


	@NotNull
    private boolean alerte;


	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH}, mappedBy="analysePlantes", fetch=FetchType.LAZY)
    private Set<DetailsAnalyseRavageurs> detailsAnalyseRavageurs = new HashSet<DetailsAnalyseRavageurs>();


	public AnalysePlantes() {
		super();
		// TODO Auto-generated constructor stub
	}


	public AnalysePlantes(Set<OrdreIntervention> listeOrdresIntervention) {
		super(listeOrdresIntervention);
		// TODO Auto-generated constructor stub
	}

	
	public AnalysePlantes(
			String numeroIntervention,
			Date heureDebutIntervention,
			Date heureFinIntervention,
			double debitEau,
			String stadePhenologique,
			int pluviometrie,
			int temperature,
			int hygrometrie,
			int vitesseVent,
			Campagne campagne,
			Domaine domaine,
			OrdreIntervention ordreIntervention,
			Operation operation,
			Set<DetailsInterventionParcelleCulturale> detailsInterventionParcelleCulturales,
			Set<DetailsInterventionMo> detailsInterventionMo,
			Set<DetailsInterventionCategorieMo> detailsInterventionCategorieMo,
			Set<DetailsInterventionMateriel> detailsInterventionMateriel,
			Set<DetailsInterventionOutillage> detailsInterventioOutillage,
			Set<DetailsInterventionProduits> detailsInterventionProduits,
			Set<CiblesTraitementPhyto> ciblesTraitementPhytos,
			String observation) {
		super(numeroIntervention, heureDebutIntervention, heureFinIntervention,
				debitEau, stadePhenologique, pluviometrie, temperature, hygrometrie,
				vitesseVent, campagne, domaine, ordreIntervention, operation,
				detailsInterventionParcelleCulturales, detailsInterventionMo,
				detailsInterventionCategorieMo, detailsInterventionMateriel,
				detailsInterventioOutillage, detailsInterventionProduits,
				ciblesTraitementPhytos, observation);
		// TODO Auto-generated constructor stub
	}


	public AnalysePlantes(boolean alerte,
			Set<DetailsAnalyseRavageurs> detailsAnalyseRavageurs) {
		super();
		this.alerte = alerte;
		this.detailsAnalyseRavageurs = detailsAnalyseRavageurs;
	}


	public boolean isAlerte() {
		return alerte;
	}


	public void setAlerte(boolean alerte) {
		this.alerte = alerte;
	}


	public Set<DetailsAnalyseRavageurs> getDetailsAnalyseRavageurs() {
		return detailsAnalyseRavageurs;
	}


	public void setDetailsAnalyseRavageurs(
			Set<DetailsAnalyseRavageurs> detailsAnalyseRavageurs) {
		this.detailsAnalyseRavageurs = detailsAnalyseRavageurs;
	}

	
 }
