
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;



@Entity
@Name("analyseSol")
@DiscriminatorValue("AnalyseSol")
public class AnalyseSol extends Analyse implements Serializable{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 3326970482288070385L;
	
	
	@NotNull
	private double tauxN;
	
	@NotNull
	private double tauxP;
	
	@NotNull
	private double tauxK;
	
	
	private double tauxMg;
	
	
	private double tauxCa;


	public AnalyseSol() {
		super();
		// TODO Auto-generated constructor stub
	}


	public double getTauxN() {
		return tauxN;
	}


	public void setTauxN(double tauxN) {
		this.tauxN = tauxN;
	}


	public double getTauxP() {
		return tauxP;
	}


	public void setTauxP(double tauxP) {
		this.tauxP = tauxP;
	}


	public double getTauxK() {
		return tauxK;
	}


	public void setTauxK(double tauxK) {
		this.tauxK = tauxK;
	}


	public double getTauxMg() {
		return tauxMg;
	}


	public void setTauxMg(double tauxMg) {
		this.tauxMg = tauxMg;
	}


	public double getTauxCa() {
		return tauxCa;
	}


	public void setTauxCa(double tauxCa) {
		this.tauxCa = tauxCa;
	}


	public AnalyseSol(Set<OrdreIntervention> listeOrdresIntervention) {
		super(listeOrdresIntervention);
		// TODO Auto-generated constructor stub
	}


	public AnalyseSol(
			String numeroIntervention,
			Date heureDebutIntervention,
			Date heureFinIntervention,
			double debitEau,
			String stadePhenologique,
			int pluviometrie,
			int temperature,
			int hygrometrie,
			int vitesseVent,
			Campagne campagne,
			Domaine domaine,
			OrdreIntervention ordreIntervention,
			Operation operation,
			Set<DetailsInterventionParcelleCulturale> detailsInterventionParcelleCulturales,
			Set<DetailsInterventionMo> detailsInterventionMo,
			Set<DetailsInterventionCategorieMo> detailsInterventionCategorieMo,
			Set<DetailsInterventionMateriel> detailsInterventionMateriel,
			Set<DetailsInterventionOutillage> detailsInterventioOutillage,
			Set<DetailsInterventionProduits> detailsInterventionProduits,
			Set<CiblesTraitementPhyto> ciblesTraitementPhytos,
			String observation) {
		super(numeroIntervention, heureDebutIntervention, heureFinIntervention,
				debitEau, stadePhenologique, pluviometrie, temperature, hygrometrie,
				vitesseVent, campagne, domaine, ordreIntervention, operation,
				detailsInterventionParcelleCulturales, detailsInterventionMo,
				detailsInterventionCategorieMo, detailsInterventionMateriel,
				detailsInterventioOutillage, detailsInterventionProduits,
				ciblesTraitementPhytos, observation);
		// TODO Auto-generated constructor stub
	}


	
 }
