
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;


@Entity
@Name("cyclePlanningProduction")
public class CyclePlanningProduction implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -5636020743283255626L;


	@Id
    @GeneratedValue
    private Long idCyclePlanningProduction;
	

	@NotNull
	private int numeroCycle;
	
	
	@NotNull
	@ManyToOne
    @JoinColumn(name="idPlanningProduction")
    private PlanningProduction  planningProduction;

	
 
    @NotNull
    @Temporal(TemporalType.DATE)
    private Date periodeSemisDu;

    
    @NotNull
    @Temporal(TemporalType.DATE)
    private Date periodeSemisAu;

    
    @NotNull
    @Temporal(TemporalType.DATE)
    private Date periodeCommercialisationDu;
    
    
    @NotNull
    @Temporal(TemporalType.DATE)
    private Date periodeCommercialisationAu;

    
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="cyclePlanningProduction")
    private Set<ParcelleCulturale> listePlanningsParcelle = new HashSet<ParcelleCulturale>();
    
    
    
    private String description;



	public CyclePlanningProduction() {
		super();
		// TODO Auto-generated constructor stub
	}
	

	public CyclePlanningProduction(int numeroCycle,
			PlanningProduction planningProduction, Date periodeSemisDu,
			Date periodeSemisAu, Date periodeCommercialisationDu,
			Date periodeCommercialisationAu,
			Set<ParcelleCulturale> listePlanningsParcelle, String description) {
		super();
		this.numeroCycle = numeroCycle;
		this.planningProduction = planningProduction;
		this.periodeSemisDu = periodeSemisDu;
		this.periodeSemisAu = periodeSemisAu;
		this.periodeCommercialisationDu = periodeCommercialisationDu;
		this.periodeCommercialisationAu = periodeCommercialisationAu;
		this.listePlanningsParcelle = listePlanningsParcelle;
		this.description = description;
	}

	public int getNumeroCycle() {
		return numeroCycle;
	}

	public void setNumeroCycle(int numeroCycle) {
		this.numeroCycle = numeroCycle;
	}

	public PlanningProduction getPlanningProduction() {
		return planningProduction;
	}



	public void setPlanningProduction(PlanningProduction planningProduction) {
		this.planningProduction = planningProduction;
	}


	public Date getPeriodeSemisDu() {
		return periodeSemisDu;
	}



	public void setPeriodeSemisDu(Date periodeSemisDu) {
		this.periodeSemisDu = periodeSemisDu;
	}



	public Date getPeriodeSemisAu() {
		return periodeSemisAu;
	}



	public void setPeriodeSemisAu(Date periodeSemisAu) {
		this.periodeSemisAu = periodeSemisAu;
	}



	public Date getPeriodeCommercialisationDu() {
		return periodeCommercialisationDu;
	}



	public void setPeriodeCommercialisationDu(Date periodeCommercialisationDu) {
		this.periodeCommercialisationDu = periodeCommercialisationDu;
	}



	public Date getPeriodeCommercialisationAu() {
		return periodeCommercialisationAu;
	}



	public void setPeriodeCommercialisationAu(Date periodeCommercialisationAu) {
		this.periodeCommercialisationAu = periodeCommercialisationAu;
	}



	public Set<ParcelleCulturale> getListePlanningsParcelle() {
		return listePlanningsParcelle;
	}



	public void setListePlanningsParcelle(
			Set<ParcelleCulturale> listePlanningsParcelle) {
		this.listePlanningsParcelle = listePlanningsParcelle;
	}



	public String getDescription() {
		return description;
	}



	public void setDescription(String description) {
		this.description = description;
	}



	public Long getIdCyclePlanningProduction() {
		return idCyclePlanningProduction;
	}


 }
