

package com.agritrace.entity.production;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.Intrant;
import com.agritrace.entity.entrepots.Entrepot;



@Entity
@Name("detailsInterventionProduits")
public class DetailsInterventionProduits implements Serializable
{
	
	/**
	 * 
	 */
	
	private static final long serialVersionUID = -5548791037856373567L;
	

	@Id
	@GeneratedValue
	private Long idDetailsInterventionProduits;
	
	
	@NotNull
	private double qteProduitUtilisee;
	
	
	private double dose;
	
	
	@Length(max=15)
    private String modeApplication;
    
	/*
	@ManyToOne
	@JoinColumn(name="idUom")
    private UniteMesure uniteMesure;
*/

	/*
	@NotNull
	@ManyToOne
	@JoinColumn(name="idLigneReception")
    private LigneReception ligneReception;
	*/
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idIntervention")
    private Intervention intervention;
	
	
	@NotNull
	@Length(max=30)
    private String numeroLot;
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private Intrant produit;

	private String uniteDose;
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private  Entrepot entrepot;
	

	public DetailsInterventionProduits(double qteProduitUtilisee, double dose,
			String modeApplication,
			Intervention intervention, String numeroLot, Intrant produit,
			String uniteDose, Entrepot entrepot) {
		super();
		this.qteProduitUtilisee = qteProduitUtilisee;
		this.dose = dose;
		this.modeApplication = modeApplication;
		this.intervention = intervention;
		this.numeroLot = numeroLot;
		this.produit = produit;
		this.uniteDose = uniteDose;
		this.entrepot = entrepot;
	}


	public String getUniteDose() {
		return uniteDose;
	}




	public void setUniteDose(String uniteDose) {
		this.uniteDose = uniteDose;
	}




	public String getNumeroLot() {
		return numeroLot;
	}



	public void setNumeroLot(String numeroLot) {
		this.numeroLot = numeroLot;
	}



	public Intrant getProduit() {
		return produit;
	}



	public void setProduit(Intrant produit) {
		this.produit = produit;
	}



	public Entrepot getEntrepot() {
		return entrepot;
	}


	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}



	public DetailsInterventionProduits() {
		super();
		// TODO Auto-generated constructor stub
	}


	public String getModeApplication() {
		return modeApplication;
	}


	public void setModeApplication(String modeApplication) {
		this.modeApplication = modeApplication;
	}


	public double getQteProduitUtilisee() {
		return qteProduitUtilisee;
	}


	public void setQteProduitUtilisee(double qteProduitUtilisee) {
		this.qteProduitUtilisee = qteProduitUtilisee;
	}


	public Intervention getIntervention() {
		return intervention;
	}


	public void setIntervention(Intervention intervention) {
		this.intervention = intervention;
	}

	public Long getIdDetailsInterventionProduits() {
		return idDetailsInterventionProduits;
	}

	public void setDose(double dose) {
		this.dose = dose;
	}


	public double getDose() {
		return dose;
	}
	
 }
