

package com.agritrace.entity.production;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.Intrant;
import com.agritrace.entity.entrepots.Entrepot;



@Entity
@Name("detailsProduitsMaintenance")
public class DetailsProduitsMaintenance implements Serializable
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5942460759892146445L;


	@Id
	@GeneratedValue
	private Long idDetailsProduitsMaintenance;
	
	
	@NotNull
	private double qteProduitUtilisee;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idArticle")
    private Intrant produit;

	@NotNull
	@ManyToOne
	@JoinColumn(name="idMaintenance")
    private Maintenance maintenance;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idEntrepot")
    private  Entrepot entrepot;


	public DetailsProduitsMaintenance() {
		super();
		// TODO Auto-generated constructor stub
	}

	public DetailsProduitsMaintenance(double qteProduitUtilisee,
			Intrant produit, Maintenance maintenance, Entrepot entrepot) {
		super();
		this.qteProduitUtilisee = qteProduitUtilisee;
		this.produit = produit;
		this.maintenance = maintenance;
		this.entrepot = entrepot;
	}

	public Entrepot getEntrepot() {
		return entrepot;
	}

	public void setEntrepot(Entrepot entrepot) {
		this.entrepot = entrepot;
	}

	public Intrant getProduit() {
		return produit;
	}

	public void setProduit(Intrant produit) {
		this.produit = produit;
	}

	public double getQteProduitUtilisee() {
		return qteProduitUtilisee;
	}


	public void setQteProduitUtilisee(double qteProduitUtilisee) {
		this.qteProduitUtilisee = qteProduitUtilisee;
	}


	public Maintenance getMaintenance() {
		return maintenance;
	}


	public void setMaintenance(Maintenance maintenance) {
		this.maintenance = maintenance;
	}

	public Long getIdDetailsProduitsMaintenance() {
		return idDetailsProduitsMaintenance;
	}

 }
