
package com.agritrace.entity.production;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Semaine;


@Entity
@Name("estimationProductionSemaine")
public class EstimationProductionSemaine implements Serializable{

   

	/**
	 * 
	 */
	private static final long serialVersionUID = -4148429114390663795L;


	@Id
    @GeneratedValue
    private Long idEstimationProductionSemaine;
	

	@NotNull
	@ManyToOne 
    @JoinColumn(name="idSemaine")
    private Semaine  semaine;
	
	
	@NotNull
	@ManyToOne 
    @JoinColumn(name="idParcelleCulturale")
    private ParcelleCulturale parcelleCulturale;
	
    
	@NotNull
    private double tonnageEstime;


	public EstimationProductionSemaine() {
		super();
		// TODO Auto-generated constructor stub
	}

	public EstimationProductionSemaine(Semaine semaine,
			ParcelleCulturale parcelleCulturale, double tonnageEstime) {
		super();
		this.semaine = semaine;
		this.parcelleCulturale = parcelleCulturale;
		this.tonnageEstime = tonnageEstime;
	}

	public double getTonnageEstime() {
		return tonnageEstime;
	}

	public void setTonnageEstime(double tonnageEstime) {
		this.tonnageEstime = tonnageEstime;
	}

	public ParcelleCulturale getParcelleCulturale() {
		return parcelleCulturale;
	}


	public void setParcelleCulturale(ParcelleCulturale parcelleCulturale) {
		this.parcelleCulturale = parcelleCulturale;
	}


	public Semaine getSemaine() {
		return semaine;
	}


	public void setSemaine(Semaine semaine) {
		this.semaine = semaine;
	}


	public Long getIdEstimationProductionSemaine() {
		return idEstimationProductionSemaine;
	}


 }
