
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;


@Entity
@Name("nettoyageChateauEau")
@DiscriminatorValue("NettoyageChateauEau")
public class NettoyageChateauEau extends Nettoyage implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -6799054944976965301L;
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="nettoyageChateauEau")
	private Set<DetailsChateauxNettoyage> detailsChateauxNettoyages=new HashSet<DetailsChateauxNettoyage>();

	public NettoyageChateauEau() {
		super();
		// TODO Auto-generated constructor stub
	}

	public NettoyageChateauEau(
			String numeroIntervention,
			Date heureDebutIntervention,
			Date heureFinIntervention,
			double debitEau,
			String stadePhenologique,
			int pluviometrie,
			int temperature,
			int hygrometrie,
			int vitesseVent,
			Campagne campagne,
			Domaine domaine,
			OrdreIntervention ordreIntervention,
			Operation operation,
			Set<DetailsInterventionParcelleCulturale> detailsInterventionParcelleCulturales,
			Set<DetailsInterventionMo> detailsInterventionMo,
			Set<DetailsInterventionCategorieMo> detailsInterventionCategorieMo,
			Set<DetailsInterventionMateriel> detailsInterventionMateriel,
			Set<DetailsInterventionOutillage> detailsInterventioOutillage,
			Set<DetailsInterventionProduits> detailsInterventionProduits,
			Set<CiblesTraitementPhyto> ciblesTraitementPhytos,
			String observation) {
		super(numeroIntervention, heureDebutIntervention, heureFinIntervention,
				debitEau, stadePhenologique, pluviometrie, temperature, hygrometrie,
				vitesseVent, campagne, domaine, ordreIntervention, operation,
				detailsInterventionParcelleCulturales, detailsInterventionMo,
				detailsInterventionCategorieMo, detailsInterventionMateriel,
				detailsInterventioOutillage, detailsInterventionProduits,
				ciblesTraitementPhytos, observation);
		// TODO Auto-generated constructor stub
	}




	public NettoyageChateauEau(
			Set<DetailsChateauxNettoyage> detailsChateauxNettoyages) {
		super();
		this.detailsChateauxNettoyages = detailsChateauxNettoyages;
	}
	

	public Set<DetailsChateauxNettoyage> getDetailsChateauxNettoyages() {
		return detailsChateauxNettoyages;
	}

	public void setDetailsChateauxNettoyages(
			Set<DetailsChateauxNettoyage> detailsChateauxNettoyages) {
		this.detailsChateauxNettoyages = detailsChateauxNettoyages;
	}

	
	


 }
