
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.PorteGreffe;
import com.agritrace.entity.articles.Variete;
import com.agritrace.entity.domaine.Parcelle;



@Entity
@Name("parcelleCulturale")
public class ParcelleCulturale implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = -3559754106166560475L;

	
	@Id
    @GeneratedValue
    private Long idParcelleCulturale;

	
    @NotNull
    @Length(max=30)
    private String numeroParcelleCulturale;


    private int densitePlantation;
    
    
    @NotNull
	private int nombreBillons;
	
	
	private int nombrePlantsParBillon;
	
	
    @NotNull
    private long tonnageEstime;
    
    
    @NotNull
    @ManyToOne 
    @JoinColumn (name="idCyclePlanningProduction")
    private CyclePlanningProduction cyclePlanningProduction;
    
    
    @NotNull
    @ManyToOne 
    @JoinColumn (name="idParcelle")
    private Parcelle parcelle;
    
    
	@NotNull
	@ManyToOne
	@JoinColumn(name="idVariete")
	private Variete variete;
    
	
	@ManyToOne
	@JoinColumn(name="idPorteGreffe")
	private PorteGreffe porteGreffe;
    


	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="parcelleCulturale")
	private Set<EstimationProductionSemaine> listeEstimationProductionParSemaine = new HashSet<EstimationProductionSemaine>();
	
	
	public ParcelleCulturale() {
		super();
		// TODO Auto-generated constructor stub
	}

	public ParcelleCulturale(String numeroParcelleCulturale,
			int densitePlantation, int nombreBillons,
			int nombrePlantsParBillon, long tonnageEstime,
			CyclePlanningProduction cyclePlanningProduction, Parcelle parcelle,
			Variete variete, PorteGreffe porteGreffe,
			Set<EstimationProductionSemaine> listeEstimationProductionParSemaine) {
		super();
		this.numeroParcelleCulturale = numeroParcelleCulturale;
		this.densitePlantation = densitePlantation;
		this.nombreBillons = nombreBillons;
		this.nombrePlantsParBillon = nombrePlantsParBillon;
		this.tonnageEstime = tonnageEstime;
		this.cyclePlanningProduction = cyclePlanningProduction;
		this.parcelle = parcelle;
		this.variete = variete;
		this.porteGreffe = porteGreffe;
		this.listeEstimationProductionParSemaine = listeEstimationProductionParSemaine;
	}

	public Set<EstimationProductionSemaine> getListeEstimationProductionParSemaine() {
		return listeEstimationProductionParSemaine;
	}

	public void setListeEstimationProductionParSemaine(
			Set<EstimationProductionSemaine> listeEstimationProductionParSemaine) {
		this.listeEstimationProductionParSemaine = listeEstimationProductionParSemaine;
	}

	public Variete getVariete() {
		return variete;
	}

	public void setVariete(Variete variete) {
		this.variete = variete;
	}

	public PorteGreffe getPorteGreffe() {
		return porteGreffe;
	}

	public void setPorteGreffe(PorteGreffe porteGreffe) {
		this.porteGreffe = porteGreffe;
	}

	public int getDensitePlantation() {
		return densitePlantation;
	}


	public void setDensitePlantation(int densitePlantation) {
		this.densitePlantation = densitePlantation;
	}


	public int getNombreBillons() {
		return nombreBillons;
	}


	public void setNombreBillons(int nombreBillons) {
		this.nombreBillons = nombreBillons;
	}


	public int getNombrePlantsParBillon() {
		return nombrePlantsParBillon;
	}


	public void setNombrePlantsParBillon(int nombrePlantsParBillon) {
		this.nombrePlantsParBillon = nombrePlantsParBillon;
	}


	public String getNumeroParcelleCulturale() {
		return numeroParcelleCulturale;
	}





	public void setNumeroParcelleCulturale(String numeroParcelleCulturale) {
		this.numeroParcelleCulturale = numeroParcelleCulturale;
	}



	public long getTonnageEstime() {
		return tonnageEstime;
	}





	public void setTonnageEstime(long tonnageEstime) {
		this.tonnageEstime = tonnageEstime;
	}





	public CyclePlanningProduction getCyclePlanningProduction() {
		return cyclePlanningProduction;
	}





	public void setCyclePlanningProduction(
			CyclePlanningProduction cyclePlanningProduction) {
		this.cyclePlanningProduction = cyclePlanningProduction;
	}





	public Parcelle getParcelle() {
		return parcelle;
	}





	public void setParcelle(Parcelle parcelle) {
		this.parcelle = parcelle;
	}





	public Long getIdParcelleCulturale() {
		return idParcelleCulturale;
	}

	
	
 }
