
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.convention.LignesConvention;

@Entity
@Name("planningProduction")
public class PlanningProduction implements Serializable 
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 7150196740599191209L;
	

	@Id
    @GeneratedValue
    private Long idPlanningProduction;
   
	
	@NotNull
    @Length(max=20)
    private String numeroPlanningProduction;
	
	
	@ManyToOne
	@JoinColumn(name="idCampagne")
	private Campagne campagne;
	

	@NotNull
	@ManyToOne 
    @JoinColumn(name="idLigneConvention")
    private LignesConvention  lignesConvention;
   
    
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="planningProduction")
    private Set<CyclePlanningProduction> cyclesPlanningProduction = new HashSet<CyclePlanningProduction>();


	public PlanningProduction() {
		super();
		// TODO Auto-generated constructor stub
	}

	public PlanningProduction(String numeroPlanningProduction,
			Campagne campagne, LignesConvention lignesConvention,
			Set<CyclePlanningProduction> cyclesPlanningProduction) {
		super();
		this.numeroPlanningProduction = numeroPlanningProduction;
		this.campagne = campagne;
		this.lignesConvention = lignesConvention;
		this.cyclesPlanningProduction = cyclesPlanningProduction;
	}

	public LignesConvention getLignesConvention() {
		return lignesConvention;
	}

	public void setLignesConvention(LignesConvention lignesConvention) {
		this.lignesConvention = lignesConvention;
	}

	public Campagne getCampagne() {
		return campagne;
	}

	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}

	
	public String getNumeroPlanningProduction() {
		return numeroPlanningProduction;
	}


	public void setNumeroPlanningProduction(String numeroPlanningProduction) {
		this.numeroPlanningProduction = numeroPlanningProduction;
	}


	public Set<CyclePlanningProduction> getCyclesPlanningProduction() {
		return cyclesPlanningProduction;
	}


	public void setCyclesPlanningProduction(
			Set<CyclePlanningProduction> cyclesPlanningProduction) {
		this.cyclesPlanningProduction = cyclesPlanningProduction;
	}


	public Long getIdPlanningProduction() {
		return idPlanningProduction;
	}

 }
