
package com.agritrace.entity.production;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;


@Entity
@Name("recolte")
@DiscriminatorValue("Recolte")
public class Recolte extends Intervention implements Serializable
{
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2713793509470994706L;
	
	
	@NotNull
	private double poidsTotalNet;
	
	
	@NotNull
	@Length(max=20)
	private String numeroLotRecolte;
	
	
	@NotNull
    @ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="idParcelleCulturale")
    private ParcelleCulturale parcelleCulturale;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH}, fetch=FetchType.LAZY, mappedBy="recolte")
	private Set<DetailsRecolteCaisses> detailsRecolteCaisses=new HashSet<DetailsRecolteCaisses>();


	
	public Recolte() {
		super();
		// TODO Auto-generated constructor stub
	}

	public Recolte(
			String numeroIntervention,
			Date heureDebutIntervention,
			Date heureFinIntervention,
			double debitEau,
			String stadePhenologique,
			int pluviometrie,
			int temperature,
			int hygrometrie,
			int vitesseVent,
			Campagne campagne,
			Domaine domaine,
			OrdreIntervention ordreIntervention,
			Operation operation,
			Set<DetailsInterventionParcelleCulturale> detailsInterventionParcelleCulturales,
			Set<DetailsInterventionMo> detailsInterventionMo,
			Set<DetailsInterventionCategorieMo> detailsInterventionCategorieMo,
			Set<DetailsInterventionMateriel> detailsInterventionMateriel,
			Set<DetailsInterventionOutillage> detailsInterventioOutillage,
			Set<DetailsInterventionProduits> detailsInterventionProduits,
			Set<CiblesTraitementPhyto> ciblesTraitementPhytos,
			String observation) {
		super(numeroIntervention, heureDebutIntervention, heureFinIntervention,
				debitEau, stadePhenologique, pluviometrie, temperature, hygrometrie,
				vitesseVent, campagne, domaine, ordreIntervention, operation,
				detailsInterventionParcelleCulturales, detailsInterventionMo,
				detailsInterventionCategorieMo, detailsInterventionMateriel,
				detailsInterventioOutillage, detailsInterventionProduits,
				ciblesTraitementPhytos, observation);
		// TODO Auto-generated constructor stub
	}



	public ParcelleCulturale getParcelleCulturale() {
		return parcelleCulturale;
	}

	public void setParcelleCulturale(ParcelleCulturale parcelleCulturale) {
		this.parcelleCulturale = parcelleCulturale;
	}

	public String getNumeroLotRecolte() {
		return numeroLotRecolte;
	}



	public void setNumeroLotRecolte(String numeroLotRecolte) {
		this.numeroLotRecolte = numeroLotRecolte;
	}



	public Set<DetailsRecolteCaisses> getDetailsRecolteCaisses() {
		return detailsRecolteCaisses;
	}



	public void setDetailsRecolteCaisses(
			Set<DetailsRecolteCaisses> detailsRecolteCaisses) {
		this.detailsRecolteCaisses = detailsRecolteCaisses;
	}

	public double getPoidsTotalNet() {
		return poidsTotalNet;
	}

	public void setPoidsTotalNet(double poidsTotalNet) {
		this.poidsTotalNet = poidsTotalNet;
	}
	
	
	
	
}
