
package com.agritrace.entity.tiers;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.hibernate.validator.Past;
import org.jboss.seam.annotations.Name;



@Entity
@Name("affectationTravail")
public class AffectationTravail implements Serializable
{


	/**
	 * 
	 */
	private static final long serialVersionUID = 3243537543465064940L;


	@Id
	@GeneratedValue
    private Long idAffectationTravail;


	@NotNull
	@Column(precision=19, scale=2)
	private BigDecimal salaire; 
	
	
	@Past
	@Temporal(TemporalType.DATE)
    private Date dateEntree;

	
	@Temporal(TemporalType.DATE)
    private Date dateSortie;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idFonctionPersonnel")
	private FonctionPersonnel fonctionPersonnel;


	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
	private Personnel personnel;
	
	
	@NotNull
	@Length(max=20)
    private String categoriePersonnel;
	
	/// valeurs (1 : PostesFixes , 2 : Ouvriers)
	
	
	public AffectationTravail() {
		super();
		// TODO Auto-generated constructor stub
	}

	public AffectationTravail(BigDecimal salaire, Date dateEntree,
			Date dateSortie, FonctionPersonnel fonctionPersonnel,
			Personnel personnel, String categoriePersonnel) {
		super();
		this.salaire = salaire;
		this.dateEntree = dateEntree;
		this.dateSortie = dateSortie;
		this.fonctionPersonnel = fonctionPersonnel;
		this.personnel = personnel;
		this.categoriePersonnel = categoriePersonnel;
	}

	
	public String getCategoriePersonnel() {
		return categoriePersonnel;
	}

	public void setCategoriePersonnel(String categoriePersonnel) {
		this.categoriePersonnel = categoriePersonnel;
	}

	public BigDecimal getSalaire() {
		return salaire;
	}


	public void setSalaire(BigDecimal salaire) {
		this.salaire = salaire;
	}


	public Date getDateEntree() {
		return dateEntree;
	}

	public void setDateEntree(Date dateEntree) {
		this.dateEntree = dateEntree;
	}


	public Date getDateSortie() {
		return dateSortie;
	}


	public void setDateSortie(Date dateSortie) {
		this.dateSortie = dateSortie;
	}





	public FonctionPersonnel getFonctionPersonnel() {
		return fonctionPersonnel;
	}





	public void setFonctionPersonnel(FonctionPersonnel fonctionPersonnel) {
		this.fonctionPersonnel = fonctionPersonnel;
	}





	public Personnel getPersonnel() {
		return personnel;
	}





	public void setPersonnel(Personnel personnel) {
		this.personnel = personnel;
	}





	public Long getIdAffectationTravail() {
		return idAffectationTravail;
	}





	
	
	
 }
