
package com.agritrace.entity.tiers;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.location.Adresse;


@Entity
@Name("personnel")
@DiscriminatorValue("Personnel")
public class Personnel extends Tiers {

	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5840888881693032895L;

	@NotNull
	@Length(max=100)
    private String matriculePersonnel;

	@NotNull
	@Length(max=20)
    private String cin;

	@NotNull
	@Length(max=100)
    private String nomPersonnel;

	@NotNull
	@Length(max=100)
    private String prenomPersonnel;
    
	@NotNull
	@Length(max=20)
    private String gsmPersonnel;
	
	
	@Length(max=20)
	private String numeroCnss;
	
	
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="personnel")
    private Set<AffectationTravail> listeAffectationTravail = new HashSet<AffectationTravail>();
    
	 
    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="personnel")
    private Set<PersonnelFormation> listeAffectationFormation = new HashSet<PersonnelFormation>();
    
    

	public Personnel() {
		super();
		// TODO Auto-generated constructor stub
	}
	

	public Personnel(String libelleTiers, CategorieTiers categorieTiers,
			Domaine domaine, Set<Adresse> listeAdresses) {
		super(libelleTiers, categorieTiers, domaine, listeAdresses);
		// TODO Auto-generated constructor stub
	}

	

	public Personnel(String matriculePersonnel, String cin,
			String nomPersonnel, String prenomPersonnel, String gsmPersonnel,
			String numeroCnss, Set<AffectationTravail> listeAffectationTravail,
			Set<PersonnelFormation> listeAffectationFormation) {
		super();
		this.matriculePersonnel = matriculePersonnel;
		this.cin = cin;
		this.nomPersonnel = nomPersonnel;
		this.prenomPersonnel = prenomPersonnel;
		this.gsmPersonnel = gsmPersonnel;
		this.numeroCnss = numeroCnss;
		this.listeAffectationTravail = listeAffectationTravail;
		this.listeAffectationFormation = listeAffectationFormation;
	}


	@SuppressWarnings("unchecked")
	public AffectationTravail getLastAffectationPersonnel()
    {
    	AffectationTravail lastAffectation = null;
    	
    	if (!this.getListeAffectationTravail().isEmpty())
    	{
    		List<AffectationTravail> listeAffectations = (new ArrayList(this.getListeAffectationTravail()));
    		
    		lastAffectation = listeAffectations.get(0);

    		for(int i=1; i<listeAffectations.size(); i++ )
    		{
    			if(lastAffectation.getDateEntree().before(listeAffectations.get(i).getDateEntree()))
    			{
    			    lastAffectation = listeAffectations.get(i);	
    			}
    		}
    	}
    	
    	return lastAffectation;
    }
    
	
	public String getNumeroCnss() {
		return numeroCnss;
	}


	public void setNumeroCnss(String numeroCnss) {
		this.numeroCnss = numeroCnss;
	}


	public Set<PersonnelFormation> getListeAffectationFormation() {
		return listeAffectationFormation;
	}

	public void setListeAffectationFormation(
			Set<PersonnelFormation> listeAffectationFormation) {
		this.listeAffectationFormation = listeAffectationFormation;
	}

	public String getMatriculePersonnel() {
		return matriculePersonnel;
	}


	public void setMatriculePersonnel(String matriculePersonnel) {
		this.matriculePersonnel = matriculePersonnel;
	}


	public String getCin() {
		return cin;
	}


	public void setCin(String cin) {
		this.cin = cin;
	}


	public String getNomPersonnel() {
		return nomPersonnel;
	}


	public void setNomPersonnel(String nomPersonnel) {
		this.nomPersonnel = nomPersonnel;
	}


	public String getPrenomPersonnel() {
		return prenomPersonnel;
	}


	public void setPrenomPersonnel(String prenomPersonnel) {
		this.prenomPersonnel = prenomPersonnel;
	}


	public String getGsmPersonnel() {
		return gsmPersonnel;
	}


	public void setGsmPersonnel(String gsmPersonnel) {
		this.gsmPersonnel = gsmPersonnel;
	}


	public Set<AffectationTravail> getListeAffectationTravail() {
		return listeAffectationTravail;
	}


	public void setListeAffectationTravail(
			Set<AffectationTravail> listeAffectationTravail) {
		this.listeAffectationTravail = listeAffectationTravail;
	}
	

	
	
 }
