
package com.agritrace.entity.tiers;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;



@Entity
@Name("pointage")
public class Pointage implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -716599067437345642L;


	@Id
	@GeneratedValue
    private Long idPointage;
	
	@NotNull
	@Temporal(TemporalType.DATE)
    private Date datePointage;

	@NotNull
    private int demiTtJournee;   //1 : demi journée | 2 : journée complète
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idCampagne")
	private Campagne campagne;
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idTiers")
	private Personnel personnel;
	
	private double primeParJournee;
	
	private double primeParTache;
	
	
	public Pointage() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	
    public Pointage(Date datePointage, int demiTtJournee, Campagne campagne,
			Domaine domaine, Personnel personnel, double primeParJournee,
			double primeParTache) {
		super();
		this.datePointage = datePointage;
		this.demiTtJournee = demiTtJournee;
		this.campagne = campagne;
		this.domaine = domaine;
		this.personnel = personnel;
		this.primeParJournee = primeParJournee;
		this.primeParTache = primeParTache;
	}


    /*
	public String getDureeTravaille()
    {
    	String duree = "";
    	
    	switch(this.demiTtJournee) 
    	{
    		case 4 : 
    			
		    			duree = "½ journée";
		    			break;
    		
    		case 8 : 
    			
		    			duree = "1 journée";
		    			break;
    		
    		case 16 : 
    			
		    			duree = "2 jours";
		    			break;
    		
    		case 24 : 
    					
		    			duree = "3 jours";
		    			break;
    		
    	
			
    		default : break;
    		
    	}
    	
    	return duree;
    }
    */
    
	public double getPrimeParJournee() {
		return primeParJournee;
	}



	public void setPrimeParJournee(double primeParJournee) {
		this.primeParJournee = primeParJournee;
	}



	public double getPrimeParTache() {
		return primeParTache;
	}



	public void setPrimeParTache(double primeParTache) {
		this.primeParTache = primeParTache;
	}



	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}

	public Date getDatePointage() {
		return datePointage;
	}


	public void setDatePointage(Date datePointage) {
		this.datePointage = datePointage;
	}


	public int getDemiTtJournee() {
		return demiTtJournee;
	}


	public void setDemiTtJournee(int demiTtJournee) {
		this.demiTtJournee = demiTtJournee;
	}


	public Campagne getCampagne() {
		return campagne;
	}


	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}


	public Personnel getPersonnel() {
		return personnel;
	}


	public void setPersonnel(Personnel personnel) {
		this.personnel = personnel;
	}


	public Long getIdPointage() {
		return idPointage;
	}
	
 }
