
package com.agritrace.entity.tiers;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.location.Adresse;

@Entity
@Name("tiers")
public class Tiers implements Serializable
{
    /**
	 * 
	 */
	private static final long serialVersionUID = 6788754182632478897L;

	
	@Id
	@GeneratedValue
	private int idTiers;
	
	
	@Length(max=200)
    private String libelleTiers;

	
	@ManyToOne
	@JoinColumn(name="idCategorieTiers")
	private CategorieTiers categorieTiers;
	
	
	@NotNull
	@ManyToOne
	@JoinColumn(name="idDomaine")
	private Domaine domaine;
	
	
	@OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY, mappedBy="tiers")
    private Set<Adresse> listeAdresses = new HashSet<Adresse>();

		
	public Tiers() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	public String getInstanceOfTiers()
	{
		String instance = "";
		if(this instanceof Producteur)
			instance="Producteur";
		else if(this instanceof Client)
			instance="Client";
		else if(this instanceof Fournisseur)
			instance="Fournisseur";
		else if(this instanceof Personnel)
			instance="Personnel";
		return instance;
	}

	public Tiers(String libelleTiers, CategorieTiers categorieTiers,
			Domaine domaine, Set<Adresse> listeAdresses) {
		super();
		this.libelleTiers = libelleTiers;
		this.categorieTiers = categorieTiers;
		this.domaine = domaine;
		this.listeAdresses = listeAdresses;
	}

	public Domaine getDomaine() {
		return domaine;
	}


	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}


	public String getLibelleTiers() {
		return libelleTiers;
	}


	public void setLibelleTiers(String libelleTiers) {
		this.libelleTiers = libelleTiers;
	}


	public CategorieTiers getCategorieTiers() {
		return categorieTiers;
	}


	public void setCategorieTiers(CategorieTiers categorieTiers) {
		this.categorieTiers = categorieTiers;
	}


	public Set<Adresse> getListeAdresses() {
		return listeAdresses;
	}


	public void setListeAdresses(Set<Adresse> listeAdresses) {
		this.listeAdresses = listeAdresses;
	}


	public int getIdTiers() {
		return idTiers;
	}
	
 }
