
package com.agritrace.entity.userRoles;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;

@Entity
@Name("userAffectationDomaine")
public class UserAffectationDomaine implements Serializable
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 6897547116566900455L;

	@Id
	@GeneratedValue
	private Long idUserAffectationDomaine;

	
    @Temporal(TemporalType.DATE)
    private Date dateAffectation;
	
    @NotNull
    @ManyToOne
    @JoinColumn(name="idUser")
    private Users user;
    
    
    @NotNull
    @ManyToOne
    @JoinColumn(name="idDomaine")
    private Domaine domaine;

	public UserAffectationDomaine() {
		super();
		// TODO Auto-generated constructor stub
	}

	public UserAffectationDomaine(Date dateAffectation, Users user,
			Domaine domaine) {
		super();
		this.dateAffectation = dateAffectation;
		this.user = user;
		this.domaine = domaine;
	}

	public Long getIdUserAffectationDomaine() {
		return idUserAffectationDomaine;
	}

	public void setIdUserAffectationDomaine(Long idUserAffectationDomaine) {
		this.idUserAffectationDomaine = idUserAffectationDomaine;
	}

	public Date getDateAffectation() {
		return dateAffectation;
	}

	public void setDateAffectation(Date dateAffectation) {
		this.dateAffectation = dateAffectation;
	}

	public Users getUser() {
		return user;
	}

	public void setUser(Users user) {
		this.user = user;
	}

	public Domaine getDomaine() {
		return domaine;
	}

	public void setDomaine(Domaine domaine) {
		this.domaine = domaine;
	}
    
    
    


 }
