
package com.agritrace.entity.userRoles;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;

import org.hibernate.validator.Length;
import org.hibernate.validator.NotNull;
import org.jboss.seam.annotations.Name;


@Entity
@Name("users")
public class Users implements Serializable
{


	/**
	 * 
	 */
	private static final long serialVersionUID = 4100213706439736660L;

	@Id
	@GeneratedValue
    private int idUser;

	@NotNull
	@Length(max=40)
    private String username;

	@NotNull
	@Length(max=40)
    private String password;

	@NotNull
	@Length(max=40)
    private String nomUser;

	@NotNull
	@Length(max=40)
    private String prenomUser;

	
    private String description;

	@NotNull
	@Length(max=30)
    private String libelleRole;

    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="user")
    private Set<UserAffectationDomaine> userAffectationsDomaines = new HashSet<UserAffectationDomaine>();

    @OneToMany(cascade = {CascadeType.MERGE,CascadeType.REMOVE,CascadeType.REFRESH} , fetch = FetchType.LAZY , mappedBy="user")
    private Set<UserAffectationCampagne> userAffectationsCampagnes = new HashSet<UserAffectationCampagne>();

    
    
    
	public Users() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	
	public Users(String username, String password, String nomUser,
			String prenomUser, String description, String libelleRole,
			Set<UserAffectationDomaine> userAffectationsDomaines,
			Set<UserAffectationCampagne> userAffectationsCampagnes) {
		super();
		this.username = username;
		this.password = password;
		this.nomUser = nomUser;
		this.prenomUser = prenomUser;
		this.description = description;
		this.libelleRole = libelleRole;
		this.userAffectationsDomaines = userAffectationsDomaines;
		this.userAffectationsCampagnes = userAffectationsCampagnes;
	}



	public Users(String username, String password) {
		super();
		this.username = username;
		this.password = password;
	}


	public Set<UserAffectationDomaine> getUserAffectationsDomaines() {
		return userAffectationsDomaines;
	}



	public void setUserAffectationsDomaines(
			Set<UserAffectationDomaine> userAffectationsDomaines) {
		this.userAffectationsDomaines = userAffectationsDomaines;
	}



	public Set<UserAffectationCampagne> getUserAffectationsCampagnes() {
		return userAffectationsCampagnes;
	}



	public void setUserAffectationsCampagnes(
			Set<UserAffectationCampagne> userAffectationsCampagnes) {
		this.userAffectationsCampagnes = userAffectationsCampagnes;
	}


	public int getIdUser() {
		return idUser;
	}


	public String getUsername() {
		return username;
	}



	public void setUsername(String username) {
		this.username = username;
	}



	public String getPassword() {
		return password;
	}



	public void setPassword(String password) {
		this.password = password;
	}



	public String getNomUser() {
		return nomUser;
	}



	public void setNomUser(String nomUser) {
		this.nomUser = nomUser;
	}



	public String getPrenomUser() {
		return prenomUser;
	}



	public void setPrenomUser(String prenomUser) {
		this.prenomUser = prenomUser;
	}



	public String getDescription() {
		return description;
	}



	public void setDescription(String description) {
		this.description = description;
	}



	public String getLibelleRole() {
		return libelleRole;
	}



	public void setLibelleRole(String libelleRole) {
		this.libelleRole = libelleRole;
	}
	
 }
