package com.agritrace.session;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.framework.EntityHome;

import com.agritrace.entity.location.Adresse;
import com.agritrace.entity.tiers.Tiers;

@Name("adresseHome")
public class AdresseHome extends EntityHome<Adresse> {

	@In(create = true)
	TiersHome tiersHome;
	
	
	@Out(required=false)
	private List<String> listDesPays;

	public void setAdresseIdAdresse(Integer id) {
		setId(id);
	}

	public Integer getAdresseIdAdresse() {
		return (Integer) getId();
	}

	@Override
	protected Adresse createInstance() {
		Adresse adresse = new Adresse();
		return adresse;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Tiers tiers = tiersHome.getDefinedInstance();
		if (tiers != null) {
			getInstance().setTiers(tiers);
		}
	}

	public boolean isWired() {
		return true;
	}

	public Adresse getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	
	@Factory("listDesPays")
	public List<String> getListPays()
	{
		Locale[] locales = Locale.getAvailableLocales();
		
		listDesPays=new ArrayList<String>();
		
	    for (Locale locale : locales) 
	    {
	    	if(! locale.getDisplayCountry().toString().equals(""))
	    	{
	    		listDesPays.add(locale.getDisplayCountry().toString());
	    	}
	    }
		
	    Collections.sort(listDesPays);
	    
		return listDesPays;
	}
	
	
}
