package com.agritrace.session;

import com.agritrace.entity.location.*;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("adresseList")
public class AdresseList extends EntityQuery<Adresse> {

	private static final String EJBQL = "select adresse from Adresse adresse";

	private static final String[] RESTRICTIONS = {
			"lower(adresse.adresse) like lower(concat(#{adresseList.adresse.adresse},'%'))",
			"lower(adresse.fax) like lower(concat(#{adresseList.adresse.fax},'%'))",
			"lower(adresse.pays) like lower(concat(#{adresseList.adresse.pays},'%'))",
			"lower(adresse.tel) like lower(concat(#{adresseList.adresse.tel},'%'))",
			"lower(adresse.ville) like lower(concat(#{adresseList.adresse.ville},'%'))", };

	private Adresse adresse = new Adresse();

	public AdresseList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public Adresse getAdresse() {
		return adresse;
	}
}
