package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

import com.agritrace.entity.tiers.AffectationTravail;
import com.agritrace.entity.tiers.FonctionPersonnel;
import com.agritrace.entity.tiers.Personnel;

@Name("affectationTravailHome")
public class AffectationTravailHome extends EntityHome<AffectationTravail> {

	@In(create = true)
	FonctionPersonnelHome fonctionPersonnelHome;
	@In(create = true)
	PersonnelHome personnelHome;

	public void setAffectationTravailIdAffectationTravail(Long id) {
		setId(id);
	}

	public Long getAffectationTravailIdAffectationTravail() {
		return (Long) getId();
	}

	@Override
	protected AffectationTravail createInstance() {
		AffectationTravail affectationTravail = new AffectationTravail();
		return affectationTravail;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		FonctionPersonnel fonctionPersonnel = fonctionPersonnelHome
				.getDefinedInstance();
		if (fonctionPersonnel != null) {
			getInstance().setFonctionPersonnel(fonctionPersonnel);
		}
		Personnel personnel = personnelHome.getDefinedInstance();
		if (personnel != null) {
			getInstance().setPersonnel(personnel);
		}
	}

	public boolean isWired() {
		if (getInstance().getFonctionPersonnel() == null)
			return false;
		if (getInstance().getPersonnel() == null)
			return false;
		return true;
	}

	public AffectationTravail getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void fonctionChanged(ValueChangeEvent event)
	{
		FonctionPersonnel fonctionPersonnel = (FonctionPersonnel)event.getNewValue();
		
		if (fonctionPersonnel != null) 
		{
			getInstance().setFonctionPersonnel(fonctionPersonnel);
		}
	}

}
