package com.agritrace.session;

import com.agritrace.entity.tiers.*;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("affectationTravailList")
public class AffectationTravailList extends EntityQuery<AffectationTravail> {

	private static final String EJBQL = "select affectationTravail from AffectationTravail affectationTravail";

	private static final String[] RESTRICTIONS = {
		
		"lower(affectationTravail.personnel.nomPersonnel) like lower(concat(#{affectationTravailList.personnel.nomPersonnel},'%'))",
		"lower(affectationTravail.personnel.prenomPersonnel) like lower(concat(#{affectationTravailList.personnel.prenomPersonnel},'%'))",
		"lower(affectationTravail.personnel.matriculePersonnel) like lower(concat(#{affectationTravailList.personnel.matriculePersonnel},'%'))",
		
	};

	private AffectationTravail affectationTravail = new AffectationTravail();

	public AffectationTravailList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public AffectationTravail getAffectationTravail() {
		return affectationTravail;
	}
}
