package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("analyseEauList")
public class AnalyseEauList extends EntityQuery<AnalyseEau> {
	

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select analyseEau from AnalyseEau analyseEau";

	private static final String[] RESTRICTIONS = {
		
		"lower(analyseEau.numeroIntervention) like lower(concat(#{analyseEauList.analyseEau.numeroIntervention},'%'))", 
		"analyseEau.campagne.campagne = #{campagneSession.campagne.campagne}",
		"analyseEau.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
		
	};

	private AnalyseEau analyseEau = new AnalyseEau();

	public AnalyseEauList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public AnalyseEau getAnalyseEau() {
		return analyseEau;
	}
}
