package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("analysePlantesList")
public class AnalysePlantesList extends EntityQuery<AnalysePlantes> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select analysePlantes from AnalysePlantes analysePlantes";

	private static final String[] RESTRICTIONS = {
		
		"lower(analysePlantes.numeroIntervention) like lower(concat(#{analysePlantesList.analysePlantes.numeroIntervention},'%'))", 
		"analysePlantes.campagne.campagne = #{campagneSession.campagne.campagne}",
		"analysePlantes.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private AnalysePlantes analysePlantes = new AnalysePlantes();

	public AnalysePlantesList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public AnalysePlantes getAnalysePlantes() {
		return analysePlantes;
	}
}
