package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("analyseSolList")
public class AnalyseSolList extends EntityQuery<AnalyseSol> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select analyseSol from AnalyseSol analyseSol";

	private static final String[] RESTRICTIONS = { 
		
		"lower(analyseSol.numeroIntervention) like lower(concat(#{analyseSolList.analyseSol.numeroIntervention},'%'))", 
		"analyseSol.campagne.campagne = #{campagneSession.campagne.campagne}",
		"analyseSol.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	
	};

	private AnalyseSol analyseSol = new AnalyseSol();

	public AnalyseSolList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public AnalyseSol getAnalyseSol() {
		return analyseSol;
	}
}
