package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Article;
import com.agritrace.entity.articles.ArticleFournisseur;
import com.agritrace.entity.tiers.Fournisseur;

@Name("articleFournisseurHome")
public class ArticleFournisseurHome extends EntityHome<ArticleFournisseur> {

	@In(create = true)
	ArticleHome articleHome;
	
	/*
	@In(create = true)
	FournisseurHome fournisseurHome;
	*/
	
	@Logger
	Log logger;
	
	public void setArticleFournisseurIdArticleFournisseur(Long id) {
		setId(id);
	}

	public Long getArticleFournisseurIdArticleFournisseur() {
		return (Long) getId();
	}

	@Override
	protected ArticleFournisseur createInstance() {
		ArticleFournisseur articleFournisseur = new ArticleFournisseur();
		return articleFournisseur;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Article article = articleHome.getDefinedInstance();
		if (article != null) {
			getInstance().setArticle(article);
		}
		/*
		Fournisseur fournisseur = fournisseurHome.getDefinedInstance();
		if (fournisseur != null) {
			getInstance().setFournisseur(fournisseur);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getArticle() == null)
			return false;
		if (getInstance().getFournisseur() == null)
			return false;
		return true;
	}

	public ArticleFournisseur getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void fournisseurChanged(ValueChangeEvent event)
	{
		Fournisseur fournisseur=(Fournisseur)event.getNewValue();
		
		if(fournisseur!=null)
		{
			getInstance().setFournisseur(fournisseur);
			logger.info(">>>>>>>>>>>>>>>>> Fournisseur changed : "+fournisseur.getLibelleTiers());
		}
	}

}
