package com.agritrace.session;

import com.agritrace.entity.articles.*;
import com.agritrace.entity.unitesMesure.UniteMesure;
import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("articleHome")
public class ArticleHome<E> extends EntityHome<Article> {

	@In(create = true)
	UniteMesureHome uniteMesureHome;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
	
	private String unite;
	
	public String getUnite() 
	{
		return (getInstance().getUniteMesure()!=null ? getInstance().getUniteMesure().getSymboleUom() : this.unite);
	}
	
	public void setUnite(String unite) 
	{
		this.unite = unite;
		setInstanceUom();
	}
	
	public void setInstanceUom()
	{
		UniteMesure uniteMesure = null;
		
		try
		{
			uniteMesure = (UniteMesure)entityManager.createQuery("select uniteMesure from UniteMesure uniteMesure " +
			"where uniteMesure.symboleUom =:uom")
			.setParameter("uom", this.unite)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		
		catch(NoResultException nre){}

		if(uniteMesure!=null)
		{
			getInstance().setUniteMesure(uniteMesure);
		}
	}
	
	public void setArticleIdArticle(Long id) {
		setId(id);
	}

	public Long getArticleIdArticle() {
		return (Long) getId();
	}

	@Override
	protected Article createInstance() {
		Article article = new Article();
		return article;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		UniteMesure uniteMesure = uniteMesureHome.getDefinedInstance();
		if (uniteMesure != null) {
			getInstance().setUniteMesure(uniteMesure);
		}
	}

	public boolean isWired() {
		if (getInstance().getUniteMesure() == null)
			return false;
		return true;
	}

	public Article getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<ArticleFournisseur> getListeFournisseursArticles() 
	{
		return getInstance() == null ? null
				: new ArrayList<ArticleFournisseur>(getInstance()
						.getListeFournisseursArticles());
	}

	public void uniteMesureChanged(ValueChangeEvent event)
	{
		String uom = (String)event.getNewValue();
		
		if(!uom.trim().equals("") )
		{
			logger.info("Unité mesure changed :"+uom);
			setUnite(uom);
		}
	}
	
}
