package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("articleList")
public class ArticleList extends EntityQuery<Article> {


	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select article from Article article";

	private static final String[] RESTRICTIONS = 
	{
			"lower(article.designation) like lower(concat(#{articleList.article.designation},'%'))", 
	};

	private Article article = new Article();

	public ArticleList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Article getArticle() {
		return article;
	}
	
	
	@SuppressWarnings("unchecked")
	@Factory("listeArticles")
	public List<String> getListeArticles()
	{
		return entityManager.createQuery("select article.designation from Article article order by article.designation asc")
		.getResultList();
	}
}
