package com.agritrace.session;


import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.log.Log;
import org.jboss.seam.security.Credentials;
import org.jboss.seam.security.Identity;

import com.agritrace.entity.userRoles.Users;
import com.agritrace.utils.Parametre;


@Name("authenticator")
public class Authenticator
{
	@In
	private EntityManager entityManager;
	
    @Logger private Log log;

    @In Identity identity;
    
    @In(create = true)
    CampagneSession campagneSession;
    
    @In(create = true)
    DomaineSession domaineSession;
    
    @In Credentials credentials;
    
    @In(create=true)
    Parametre parametre;
    
    
    public boolean authenticate()
    {
    	
    	//////////////////////Mode super utilisateur///////////////////////////////
    	
    	if(credentials.getUsername().trim().equals("ardassdev") && credentials.getPassword().trim().equals("JEE_Seam"))
		{
			identity.addRole("Administrateur");
			
			////////////////////////////////////Chargement des campagnes/domaines aux super utilisateur/////////////
			campagneSession.setInstance(new Users(credentials.getUsername(), credentials.getPassword()));
			campagneSession.wire();
			domaineSession.setInstance(new Users(credentials.getUsername(), credentials.getPassword()));
			domaineSession.wire();
			/////////////////////////////////////////////////////////////////////////////////////////////////////////
			return true;
		}
    	
    	////////////////////////////////////////////////////////////////////////////
    	
    	/////////////////// Mode d'authentification simple ////////////////////////////
    	else
    	{
    		
    		Users user=null;
    		
    		try
    		{
    			user = (Users) entityManager.createQuery(

        		"from Users where username = :username and password = :password")

        		.setParameter("username", credentials.getUsername())

        		.setParameter("password", credentials.getPassword())

        		.getSingleResult();
    			
    			//////////////////////////////// Chargement des campagnes/domaines de l'utilisateur////////////////////
    			campagneSession.setInstance(user);
    			campagneSession.wire();
    			domaineSession.setInstance(user);
    			domaineSession.wire();
    			//////////////////////////////////////////////////////////////////////////////////////////////
    			
    			
    		}catch (NoResultException nre)
    		{
    			nre.getStackTrace();
    		}
    		
    		if (user != null) 
    		{
    			    int counter = parametre.getCounter();
    			    
    			    if(counter < 400)  
    			    {
    			    	//L'utilisateur n'a pas encore atteint 400 connexion au système
    			    	
    			    	log.info("Athenticator : Valeur du compteur pré-incrémentation : "+parametre.getCounter());
        			    
        			    counter++; 
        			    
        			    parametre.setCounter(counter);
        			    
        				log.info("Athenticator : Valeur du compteur post-incrémentation : "+parametre.getCounter());
        				
        				identity.addRole(user.getLibelleRole());
        				
    					return true;
    			    }
    			    
    			    else
    			    {
    			    	//L'utilisateur a atteint 400 connexion au système
    			    	return false;
    			    }
    		}
    		else
    		{
    				return false;
    		}
    		
    	}

    }

}
