package com.agritrace.session;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.DetailsInterventionMo;
import com.agritrace.entity.production.Intervention;


@SuppressWarnings("serial")
@Name("bilanJournalierMo")
public class BilanJournalierMo extends EntityQuery<Intervention> 
{
	
	@Logger
	Log logger;
	
	private static final String EJBQL = "select intervention from Intervention intervention";
	
	private static final String[] RESTRICTIONS = 
	{
				"CAST(intervention.heureDebutIntervention AS date) = CAST(#{bilanJounalierMo.intervention.heureDebutIntervention} AS date)",
				"intervention.parcelleCulturale.parcelle.domaine.libelleDomaine = #{bilanJounalierMo.intervention.domaine}",
	};
	
	
	private Intervention intervention = new Intervention();

	private String domaine = "";
	
	public BilanJournalierMo() 
	{		
		InitEJBQL();
	}

	public Intervention getIntervention() 
	{
		return intervention;
	}
	
	public String getDomaine() {
		return domaine;
	}

	public void setDomaine(String domaine) {
		this.domaine = domaine;
	}

	public void InitEJBQL()
	{
		setEjbql(EJBQL);
        setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(14);
	}
	
	
	public List<BilanJournalierMoByOperation> getBilanMoJournalierByOperation()
	{
		//La liste contenant toute les interventions de la recherche selon 
		//la date et la campagne
		List<Intervention> listInterventionWithoutCost = this.getResultList();
		
		//La liste qui va contenir toute les détails de la Main d'oeuvre par Opération
		List<BilanJournalierMoByOperation> bilanJournalierMoList = new ArrayList<BilanJournalierMoByOperation>();
		
		for(Intervention intervention : listInterventionWithoutCost)
		{
			System.out.println("Intervention N° :"+intervention.getNumeroIntervention()+" Opération : "+intervention.getInstanceOfIntervention());
			
			BigDecimal coutMainOeuvre = new BigDecimal(0);
			
			////////////Instanciate an BilanJournalierMoByOperation object
			BilanJournalierMoByOperation bilanJournalierMoByOperation=new BilanJournalierMoByOperation();
		
			////////////Add the first attribute  : Intervention Object
			bilanJournalierMoByOperation.setIntervention(intervention);
			
			///////////Add the second attribute  : Effectif de la main d'oeuvre
			bilanJournalierMoByOperation.setEffectifMo(intervention.getDetailsInterventionMo()== null ? 
													0 : intervention.getDetailsInterventionMo().size());
			
			///////////Add the third attribute  :  Cout de la main d'oeuvre
			
			for(DetailsInterventionMo detailsMainOeuvre : intervention.getDetailsInterventionMo())
			{
				System.out.println("Personnel Salaire :"+detailsMainOeuvre.getPersonnel().getLastAffectationPersonnel().getSalaire());
				coutMainOeuvre = coutMainOeuvre.add(detailsMainOeuvre.getPersonnel().getLastAffectationPersonnel().getSalaire());
				System.out.println("Cout M.O actuel :"+coutMainOeuvre);
			}
			
			bilanJournalierMoByOperation.setCoutMo(coutMainOeuvre);
			
			System.out.println("************************Cout M.O de l'ntervention :"+intervention.getNumeroIntervention()+
													 " Est :"+coutMainOeuvre);
			
			///////////////////////Ajout de l'objet bilanJournalierMoByOperation à la liste////////
			bilanJournalierMoList.add(bilanJournalierMoByOperation);
			
		}
		
		return bilanJournalierMoList;
	}
	
}
