package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("caisseRamassageList")
public class CaisseRamassageList extends EntityQuery<CaisseRamassage> 
{
	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select caisseRamassage from CaisseRamassage caisseRamassage";

	private static final String[] RESTRICTIONS = 
	{
		"lower(caisseRamassage.designation) like lower(concat(#{caisseRamassageList.caisseRamassage.designation},'%'))", 
		"caisseRamassage.caissePalette like #{caisseRamassageList.caisseRamassage.caissePalette}", 
	};

	private CaisseRamassage caisseRamassage = new CaisseRamassage();

	public CaisseRamassageList() 
	{
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public CaisseRamassage getCaisseRamassage() {
		return caisseRamassage;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeCaissesPalettes")
	public List<String> getListeCaissesPalettes()
	{
		return entityManager.createQuery("select caisseRamassage.designation from CaisseRamassage caisseRamassage " +
								"order by caisseRamassage.designation asc").getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeCaisses")
	public List<String> getListeCaisses()
	{
		return entityManager.createQuery("select caisseRamassage.designation from CaisseRamassage caisseRamassage where " +
				"caisseRamassage.caissePalette = 'Caisse'").getResultList();
	}
}
