package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.convention.Campagne;

@Name("campagneList")
public class CampagneList extends EntityQuery<Campagne> {

	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select campagne from Campagne campagne";

	private static final String[] RESTRICTIONS = {
			"lower(campagne.campagne) like lower(concat(#{campagneList.campagne.campagne},'%'))",
			"lower(campagne.description) like lower(concat(#{campagneList.campagne.description},'%'))", };

	private Campagne campagne = new Campagne();

	public CampagneList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Campagne getCampagne() {
		return campagne;
	}
	
	
	@Factory("listeCampagne")
	public List<Campagne> getListeCampagne()
	{
		return entityManager.createQuery(this.EJBQL).getResultList();
	}
}
