package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.userRoles.Users;

@Name("campagneSession")
@Scope(value=ScopeType.SESSION)
public class CampagneSession extends EntityHome<Users>
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@In
	private EntityManager entityManager;
	
	private List<String> listeCampagne = new ArrayList<String>();
	
	private String campagneCourante="";
	
	private Campagne campagne=null;
	
	@Logger
	Log logger;
	
	//private String campagneChoosed=null;
	//private Campagne campagneAdmin=null;
	
	
	public Campagne getCampagne() {
		return campagne;
	}

	public void setCampagne(Campagne campagne) {
		this.campagne = campagne;
	}

	public String getCampagneCourante() {
		return campagneCourante;
	}

	public void setCampagneCourante(String campagneCourante) {
		this.campagneCourante = campagneCourante;
	}
	
	public void campagneChanged(ValueChangeEvent event)  
	{
		logger.info("********************************** campagneChaged () Déclenchée !!!!!!!!!!!!!!!!!!");
		
		campagneCourante =  (String)event.getNewValue();
		
		if(!campagneCourante.trim().equals(""))
		{
			try
			{
				campagne=(Campagne)entityManager.createQuery("select campagne from Campagne campagne where campagne.campagne=:campagne")
				.setParameter("campagne", campagneCourante).getSingleResult();
				logger.info("************ L'objet campagné sélectionné est : >>>>>>>>>>>>>>>>>>>>>>>>>>>>>"+campagne.getCampagne());
			}
			catch(Exception ex)
			{
				ex.getStackTrace();
				campagne=null;
				logger.info("Une exception a été déclenché durant le chargement de la campagne sélectionnée !!!!!!!!!!!!!!");
			}
			
		}
		else
		{
			this.campagne=null;
			this.campagneCourante="";
			logger.info("Aucune campagne n'a été sélectionné !!!!!!!!!!!!!!!!!!!!!!!");
		}
	}
	
	@SuppressWarnings("unchecked")
	public void wire() 
	{
		listeCampagne =new ArrayList<String>();

		/// Le super utilisateur et l'administrateur peuvent accéder à toutes les campagnes
		if(getInstance().getUsername().equals("ardassdev") || getInstance().getLibelleRole().equals("Administrateur"))
		{
				
			listeCampagne.addAll(entityManager.createQuery("select campagne.campagne from Campagne campagne order by campagne.campagne asc")
			.getResultList());
			
		}
		else
		{
			/// Chaque utilisateur accède aux domaines qui lui ont été affecté
			
			listeCampagne.addAll(entityManager.createQuery("select userAffectationCampagne.campagne.campagne from UserAffectationCampagne userAffectationCampagne " +
			" where userAffectationCampagne.user.username =:username order by userAffectationCampagne.campagne.campagne asc")
			.setParameter("username", getInstance().getUsername())
			.getResultList());
		}
		
		logger.info("************************************************************* [CampagneSession : wire()] : Taille de la CampagneListe :"+listeCampagne.size());
	}

	public List<String> getListeCampagne() {
		return listeCampagne;
	}


}
