package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.domaine.Certification;

@Name("certificationList")
public class CertificationList extends EntityQuery<Certification> {
	
	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select certification from Certification certification";

	private static final String[] RESTRICTIONS = { "lower(certification.libelleCertification) like lower(concat(#{certificationList.certification.libelleCertification},'%'))", };

	private Certification certification = new Certification();

	public CertificationList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Certification getCertification() {
		return certification;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeCertifications")
	public List<String> getListeCertifications()
	{
		return entityManager.createQuery("select certification.libelleCertification from Certification certification " +
				"order by certification.libelleCertification asc").getResultList();
	}
	
	
}
