package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.domaine.Certification;
import com.agritrace.entity.domaine.CertificationsDomaine;
import com.agritrace.entity.domaine.Domaine;

@Name("certificationsDomaineHome")
public class CertificationsDomaineHome extends
		EntityHome<CertificationsDomaine> {

	@In(create = true)
	CertificationHome certificationHome;
	
	@In(create = true)
	DomaineHome domaineHome;
	
	private String certification;
	
	@In
	EntityManager entityManager;
	
	@Logger
	Log logger;

	public String getCertification() {
		return (getInstance().getCertification()!= null ? getInstance().getCertification().getLibelleCertification() : certification);
	}

	public void setCertification(String certification) {
		this.certification = certification;
		setCertificationInstance();
	}

	private void setCertificationInstance() {
		// TODO Auto-generated method stub
		
		Certification certificationInstance = null;
		
		if(!certification.trim().equals(""))
		{
			certificationInstance = (Certification) entityManager.createQuery("select certification from Certification certification where " +
					"certification.libelleCertification = :param")
					.setParameter("param", certification)
					.getSingleResult();
			
		}
		
		if(certificationInstance!=null)
		{
			getInstance().setCertification(certificationInstance);
		}
	}

	public void setCertificationsDomaineIdCertificationsDomaine(Integer id) {
		setId(id);
	}

	public Integer getCertificationsDomaineIdCertificationsDomaine() {
		return (Integer) getId();
	}

	@Override
	protected CertificationsDomaine createInstance() {
		CertificationsDomaine certificationsDomaine = new CertificationsDomaine();
		return certificationsDomaine;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Certification certification = certificationHome.getDefinedInstance();
		if (certification != null) {
			getInstance().setCertification(certification);
		}
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getCertification() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public CertificationsDomaine getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void certificationChanged(ValueChangeEvent event)
	{
		String designation = (String)event.getNewValue();
		
		if(designation!=null)
		{
			setCertification(designation);
			logger.info(">>>>>>>>>>>>>>> Certification changed !!");
		}
	}

}
