package com.agritrace.session;

import com.agritrace.entity.domaine.*;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("chateauEauHome")
public class ChateauEauHome extends EntityHome<ChateauEau> {

	@In(create = true)
	DomaineHome domaineHome;

	public void setChateauEauIdChateauEau(Long id) {
		setId(id);
	}

	public Long getChateauEauIdChateauEau() {
		return (Long) getId();
	}

	@Override
	protected ChateauEau createInstance() {
		ChateauEau chateauEau = new ChateauEau();
		return chateauEau;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public ChateauEau getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

}
