package com.agritrace.session;

import com.agritrace.entity.domaine.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("chateauEauList")
public class ChateauEauList extends EntityQuery<ChateauEau> {

	
	@In(create=true)
	DomaineSession domaineSession;
	
	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select chateauEau from ChateauEau chateauEau";

	private static final String[] RESTRICTIONS = {
			"lower(chateauEau.description) like lower(concat(#{chateauEauList.chateauEau.description},'%'))",
			"lower(chateauEau.numeroChateauEau) like lower(concat(#{chateauEauList.chateauEau.numeroChateauEau},'%'))", 
			"chateauEau.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",		
	};

	private ChateauEau chateauEau = new ChateauEau();

	public ChateauEauList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public ChateauEau getChateauEau() {
		return chateauEau;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeChateaux")
	public List<ChateauEau> getListeChateaux()
	{
		return entityManager.createQuery("select chateauEau.numeroChateauEau from ChateauEau chateauEau " +
				"where chateauEau.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}").getResultList();
	}
	
}
