package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("ciblesLutteBiologiqueHome")
public class CiblesLutteBiologiqueHome extends
		EntityHome<CiblesLutteBiologique> {

	@In(create = true)
	EnnemisCultureHome ennemisCultureHome;
	@In(create = true)
	LutteBiologiqueHome lutteBiologiqueHome;
	
	@Logger
	Log logger;

	public void setCiblesLutteBiologiqueIdCiblesLutteBiologique(Long id) {
		setId(id);
	}

	public Long getCiblesLutteBiologiqueIdCiblesLutteBiologique() {
		return (Long) getId();
	}

	@Override
	protected CiblesLutteBiologique createInstance() {
		CiblesLutteBiologique ciblesLutteBiologique = new CiblesLutteBiologique();
		return ciblesLutteBiologique;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		EnnemisCulture ennemisCulture = ennemisCultureHome.getDefinedInstance();
		if (ennemisCulture != null) {
			getInstance().setEnnemisCulture(ennemisCulture);
		}
		LutteBiologique lutteBiologique = lutteBiologiqueHome
				.getDefinedInstance();
		if (lutteBiologique != null) {
			getInstance().setLutteBiologique(lutteBiologique);
		}
	}

	public boolean isWired() {
		if (getInstance().getEnnemisCulture() == null)
			return false;
		if (getInstance().getLutteBiologique() == null)
			return false;
		return true;
	}

	public CiblesLutteBiologique getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void ennemiChanged(ValueChangeEvent event)
	{
		EnnemisCulture ennemisCulture = (EnnemisCulture)event.getNewValue();
		
		logger.info("*********** Objet EnnemisCulture changed : "+ennemisCulture.getLibelleEnnemiCulture());
		
		getInstance().setEnnemisCulture(ennemisCulture);
		
	}
	
}
