package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.CiblesPesticides;
import com.agritrace.entity.articles.Culture;
import com.agritrace.entity.articles.EnnemisCulture;
import com.agritrace.entity.articles.Pesticide;

@Name("ciblesPesticidesHome")
public class CiblesPesticidesHome extends EntityHome<CiblesPesticides> {


	@In(create = true)
	EnnemisCultureHome ennemisCultureHome;
	
	@In(create = true)
	PesticideHome pesticideHome;
	
	/*
	@In(create = true)
	UniteMesureHome uniteMesureHome;
	*/
	
	@In(create = true)
	CultureHome cultureHome;
	
	@Logger
	Log logger;
	

	public void setCiblesPesticidesIdCiblesPesticides(Long id) {
		setId(id);
	}

	public Long getCiblesPesticidesIdCiblesPesticides() {
		return (Long) getId();
	}

	@Override
	protected CiblesPesticides createInstance() {
		CiblesPesticides ciblesPesticides = new CiblesPesticides();
		return ciblesPesticides;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		EnnemisCulture ennemisCulture = ennemisCultureHome.getDefinedInstance();
		if (ennemisCulture != null) {
			getInstance().setEnnemisCulture(ennemisCulture);
		}
		Pesticide pesticide = pesticideHome.getDefinedInstance();
		if (pesticide != null) {
			getInstance().setPesticide(pesticide);
		}
		
		/*
		UniteMesure uniteMesure = uniteMesureHome.getDefinedInstance();
		if (uniteMesure != null) {
			getInstance().setUniteMesure(uniteMesure);
		}
		*/
		
		Culture culture = cultureHome.getDefinedInstance();
		if (culture != null) 
		{
			getInstance().setCulture(culture);
		}
	}

	public boolean isWired() {
		if (getInstance().getEnnemisCulture() == null)
			return false;
		if (getInstance().getPesticide() == null)
			return false;
		if (getInstance().getCulture() == null)
			return false;
		return true;
	}

	public CiblesPesticides getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	/*
	public void uniteChanged(ValueChangeEvent event)
	{
		UniteMesure uniteMesure = (UniteMesure)event.getNewValue();
		
		if(uniteMesure!=null)
		{
			System.out.println("****************** Une nouvelle unité de mesure a été choisi : "+uniteMesure.getSymboleUom());
			getInstance().setUniteMesure(uniteMesure);
		}
	}
	*/
	
	public void cultureChanged(ValueChangeEvent event)
	{
		Culture culture = (Culture)event.getNewValue();
		
		logger.info("*********** Objet culture changed : "+culture.getDesignationCulture());
		
		getInstance().setCulture(culture);
		
	}

	public void ennemiChanged(ValueChangeEvent event)
	{
		EnnemisCulture ennemisCulture = (EnnemisCulture)event.getNewValue();
		
		logger.info("*********** Objet EnnemisCulture changed : "+ennemisCulture.getLibelleEnnemiCulture());
		
		getInstance().setEnnemisCulture(ennemisCulture);
		
	}
	
}
