package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.EnnemisCulture;
import com.agritrace.entity.production.CiblesTraitementPhyto;
import com.agritrace.entity.production.Intervention;

@Name("ciblesTraitementPhytoHome")
public class CiblesTraitementPhytoHome extends
		EntityHome<CiblesTraitementPhyto> {

	@In(create = true)
	EnnemisCultureHome ennemisCultureHome;
	
	@In(create = true)
	InterventionHome interventionHome;
	
	@In(create=true)
	EntityManager entityManager;
	
	private String ennemi=null;
	
	@Logger
	Log logger;

	public String getEnnemi() {
		return (getInstance().getEnnemisCulture()!=null ? getInstance().getEnnemisCulture().getLibelleEnnemiCulture() : ennemi);
	}

	public void setEnnemi(String ennemi) 
	{
		this.ennemi = ennemi;
		setInstanceEnnemi();
	}

	public void setCiblesTraitementPhytoIdCiblesTraitementPhyto(Long id) {
		setId(id);
	}

	public Long getCiblesTraitementPhytoIdCiblesTraitementPhyto() {
		return (Long) getId();
	}

	@Override
	protected CiblesTraitementPhyto createInstance() {
		CiblesTraitementPhyto ciblesTraitementPhyto = new CiblesTraitementPhyto();
		return ciblesTraitementPhyto;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	
	@Override
	public String persist() {

		return super.persist();
	}

	
	@Override
	public String update() {
		
		return super.update();
	}

	public void wire() {
		
		getInstance();

		Intervention intervention = interventionHome.getDefinedInstance();
		if (intervention != null) {
			getInstance().setIntervention(intervention);
		}
		
		
	}
	
	public void setInstanceEnnemi()
	{
		EnnemisCulture  ennemisCulture=null;
		
		if(!this.ennemi.trim().equals(""))
		{
			try
			{
				ennemisCulture = (EnnemisCulture) entityManager.createQuery("select ennemisCulture from EnnemisCulture ennemisCulture where " +
												"ennemisCulture.libelleEnnemiCulture =:nom ")
				.setParameter("nom", this.ennemi)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(ennemisCulture!=null)
			{
				getInstance().setEnnemisCulture(ennemisCulture);
			}
		}
		
	}

	public boolean isWired() {
		if (getInstance().getIntervention() == null || getInstance().getEnnemisCulture() == null)
			return false;
		
		return true;
	}

	public CiblesTraitementPhyto getDefinedInstance() 
	{
		return isIdDefined() ? getInstance() : null;
	}
	
	public void ennemiChanged(ValueChangeEvent event)
	{
		String ennemiSelected=(String)event.getNewValue();
		
		if(!ennemiSelected.trim().equals(""))
		{
			setEnnemi(ennemiSelected);
			logger.info(">>>>>>>>>>>>>>>>> Ennemi changed : "+ennemiSelected);
		}
		else
		{
			setEnnemi(null);
		}
	}

}
