package com.agritrace.session;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Client;

@Name("clientHome")
public class ClientHome extends TiersHome<Client> {

	@In(create=true)
	DomaineSession domaineSession;
	
	public void setClientIdTiers(Integer id) {
		setId(id);
	}

	public Integer getClientIdTiers() {
		return (Integer) getId();
	}

	@Override
	protected Client createInstance() {
		Client client = new Client();
		return client;
	}
	
	public Client getInstance() {
		return (Client) super.getInstance();
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		Domaine domaine = domaineSession.getDomaine();
		
		getInstance().setDomaine(domaine);
		
	}

	public boolean isWired() 
	{
		return true;
	}

	public Client getDefinedInstance() {
		return isIdDefined() ? (Client)getInstance() : null;
	}

}
