package com.agritrace.session;

import com.agritrace.entity.tiers.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("clientList")
public class ClientList extends EntityQuery<Client> {

	@In
	EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select client from Client client";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(client.libelleTiers) like lower(concat(#{clientList.client.libelleTiers},'%'))", 
	};

	private Client client = new Client();

	public ClientList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Client getClient() {
		return client;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeClients")
	public List<Client> getListeClient()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeClient")
	public List<Client> getListeClients()
	{
		return entityManager.createQuery("select client.libelleTiers from Client client order by client.libelleTiers asc").getResultList();
	}
}
