package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("commandeList")
public class CommandeList extends EntityQuery<Commande> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	
	private static final String EJBQL = "select commande from Commande commande";

	private static final String[] RESTRICTIONS = {
			"lower(commande.numeroCommande) like lower(concat(#{commandeList.commande.numeroCommande},'%'))",
			"commande.campagne.campagne = #{campagneSession.campagne.campagne}",
			"commande.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Commande commande = new Commande();
	
	public CommandeList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Commande getCommande() {
		return commande;
	}
}
