package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.CompatibiliteLutteBiologique;
import com.agritrace.entity.articles.LutteBiologique;
import com.agritrace.entity.articles.Pesticide;

@Name("compatibiliteLutteBiologiqueHome")
public class CompatibiliteLutteBiologiqueHome extends
		EntityHome<CompatibiliteLutteBiologique> {

	@In(create = true)
	PesticideHome pesticideHome;
	
	/*
	@In(create = true)
	LutteBiologiqueHome lutteBiologiqueHome;
	 */
	
	@Logger
	Log logger;
	
	
	public void setCompatibiliteLutteBiologiqueIdCompatibiliteLutteBio(Long id) {
		setId(id);
	}

	public Long getCompatibiliteLutteBiologiqueIdCompatibiliteLutteBio() {
		return (Long) getId();
	}

	@Override
	protected CompatibiliteLutteBiologique createInstance() {
		CompatibiliteLutteBiologique compatibiliteLutteBiologique = new CompatibiliteLutteBiologique();
		return compatibiliteLutteBiologique;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Pesticide pesticide = pesticideHome.getDefinedInstance();
		if (pesticide != null) {
			getInstance().setPesticide(pesticide);
		}
		
		/*LutteBiologique lutteBiologique = lutteBiologiqueHome.getDefinedInstance();
		if (lutteBiologique != null) {
			getInstance().setLutteBiologique(lutteBiologique);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getPesticide() == null)
			return false;
		if (getInstance().getLutteBiologique() == null)
			return false;
		return true;
	}

	public CompatibiliteLutteBiologique getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void auxiliaireChanged(ValueChangeEvent event)
	{
	
		LutteBiologique lutteBiologique = (LutteBiologique) event.getNewValue();
		
		if (lutteBiologique != null) 
		{
			getInstance().setLutteBiologique(lutteBiologique);
			logger.info("************** Auxiliaire changed : "+lutteBiologique.getDesignation());
			
		}
		
	}

}
