package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.convention.Convention;
import com.agritrace.entity.convention.LignesConvention;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Client;

@Name("conventionHome")
public class ConventionHome extends EntityHome<Convention> {

	/*
	@In(create = true)
	CampagneHome campagneHome;
	*/
	
	@In(create = true)
	ClientHome clientHome;

	@In(create=true)
	CampagneSession campagneSession;
	
	@In
	DomaineSession domaineSession;
	
	@Logger
	Log logger;
	
	private String nomClient;
	
	@In
	EntityManager entityManager;
	
	
	public String getNomClient() 
	{
		return (getInstance().getClient()!=null ? getInstance().getClient().getLibelleTiers() : this.nomClient);
	}

	public void setNomClient(String nomClient) 
	{
		this.nomClient = nomClient;
		setInstanceClient();
	}

	
	private void setInstanceClient() 
	{
		Client clientInstance =null;
		
		if(!this.nomClient.equals(""))
		{
			try
			{
				clientInstance = (Client)entityManager.createQuery("select client from Client client where " +
												"client.libelleTiers =:param")
				.setParameter("param", this.nomClient)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(clientInstance!=null)
			{
				getInstance().setClient(clientInstance);
			}
		}
	}

	public void setConventionIdConvention(Long id) {
		setId(id);
	}

	public Long getConventionIdConvention() {
		return (Long) getId();
	}

	@Override
	protected Convention createInstance() {
		Convention convention = new Convention();
		return convention;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		System.out.println("Pre-Affectatation campagne => convention");
		
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
			
			System.out.println("Post-Affectatation campagne => convention");
		}
		
		/*
		Client client = clientHome.getDefinedInstance();
		if (client != null) {
			getInstance().setClient(client);
		}
		*/
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		if (getInstance().getClient() == null)
			return false;
		return true;
	}

	public Convention getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<LignesConvention> getLignesConvention() {
		return getInstance() == null ? null : new ArrayList<LignesConvention>(
				getInstance().getLignesConvention());
	}

	public void clientChanged(ValueChangeEvent event)
	{
		String nomClient=(String)event.getNewValue();
		
		if(!nomClient.trim().equals(""))
		{
			setNomClient(nomClient);
			logger.info(">>>>>>>>>>>>>>>>> Client changed : "+nomClient);
		}
	}
	
}
