package com.agritrace.session;

import java.util.Arrays;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.convention.Convention;

@Name("conventionList")
public class ConventionList extends EntityQuery<Convention> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select convention from Convention convention";
		
	private static final String[] RESTRICTIONS = 
	{ 
		"lower(convention.numeroConvention) like lower(concat(#{conventionList.convention.numeroConvention},'%'))",
		"convention.campagne.campagne = #{campagneSession.campagne.campagne}",
		"convention.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Convention convention = new Convention();
	

	public ConventionList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Convention getConvention() {
		return convention;
	}
	
}
