package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

import com.agritrace.entity.articles.Culture;
import com.agritrace.entity.articles.Espece;
import com.agritrace.entity.articles.TypeCulture;

@Name("cultureHome")
public class CultureHome extends EntityHome<Culture> {

	
	@In(create = true)
	EspeceHome especeHome;
	
	
	public void setCultureIdCulture(Long id) {
		setId(id);
	}

	public Long getCultureIdCulture() {
		return (Long) getId();
	}

	@Override
	protected Culture createInstance() {
		Culture culture = new Culture();
		return culture;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		
		Espece espece = especeHome.getDefinedInstance();
		if (espece != null) {
			getInstance().setEspece(espece);
		}
		
	}

	public boolean isWired() {
		if (getInstance().getEspece() == null)
			return false;
		return true;
	}

	public Culture getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	
	public List<TypeCulture> getListeTypesCultures() {
		return getInstance() == null ? null : new ArrayList<TypeCulture>(
				getInstance().getListeTypesCultures());
	}
	
	
	/*
	public void especeChanged(ValueChangeEvent event)
	{
		System.out.println("EspeceChanged declenchée -----------------------");
		
		Espece espece = (Espece)event.getNewValue();
		
		if (espece != null) 
		{
			getInstance().setEspece(espece);
		}
	}

*/
}
