package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("cultureList")
public class CultureList extends EntityQuery<Culture> {
	

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select culture from Culture culture";

	private static final String[] RESTRICTIONS = {
			"lower(culture.description) like lower(concat(#{cultureList.culture.description},'%'))",
			"lower(culture.designationCulture) like lower(concat(#{cultureList.culture.designationCulture},'%'))", };

	private Culture culture = new Culture();

	public CultureList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Culture getCulture() {
		return culture;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeCultures")
	public List<String> getListeCultures()
	{
		return entityManager.createQuery("select culture.designationCulture from Culture culture " +
				"order by culture.designationCulture asc").getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listesCultures")
	public List<String> getListesCultures()
	{
		return entityManager.createQuery("select culture from Culture culture " +
				"order by culture.designationCulture asc").getResultList();
	}
	
}
