package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.CyclePlanningProduction;
import com.agritrace.entity.production.ParcelleCulturale;
import com.agritrace.entity.production.PlanningProduction;

@Name("cyclePlanningProductionHome")
public class CyclePlanningProductionHome extends EntityHome<CyclePlanningProduction> {


	@In(create = true)
	PlanningProductionHome planningProductionHome;
	
	@Logger
	Log logger;

	public void setCyclePlanningProductionIdCyclePlanningProduction(Long id) {
		setId(id);
	}

	public Long getCyclePlanningProductionIdCyclePlanningProduction() {
		return (Long) getId();
	}

	@Override
	protected CyclePlanningProduction createInstance() {
		CyclePlanningProduction cyclePlanningProduction = new CyclePlanningProduction();
		return cyclePlanningProduction;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		PlanningProduction planningProduction = planningProductionHome
				.getDefinedInstance();
		if (planningProduction != null) {
			getInstance().setPlanningProduction(planningProduction);
		}
		
		//Call method getCycleNumber
		getCycleNumber();
	}

	public boolean isWired() {
		
		if (getInstance().getPlanningProduction() == null)
			return false;
		return true;
	}

	public CyclePlanningProduction getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<ParcelleCulturale> getListePlanningsParcelle() {
		return getInstance() == null ? null : new ArrayList<ParcelleCulturale>(
				getInstance().getListePlanningsParcelle());
	}
	
	public void getCycleNumber()
	{

		if(!this.isManaged())
		{
			//Récupération de l'objet planningProduction concerné
			PlanningProduction currentPlanning=getInstance().getPlanningProduction();
			
			//String cycleNumber à affecter à l'objet CycleProduction
			int cycleNumber =0;
			
			int cycles=currentPlanning.getCyclesPlanningProduction().size();
			
			if(cycles==0)
			{
				cycleNumber=1;
			}
			else
			{
				//Récupération du dernier objet CycleProduction ajouté
				List<CyclePlanningProduction> listeCyclePlanningProduction=new ArrayList
										<CyclePlanningProduction>(currentPlanning.getCyclesPlanningProduction()); 
				
				CyclePlanningProduction lastCycleAdded= listeCyclePlanningProduction.get((listeCyclePlanningProduction.size())-1);
				
				//N° du dernier cycle de production ajouté 
				int lastCycleNumberAdded = lastCycleAdded.getNumeroCycle();
				
				//Incrémentation du lastCycleNumberAdded puis l'affecter au cycleNumber
				cycleNumber=++lastCycleNumberAdded;
			 }
			
			 /////Affectation du cycleNumber à l'instance cyclePlanningProduction en cours
			 getInstance().setNumeroCycle(cycleNumber);
		}
		
	}

}
