package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.EnnemisCulture;
import com.agritrace.entity.production.AnalysePlantes;
import com.agritrace.entity.production.DetailsAnalyseRavageurs;

@Name("detailsAnalyseRavageursHome")
public class DetailsAnalyseRavageursHome extends
		EntityHome<DetailsAnalyseRavageurs> {

	@In(create = true)
	AnalysePlantesHome analysePlantesHome;
	
	@In(create = true)
	EnnemisCultureHome ennemisCultureHome;
	
	private String ennemi=null;
	
	@In(create=true)
	EntityManager entityManager;

	@Logger
	Log logger;

	public void setEnnemi(String ennemi) {
		this.ennemi = ennemi;
		setInstanceEnnemi();
	}

	public String getEnnemi() {
		return (getInstance().getEnnemisCulture()!=null ? getInstance().getEnnemisCulture().getLibelleEnnemiCulture() : ennemi);
	}


	
	public void setDetailsAnalyseRavageursIdDetailsAnalyseRavageurs(Long id) {
		setId(id);
	}

	public Long getDetailsAnalyseRavageursIdDetailsAnalyseRavageurs() {
		return (Long) getId();
	}

	@Override
	protected DetailsAnalyseRavageurs createInstance() {
		DetailsAnalyseRavageurs detailsAnalyseRavageurs = new DetailsAnalyseRavageurs();
		return detailsAnalyseRavageurs;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() 
	{
		getInstance();
		
		AnalysePlantes analysePlantes = analysePlantesHome.getDefinedInstance();
		if (analysePlantes != null) {
			getInstance().setAnalysePlantes(analysePlantes);
		}
		
		/*
		EnnemisCulture ennemisCulture  = ennemisCultureHome.getDefinedInstance();
		if (ennemisCulture != null) {
			getInstance().setEnnemisCulture(ennemisCulture);
		}
		*/
	}
	
	public void setInstanceEnnemi()
	{
		EnnemisCulture  ennemisCulture=null;
		
		if(!this.ennemi.trim().equals(""))
		{
			try
			{
				ennemisCulture = (EnnemisCulture) entityManager.createQuery("select ennemisCulture from EnnemisCulture ennemisCulture where " +
												"ennemisCulture.libelleEnnemiCulture =:nom ")
				.setParameter("nom", this.ennemi)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(ennemisCulture!=null)
			{
				getInstance().setEnnemisCulture(ennemisCulture);
			}
		}
		
	}

	public boolean isWired() {
		if (getInstance().getAnalysePlantes() == null)
			return false;
		if (getInstance().getEnnemisCulture() == null)
			return false;
		return true;
	}

	public DetailsAnalyseRavageurs getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	
	public void ennemiChanged(ValueChangeEvent event)
	{
		String ennemiSelected=(String)event.getNewValue();
		
		if(!ennemiSelected.trim().equals(""))
		{
			setEnnemi(ennemiSelected);
			logger.info(">>>>>>>>>>>>>>>>> Ennemi changed : "+ennemiSelected);
		}
		else
		{
			setEnnemi(null);
		}
	}
}
