package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.domaine.ChateauEau;
import com.agritrace.entity.production.DetailsChateauxNettoyage;
import com.agritrace.entity.production.NettoyageChateauEau;

@Name("detailsChateauxNettoyageHome")
public class DetailsChateauxNettoyageHome extends EntityHome<DetailsChateauxNettoyage> {

	@In(create = true)
	ChateauEauHome chateauEauHome;
	
	@In(create=true)
	NettoyageChateauEauHome nettoyageChateauEauHome;
	
	private String numeroChateau;
	
	@In(create = true)
	EntityManager entityManager;
	
	@Logger
	Log logger;

	
	public String getNumeroChateau() 
	{
		return (getInstance().getChateauEau()!=null ? getInstance().getChateauEau().getNumeroChateauEau() : this.numeroChateau);
	}

	public void setNumeroChateau(String numeroChateau) {
		this.numeroChateau = numeroChateau;
		setInstanceChateau();
		
	}

	public void setInstanceChateau()
	{
		ChateauEau chateauEauInstance =null;
		
		if(!this.numeroChateau.equals(""))
		{
			try
			{
				chateauEauInstance = (ChateauEau)entityManager.createQuery("select chateauEau from ChateauEau chateauEau where " +
												"chateauEau.numeroChateauEau =:param")
				.setParameter("param", this.numeroChateau)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(chateauEauInstance!=null)
			{
				getInstance().setChateauEau(chateauEauInstance);
			}
		}
		
	}
	
	public void setDetailsChateauxNettoyageIdDetailsChateauxNettoyage(Long id) {
		setId(id);
	}

	public Long getDetailsChateauxNettoyageIdDetailsChateauxNettoyage() {
		return (Long) getId();
	}

	@Override
	protected DetailsChateauxNettoyage createInstance() {
		DetailsChateauxNettoyage detailsChateauxNettoyage = new DetailsChateauxNettoyage();
		return detailsChateauxNettoyage;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		ChateauEau chateauEau = chateauEauHome.getDefinedInstance();
		if (chateauEau != null) {
			getInstance().setChateauEau(chateauEau);
		}
		
		
		NettoyageChateauEau nettoyageChateauEau = nettoyageChateauEauHome
				.getDefinedInstance();
		if (nettoyageChateauEau != null) {
			getInstance().setNettoyageChateauEau(nettoyageChateauEau);
		}
		
	}

	public boolean isWired() {
		if (getInstance().getChateauEau() == null)
			return false;
		if (getInstance().getNettoyageChateauEau() == null)
			return false;
		return true;
	}

	public DetailsChateauxNettoyage getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void chateauChanged(ValueChangeEvent event)
	{
		String numeroChateau = (String)event.getNewValue();
			
		if(!numeroChateau.trim().equals(""))
		{
			setNumeroChateau(numeroChateau);
			logger.info(">>>>>>>>>>>>>>>>> Chateau changed : "+numeroChateau);
		}
		else
		{
			setNumeroChateau("");
		}
	}

}
