package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.DetailsInterventionCategorieMo;
import com.agritrace.entity.production.Intervention;
import com.agritrace.entity.tiers.FonctionPersonnel;

@Name("detailsInterventionCategorieMoHome")
public class DetailsInterventionCategorieMoHome extends
		EntityHome<DetailsInterventionCategorieMo> {

	/*
	@In(create = true)
	FonctionPersonnelHome fonctionPersonnelHome;
	*/
	
	@In(create = true)
	InterventionHome interventionHome;
	
	private String categorieMo;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;


	public void setDetailsInterventionCategorieMoIdDetailsInterventionCategorieMo(Long id) {
			setId(id);
	}

	public Long getDetailsInterventionCategorieMoIdDetailsInterventionCategorieMo() {
		return (Long) getId();
	}

	@Override
	protected DetailsInterventionCategorieMo createInstance() {
		DetailsInterventionCategorieMo detailsInterventionCategorieMo = new DetailsInterventionCategorieMo();
		return detailsInterventionCategorieMo;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		/*
		FonctionPersonnel categorieMo = fonctionPersonnelHome
				.getDefinedInstance();
		if (categorieMo != null) {
			getInstance().setCategorieMo(categorieMo);
		}
		*/
		
		Intervention intervention = interventionHome.getDefinedInstance();
		if (intervention != null) {
			getInstance().setIntervention(intervention);
		}
	}

	public boolean isWired() 
	{
		if (getInstance().getCategorieMo() == null)
			return false;
		if (getInstance().getIntervention() == null)
			return false;
		return true;
	}

	public DetailsInterventionCategorieMo getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void setCategorieMo(String categorieMo) {
		this.categorieMo = categorieMo;
		setInstanceCategorieMo();
		
	}

	public String getCategorieMo() {
		
		return (getInstance().getCategorieMo()!=null ? getInstance().getCategorieMo().getFonctionPersonnel() : this.categorieMo);
	}
	
	public void setInstanceCategorieMo()
	{
		FonctionPersonnel categorieMo = null;
		
		try
		{
			categorieMo = (FonctionPersonnel)entityManager.createQuery("select fonctionPersonnel from FonctionPersonnel fonctionPersonnel" +
			" where fonctionPersonnel.fonctionPersonnel =:param")
			.setParameter("param", this.categorieMo)
			.getSingleResult();
		}
		
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(categorieMo!=null)
		{
			getInstance().setCategorieMo(categorieMo);
		}
	}
	
	public void categorieMoChanged(ValueChangeEvent event)
	{
		String categorieMo = (String)event.getNewValue();
		
		if(!categorieMo.trim().equals(""))
		{
			logger.info("detailsInterventionCategorieMoHome : CategorieMoChanged() ", "La catégorie M.O a été changé : "+categorieMo);
			
			setCategorieMo(categorieMo);
			
		}
	}
	
}
