package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Materiel;
import com.agritrace.entity.production.DetailsInterventionMateriel;
import com.agritrace.entity.production.Intervention;

@Name("detailsInterventionMaterielHome")
public class DetailsInterventionMaterielHome extends
		EntityHome<DetailsInterventionMateriel> {

	@In(create = true)
	InterventionHome interventionHome;
	
	/*
	@In(create = true)
	MaterielHome materielHome;
	*/
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
	
	private String materiel;
	
	public void setDetailsInterventionMaterielIdDetailsInterventionMateriel(
			Long id) {
		setId(id);
	}

	public Long getDetailsInterventionMaterielIdDetailsInterventionMateriel() {
		return (Long) getId();
	}

	@Override
	protected DetailsInterventionMateriel createInstance() {
		DetailsInterventionMateriel detailsInterventionMateriel = new DetailsInterventionMateriel();
		return detailsInterventionMateriel;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Intervention intervention = interventionHome.getDefinedInstance();
		if (intervention != null) {
			getInstance().setIntervention(intervention);
		}
		
		/*
		Materiel materiel = materielHome.getDefinedInstance();
		if (materiel != null) {
			getInstance().setMateriel(materiel);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getIntervention() == null)
			return false;
		if (getInstance().getMateriel() == null)
			return false;
		return true;
	}

	public DetailsInterventionMateriel getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void setMateriel(String materiel) {
		this.materiel = materiel;
		setInstanceMateriel();
	}

	public String getMateriel() 
	{
		return (getInstance().getMateriel()!=null ? getInstance().getMateriel().getDesignation() : this.materiel);
	}
	
	public void setInstanceMateriel()
	{
		Materiel materiel = null;
		
		try
		{
			materiel = (Materiel)entityManager.createQuery("select materiel from Materiel materiel " +
			"where materiel.designation =:param")
			.setParameter("param", this.materiel)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(materiel!=null)
		{
			getInstance().setMateriel(materiel);
		}
	}
	
	public void materielChanged(ValueChangeEvent event)
	{
		String materiel = (String)event.getNewValue();
		
		if(!materiel.trim().equals("") )
		{
			logger.info("detailsInterventionMaterielHome : materielChanged() ", "Le matériel a été changé : "+materiel);
			
			setMateriel(materiel);
			
		}
	}

}
