package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.DetailsInterventionMo;
import com.agritrace.entity.production.Intervention;
import com.agritrace.entity.tiers.Personnel;

@Name("detailsInterventionMoHome")
public class DetailsInterventionMoHome extends
		EntityHome<DetailsInterventionMo> {

	@In(create = true)
	InterventionHome interventionHome;
	
	/*
	@In(create = true)
	PersonnelHome personnelHome;
	*/
	
	private String personnel;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
    
	public void setDetailsInterventionMoIdDetailsInterventionMo(Long id) {
		setId(id);
	}

	public Long getDetailsInterventionMoIdDetailsInterventionMo() {
		return (Long) getId();
	}

	@Override
	protected DetailsInterventionMo createInstance() {
		DetailsInterventionMo detailsInterventionMo = new DetailsInterventionMo();
		return detailsInterventionMo;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Intervention intervention = interventionHome.getDefinedInstance();
		if (intervention != null) {
			getInstance().setIntervention(intervention);
		}
		
		/*
		Personnel personnel = personnelHome.getDefinedInstance();
		if (personnel != null) {
			getInstance().setPersonnel(personnel);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getIntervention() == null)
			return false;
		if (getInstance().getPersonnel() == null)
			return false;
		return true;
	}

	public DetailsInterventionMo getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void setPersonnel(String personnel) 
	{
		this.personnel = personnel;
		
		setInstancePersonnel();
	}

	public String getPersonnel() {
		
		return (getInstance().getPersonnel()!=null ? getInstance().getPersonnel().getNomPersonnel()+" "+getInstance().getPersonnel().getPrenomPersonnel() : personnel);
		
	}
	
	public void setInstancePersonnel()
	{
		String [] nomPrenom = this.personnel.split(" ");
		
		Personnel personnel=null;
		
		try
		{
			personnel = (Personnel) entityManager.createQuery("select personnel from Personnel personnel where personnel.nomPersonnel =:nom " +
			"and personnel.prenomPersonnel =:prenom")
			.setParameter("nom", nomPrenom[0])
			.setParameter("prenom", nomPrenom[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(personnel!=null)
		{
			logger.info("L'objet personnel a été trouvé : >>>>>>>>>>>>>>>>>>>>>>>>>>>>"+personnel.getNomPersonnel() + " "+personnel.getPrenomPersonnel());
			
			getInstance().setPersonnel(personnel);
		}
	}
	
	public void personnelChanged(ValueChangeEvent event)
	{
		String personnel = (String)event.getNewValue();
		
		logger.info("DetailsInterventionMoHome", "L'employé a été changé : "+personnel);
			
		setPersonnel(personnel);
		
	}

}
