package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Outillage;
import com.agritrace.entity.production.DetailsInterventionOutillage;
import com.agritrace.entity.production.Intervention;

@Name("detailsInterventionOutillageHome")
public class DetailsInterventionOutillageHome extends
		EntityHome<DetailsInterventionOutillage> {

	@In(create = true)
	InterventionHome interventionHome;
	
	/*
	@In(create = true)
	OutillageHome outillageHome;
	*/
	
	private String outillage;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
	
	public void setDetailsInterventionOutillageIdDetailsInterventionOutillage(
			Long id) {
		setId(id);
	}

	public Long getDetailsInterventionOutillageIdDetailsInterventionOutillage() {
		return (Long) getId();
	}

	@Override
	protected DetailsInterventionOutillage createInstance() {
		DetailsInterventionOutillage detailsInterventionOutillage = new DetailsInterventionOutillage();
		return detailsInterventionOutillage;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Intervention intervention = interventionHome.getDefinedInstance();
		if (intervention != null) {
			getInstance().setIntervention(intervention);
		}
		
		/*
		Outillage outillage = outillageHome.getDefinedInstance();
		if (outillage != null) {
			getInstance().setOutillage(outillage);
		}
		*/
		
	}

	public boolean isWired() {
		if (getInstance().getIntervention() == null)
			return false;
		if (getInstance().getOutillage() == null)
			return false;
		return true;
	}

	public DetailsInterventionOutillage getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void outillageChanged(ValueChangeEvent event)
	{
		String outillage = (String)event.getNewValue();
		
		if(!outillage.trim().equals("") )
		{
			logger.info("detailsInterventionOutillageHome : outillageChanged() ", "L'outillage a été changé : "+outillage);
			
			setOutillage(outillage);
			
		}
	}

	public void setOutillage(String outillage) {
		this.outillage = outillage;
		setInstanceOutillage();
	}

	
	public String getOutillage() 
	{
		return (getInstance().getOutillage()!=null ? getInstance().getOutillage().getDesignation() : this.outillage);
	}
	
	
	public void setInstanceOutillage()
	{
		Outillage outillage = null;
		
		try
		{
			outillage = (Outillage)entityManager.createQuery("select outillage from Outillage outillage " +
			"where outillage.designation =:param")
			.setParameter("param", this.outillage)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(outillage!=null)
		{
			getInstance().setOutillage(outillage);
		}
	}
	
	

}
