package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;
import com.agritrace.entity.articles.Intrant;
import com.agritrace.entity.entrepots.Entrepot;
import com.agritrace.entity.production.DetailsInterventionProduits;
import com.agritrace.entity.production.Intervention;
import com.agritrace.entity.unitesMesure.UniteMesure;

@Name("detailsInterventionProduitsHome")
public class DetailsInterventionProduitsHome extends EntityHome<DetailsInterventionProduits> {

	@In(create = true)
	InterventionHome interventionHome;
	
	/*
	@In(create = true)
	LigneReceptionHome ligneReceptionHome;
	*/
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
		
	private String unite;

	private String entrepot;
	
	private String libelleProduit;
	
	
	public String getLibelleProduit() 
	{
		return (getInstance().getProduit()!= null ? getInstance().getProduit().getDesignation() : this.libelleProduit);
	}

	public void setLibelleProduit(String libelleProduit) 
	{
		this.libelleProduit = libelleProduit;
		setInstanceProduit();
	}

	private void setInstanceProduit() 
	{
		Intrant intrantInstance =null;
		
		if(!this.libelleProduit.equals(""))
		{
			try
			{
				intrantInstance = (Intrant)entityManager.createQuery("select intrant from Intrant intrant where " +
												"intrant.designation =:param")
				.setParameter("param", this.libelleProduit)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(intrantInstance!=null)
			{
				getInstance().setProduit(intrantInstance);
			}
		}
	}

	public String getEntrepot() 
	{
		return (getInstance().getEntrepot()!=null ? getInstance().getEntrepot().getDenomination() : this.entrepot);
	}

	public void setEntrepot(String entrepot) 
	{
		this.entrepot = entrepot;
		setInstanceEntrepot();
	}

	private void setInstanceEntrepot() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepot)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepot(entrepot);
		}
		
	}
	
	
	public void setDetailsInterventionProduitsIdDetailsInterventionProduits(
			Long id) {
		setId(id);
	}

	public Long getDetailsInterventionProduitsIdDetailsInterventionProduits() {
		return (Long) getId();
	}

	@Override
	protected DetailsInterventionProduits createInstance() {
		DetailsInterventionProduits detailsInterventionProduits = new DetailsInterventionProduits();
		return detailsInterventionProduits;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() 
	{
		getInstance();
		
		Intervention intervention = interventionHome.getDefinedInstance();
		
		if (intervention != null) {
			getInstance().setIntervention(intervention);
		}
		
		/*
		UniteMesure uniteMesure = uniteMesureHome.getDefinedInstance();
		if (uniteMesure != null) {
			getInstance().setUniteMesure(uniteMesure);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getIntervention() == null)
			return false;
		if (getInstance().getProduit() == null)
			return false;
		if (getInstance().getEntrepot() == null)
			return false;
		return true;
	}

	public DetailsInterventionProduits getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	/*
	public void setUnite(String unite) {
		this.unite = unite;
		setInstanceUom();
	}

	public String getUnite() {
		
		return (getInstance().getUniteMesure()!=null ? getInstance().getUniteMesure().getSymboleUom() : this.unite);
	}
	*/
	
	public void qtiteChanged(ValueChangeEvent event)
	{
		try
		{
			double qtite = Double.valueOf((String)event.getNewValue());

		    getInstance().setQteProduitUtilisee(qtite);

		}catch(NumberFormatException nfe)
		{
			getInstance().setQteProduitUtilisee(0);
		}
		
	}
	
	public void numeroLotChanged(ValueChangeEvent event)
	{
		try
		{
			String numeroLot = (String)event.getNewValue();

		    getInstance().setNumeroLot(numeroLot);

		}catch(NumberFormatException nfe)
		{
			getInstance().setQteProduitUtilisee(0);
		}
		
	}
	
	/*
	public void setInstanceUom()
	{
		UniteMesure uniteMesure = null;
		
		try
		{
			uniteMesure = (UniteMesure)entityManager.createQuery("select uniteMesure from UniteMesure uniteMesure " +
			"where uniteMesure.symboleUom =:uom")
			.setParameter("uom", this.unite)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(uniteMesure!=null)
		{
			getInstance().setUniteMesure(uniteMesure);
		}
	}
*/
	
	public void doseChanged(ValueChangeEvent event)
	{
		try
		{
			double dose = Double.valueOf((String)event.getNewValue());
			
			getInstance().setDose(dose);
			
		}catch(NumberFormatException nfe)
		{
			getInstance().setDose(0);
		}
	}

	public void modeApplicationChanged(ValueChangeEvent event)
	{
		String mode = (String)event.getNewValue();
		
		if(!mode.trim().equals(""))
		{
			getInstance().setModeApplication(mode);
		}
	}
	
	public void uniteDoseChanged(ValueChangeEvent event)
	{
		String unite = (String)event.getNewValue();
		
		if(!unite.trim().equals(""))
		{
			getInstance().setUniteDose(unite);
		}
	}
	
	/*
	public void uniteMesureChanged(ValueChangeEvent event)
	{
		String uom = (String)event.getNewValue();
		
		if(!uom.trim().equals("") )
		{
			logger.info("DetailsInterventionProduitsHome : uniteMesureChanged() ", "L'unité de mesure a été changé : "+uom);
			
			setUnite(uom);
		}
	}
	*/
	
	
	
	public void entrepotChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepot(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt changed : "+designation);
		}
	}
	
	public void produitChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleProduit(designation);
			logger.info(">>>>>>>>>>>>>>>>> Intrant changed : "+designation);
		}
	}
}
