package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import com.agritrace.entity.production.*;
import com.agritrace.entity.tiers.FonctionPersonnel;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("detailsOrdreCategorieMoHome")
public class DetailsOrdreCategorieMoHome extends
		EntityHome<DetailsOrdreCategorieMo> {

	@In(create = true)
	FonctionPersonnelHome fonctionPersonnelHome;
	@In(create = true)
	OrdreInterventionHome ordreInterventionHome;

	private String categorieMo;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
	
	
	public void setDetailsOrdreCategorieMoIdDetailsOrdreCategorieMo(Long id) {
		setId(id);
	}

	public Long getDetailsOrdreCategorieMoIdDetailsOrdreCategorieMo() {
		return (Long) getId();
	}

	@Override
	protected DetailsOrdreCategorieMo createInstance() {
		DetailsOrdreCategorieMo detailsOrdreCategorieMo = new DetailsOrdreCategorieMo();
		return detailsOrdreCategorieMo;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		FonctionPersonnel categorieMo = fonctionPersonnelHome
				.getDefinedInstance();
		if (categorieMo != null) {
			getInstance().setCategorieMo(categorieMo);
		}
		OrdreIntervention ordreIntervention = ordreInterventionHome
				.getDefinedInstance();
		if (ordreIntervention != null) {
			getInstance().setOrdreIntervention(ordreIntervention);
		}
	}

	public boolean isWired() {
		if (getInstance().getCategorieMo() == null)
			return false;
		if (getInstance().getOrdreIntervention() == null)
			return false;
		return true;
	}

	public DetailsOrdreCategorieMo getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void setCategorieMo(String categorieMo) {
		this.categorieMo = categorieMo;
		setInstanceCategorieMo();
		
	}

	public String getCategorieMo() {
		
		return (getInstance().getCategorieMo()!=null ? getInstance().getCategorieMo().getFonctionPersonnel() : categorieMo);
	}
	
	public void setInstanceCategorieMo()
	{
		FonctionPersonnel categorieMo = null;
		
		try
		{
			categorieMo = (FonctionPersonnel)entityManager.createQuery("select fonctionPersonnel from FonctionPersonnel fonctionPersonnel" +
			" where fonctionPersonnel.fonctionPersonnel =:param")
			.setParameter("param", this.categorieMo)
			.getSingleResult();
		}
		
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(categorieMo!=null)
		{
			getInstance().setCategorieMo(categorieMo);
		}
	}
	
	public void categorieMoChanged(ValueChangeEvent event)
	{
		String categorieMo = (String)event.getNewValue();
		
		if(!categorieMo.trim().equals(""))
		{
			logger.info("detailsInterventionCategorieMoHome : CategorieMoChanged() ", "La catégorie M.O a été changé : "+categorieMo);
			
			setCategorieMo(categorieMo);
			
		}
	}

}
