package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import com.agritrace.entity.production.*;
import com.agritrace.entity.articles.Materiel;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("detailsOrdreMaterielHome")
public class DetailsOrdreMaterielHome extends EntityHome<DetailsOrdreMateriel> {

	@In(create = true)
	MaterielHome materielHome;
	@In(create = true)
	OrdreInterventionHome ordreInterventionHome;

	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
	
	private String materiel;
	
	public void setMateriel(String materiel) {
		this.materiel = materiel;
		setInstanceMateriel();
	}

	public String getMateriel() 
	{
		return (getInstance().getMateriel()!=null ? getInstance().getMateriel().getDesignation() : this.materiel);
	}
	
	public void setInstanceMateriel()
	{
		Materiel materiel = null;
		
		try
		{
			materiel = (Materiel)entityManager.createQuery("select materiel from Materiel materiel " +
			"where materiel.designation =:param")
			.setParameter("param", this.materiel)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(materiel!=null)
		{
			getInstance().setMateriel(materiel);
		}
	}
	
	public void materielChanged(ValueChangeEvent event)
	{
		String materiel = (String)event.getNewValue();
		
		if(!materiel.trim().equals("") )
		{
			logger.info("detailsInterventionMaterielHome : materielChanged() ", "Le matériel a été changé : "+materiel);
			
			setMateriel(materiel);
			
		}
	}
	
	public void setDetailsOrdreMaterielIdDetailsOrdreMateriel(Long id) {
		setId(id);
	}

	public Long getDetailsOrdreMaterielIdDetailsOrdreMateriel() {
		return (Long) getId();
	}

	@Override
	protected DetailsOrdreMateriel createInstance() {
		DetailsOrdreMateriel detailsOrdreMateriel = new DetailsOrdreMateriel();
		return detailsOrdreMateriel;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Materiel materiel = materielHome.getDefinedInstance();
		if (materiel != null) {
			getInstance().setMateriel(materiel);
		}
		OrdreIntervention ordreIntervention = ordreInterventionHome
				.getDefinedInstance();
		if (ordreIntervention != null) {
			getInstance().setOrdreIntervention(ordreIntervention);
		}
	}

	public boolean isWired() {
		if (getInstance().getMateriel() == null)
			return false;
		if (getInstance().getOrdreIntervention() == null)
			return false;
		return true;
	}

	public DetailsOrdreMateriel getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

}
