package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import com.agritrace.entity.production.*;
import com.agritrace.entity.articles.Outillage;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("detailsOrdreOutillageHome")
public class DetailsOrdreOutillageHome extends
		EntityHome<DetailsOrdreOutillage> {

	@In(create = true)
	OrdreInterventionHome ordreInterventionHome;
	@In(create = true)
	OutillageHome outillageHome;
	
	private String outillage;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;

	
	public void setDetailsOrdreOutillageIdDetailsOrdreOutillage(Long id) {
		setId(id);
	}

	public Long getDetailsOrdreOutillageIdDetailsOrdreOutillage() {
		return (Long) getId();
	}

	@Override
	protected DetailsOrdreOutillage createInstance() {
		DetailsOrdreOutillage detailsOrdreOutillage = new DetailsOrdreOutillage();
		return detailsOrdreOutillage;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		OrdreIntervention ordreIntervention = ordreInterventionHome
				.getDefinedInstance();
		if (ordreIntervention != null) {
			getInstance().setOrdreIntervention(ordreIntervention);
		}
		Outillage outillage = outillageHome.getDefinedInstance();
		if (outillage != null) {
			getInstance().setOutillage(outillage);
		}
	}

	public boolean isWired() {
		if (getInstance().getOrdreIntervention() == null)
			return false;
		if (getInstance().getOutillage() == null)
			return false;
		return true;
	}

	public DetailsOrdreOutillage getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void outillageChanged(ValueChangeEvent event)
	{
		String outillage = (String)event.getNewValue();
		
		if(!outillage.trim().equals("") )
		{
			logger.info("detailsInterventionOutillageHome : outillageChanged() ", "L'outillage a été changé : "+outillage);
			
			setOutillage(outillage);
			
		}
	}

	public void setOutillage(String outillage) {
		this.outillage = outillage;
		setInstanceOutillage();
	}

	
	public String getOutillage() 
	{
		return (getInstance().getOutillage()!=null ? getInstance().getOutillage().getDesignation() : outillage);
	}
	
	
	public void setInstanceOutillage()
	{
		Outillage outillage = null;
		
		try
		{
			outillage = (Outillage)entityManager.createQuery("select outillage from Outillage outillage " +
			"where outillage.designation =:param")
			.setParameter("param", this.outillage)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(outillage!=null)
		{
			getInstance().setOutillage(outillage);
		}
	}

}
