package com.agritrace.session;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("detailsOrdreParcelleCulturaleHome")
public class DetailsOrdreParcelleCulturaleHome extends
		EntityHome<DetailsOrdreParcelleCulturale> {

	@In(create = true)
	OrdreInterventionHome ordreInterventionHome;
	@In(create = true)
	ParcelleCulturaleHome parcelleCulturaleHome;
	
	@In
	EntityManager entityManager;
	
	private String numeroParcelleCulturale;
	
	@Logger
	Log logger;
	
	

	public String getNumeroParcelleCulturale() {
		
		return (getInstance().getParcelleCulturale()!=null ? getInstance().getParcelleCulturale().getNumeroParcelleCulturale() : numeroParcelleCulturale);
	}

	public void setNumeroParcelleCulturale(String numeroParcelleCulturale) {
		this.numeroParcelleCulturale = numeroParcelleCulturale;
		setInstanceParcelleCulturale();
	}
	
	
	public void setInstanceParcelleCulturale()
	{
		ParcelleCulturale parcelleCulturaleInstance =null;
		
		if(!this.numeroParcelleCulturale.trim().equals(""))
		{
			try
			{
				parcelleCulturaleInstance = (ParcelleCulturale) entityManager.createQuery("select parcelleCulturale from ParcelleCulturale parcelleCulturale where " +
												"parcelleCulturale.numeroParcelleCulturale =:numero")
				.setParameter("numero", this.numeroParcelleCulturale)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(parcelleCulturaleInstance!=null)
			{
				getInstance().setParcelleCulturale(parcelleCulturaleInstance);
			}
		}
		
	}
	
	public void parcelleCulturaleChanged(ValueChangeEvent event)
	{
		String parcelleCulturaleSelected=(String)event.getNewValue();
		
		if(!parcelleCulturaleSelected.trim().equals(""))
		{
			setNumeroParcelleCulturale(parcelleCulturaleSelected);
			logger.info(">>>>>>>>>>>>>>>>> Parcelle culturale changed : "+parcelleCulturaleSelected);
		}
		else
		{
			setNumeroParcelleCulturale(null);
		}
	}
	
	public void setDetailsOrdreParcelleCulturaleIdDetailsOrdreParcelleCulturale(
			Long id) {
		setId(id);
	}

	public Long getDetailsOrdreParcelleCulturaleIdDetailsOrdreParcelleCulturale() {
		return (Long) getId();
	}

	@Override
	protected DetailsOrdreParcelleCulturale createInstance() {
		DetailsOrdreParcelleCulturale detailsOrdreParcelleCulturale = new DetailsOrdreParcelleCulturale();
		return detailsOrdreParcelleCulturale;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		OrdreIntervention ordreIntervention = ordreInterventionHome
				.getDefinedInstance();
		if (ordreIntervention != null) {
			getInstance().setOrdreIntervention(ordreIntervention);
		}
		ParcelleCulturale parcelleCulturale = parcelleCulturaleHome
				.getDefinedInstance();
		if (parcelleCulturale != null) {
			getInstance().setParcelleCulturale(parcelleCulturale);
		}
	}

	public boolean isWired() {
		if (getInstance().getOrdreIntervention() == null)
			return false;
		if (getInstance().getParcelleCulturale() == null)
			return false;
		return true;
	}

	public DetailsOrdreParcelleCulturale getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void nbreBillonsChanged(ValueChangeEvent event)
	{
		
		if(getInstance().getParcelleCulturale()!=null)
		{
			//Donnnées
			int nombreBillonTravaille; //==> nombre de billons travaillé 
			int nombreTotalBillons;  //==> nombre total de billon de la parcelle 
			double superficieTotal;  //==> superficie de la parcelle culturale
			
			//A calculer
			double superficieTravaillee;
			
			try
			{
				
				//Affectation de données
				nombreBillonTravaille = (Integer)event.getNewValue();
				nombreTotalBillons = getInstance().getParcelleCulturale().getNombreBillons();
				superficieTotal = getInstance().getParcelleCulturale().getParcelle().getSurface();
				
				//formule de calcule de la superficie totale prévue 
				
				superficieTravaillee = (nombreBillonTravaille * superficieTotal) / nombreTotalBillons ;
				logger.info("nombreBillonPrévu : "+nombreBillonTravaille+"\n"+" nombreTotalBillons : "+nombreTotalBillons+"\n"+ " superficieTotalParcelle :"+superficieTotal);
				logger.info("superfieTotalePrévue : "+superficieTravaillee+" Ha");
				
				getInstance().setSuperficiePrevueHa(superficieTravaillee);

			}catch(Exception nfe)
			{
				
			}
		}
	}

}
