package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Intrant;
import com.agritrace.entity.production.DetailsOrdreProduits;
import com.agritrace.entity.production.OrdreIntervention;
import com.agritrace.entity.unitesMesure.UniteMesure;

@Name("detailsOrdreProduitsHome")
public class DetailsOrdreProduitsHome extends EntityHome<DetailsOrdreProduits> {

	@In(create = true)
	EntrepotHome entrepotHome;
	@In(create = true)
	OrdreInterventionHome ordreInterventionHome;
	@In(create = true)
	IntrantHome intrantHome;
	@In(create = true)
	UniteMesureHome uniteMesureHome;
	
	@Logger
	Log logger;
	
	@In
	EntityManager entityManager;
		
	private String unite;
	
	private String libelleProduit;
	
	
	public String getLibelleProduit() 
	{
		return (getInstance().getProduit()!= null ? getInstance().getProduit().getDesignation() : this.libelleProduit);
	}

	public void setLibelleProduit(String libelleProduit) 
	{
		this.libelleProduit = libelleProduit;
		setInstanceProduit();
	}

	private void setInstanceProduit() 
	{
		Intrant intrantInstance =null;
		
		if(!this.libelleProduit.equals(""))
		{
			try
			{
				intrantInstance = (Intrant)entityManager.createQuery("select intrant from Intrant intrant where " +
												"intrant.designation =:param")
				.setParameter("param", this.libelleProduit)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(intrantInstance!=null)
			{
				getInstance().setProduit(intrantInstance);
			}
		}
	}

	/*
	public void setUnite(String unite) {
		this.unite = unite;
		setInstanceUom();
	}

	public String getUnite() {
		
		return (getInstance().getUniteMesure()!=null ? getInstance().getUniteMesure().getSymboleUom() : unite);
	}
	
	public void setInstanceUom()
	{
		UniteMesure uniteMesure = null;
		
		try
		{
			uniteMesure = (UniteMesure)entityManager.createQuery("select uniteMesure from UniteMesure uniteMesure " +
			"where uniteMesure.symboleUom =:uom")
			.setParameter("uom", this.unite)
			.getSingleResult();
		}
		catch(EntityNotFoundException enfe){}
		catch(NoResultException nre){}

		if(uniteMesure!=null)
		{
			getInstance().setUniteMesure(uniteMesure);
		}
	}
	*/
	
	public void qtiteChanged(ValueChangeEvent event)
	{
		try
		{
			double qtite = Double.valueOf((String)event.getNewValue());

		    getInstance().setQteProduitPrevue(qtite);

		}catch(NumberFormatException nfe)
		{
			getInstance().setQteProduitPrevue(0);
		}
		
	}
	
	
	

	
	
	public void setDetailsOrdreProduitsIdDetailsOrdreProduits(Long id) {
		setId(id);
	}

	public Long getDetailsOrdreProduitsIdDetailsOrdreProduits() {
		return (Long) getId();
	}

	@Override
	protected DetailsOrdreProduits createInstance() {
		DetailsOrdreProduits detailsOrdreProduits = new DetailsOrdreProduits();
		return detailsOrdreProduits;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		OrdreIntervention ordreIntervention = ordreInterventionHome
				.getDefinedInstance();
		if (ordreIntervention != null) {
			getInstance().setOrdreIntervention(ordreIntervention);
		}
		Intrant produit = intrantHome.getDefinedInstance();
		if (produit != null) {
			getInstance().setProduit(produit);
		}
		
		/*UniteMesure uniteMesure = uniteMesureHome.getDefinedInstance();
		if (uniteMesure != null) {
			getInstance().setUniteMesure(uniteMesure);
		}*/
	}

	public boolean isWired() {
		
		if (getInstance().getOrdreIntervention() == null)
			return false;
		if (getInstance().getProduit() == null)
			return false;
		return true;
	}

	public DetailsOrdreProduits getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	
	public void doseChanged(ValueChangeEvent event)
	{
		try
		{
			double dose = Double.valueOf((String)event.getNewValue());
			
			getInstance().setDosePrevue(dose);
			
		}catch(NumberFormatException nfe)
		{
			getInstance().setDosePrevue(0);
		}
	}

	public void modeApplicationChanged(ValueChangeEvent event)
	{
		String mode = (String)event.getNewValue();
		
		if(!mode.trim().equals(""))
		{
			getInstance().setModeApplication(mode);
		}
	}
	
	public void uniteDoseChanged(ValueChangeEvent event)
	{
		String unite = (String)event.getNewValue();
		
		if(!unite.trim().equals(""))
		{
			getInstance().setUniteDose(unite);
		}
	}
	
	
	/*
	public void uniteMesureChanged(ValueChangeEvent event)
	{
		String uom = (String)event.getNewValue();
		
		if(!uom.trim().equals("") )
		{
			logger.info("DetailsInterventionProduitsHome : uniteMesureChanged() ", "L'unité de mesure dose a été changé : "+uom);
			
			setUnite(uom);
		}
	}
	*/
	
	
	
	public void produitChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleProduit(designation);
			logger.info(">>>>>>>>>>>>>>>>> Intrant changed : "+designation);
		}
	}


}
