package com.agritrace.session;

import com.agritrace.entity.production.*;
import com.agritrace.entity.articles.Outillage;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("detailsOutillageUtiliseHome")
public class DetailsOutillageUtiliseHome extends
		EntityHome<DetailsOutillageUtilise> {

	@In(create = true)
	MaintenanceHome maintenanceHome;
	@In(create = true)
	OutillageHome outillageHome;

	public void setDetailsOutillageUtiliseIdDetailsOutillageUtilise(Long id) {
		setId(id);
	}

	public Long getDetailsOutillageUtiliseIdDetailsOutillageUtilise() {
		return (Long) getId();
	}

	@Override
	protected DetailsOutillageUtilise createInstance() {
		DetailsOutillageUtilise detailsOutillageUtilise = new DetailsOutillageUtilise();
		return detailsOutillageUtilise;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Maintenance maintenance = maintenanceHome.getDefinedInstance();
		if (maintenance != null) {
			getInstance().setMaintenance(maintenance);
		}
		Outillage outillage = outillageHome.getDefinedInstance();
		if (outillage != null) {
			getInstance().setOutillage(outillage);
		}
	}

	public boolean isWired() {
		if (getInstance().getMaintenance() == null)
			return false;
		if (getInstance().getOutillage() == null)
			return false;
		return true;
	}

	public DetailsOutillageUtilise getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

}
