package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Intrant;
import com.agritrace.entity.entrepots.Entrepot;
import com.agritrace.entity.production.DetailsProduitsMaintenance;
import com.agritrace.entity.production.Maintenance;

@Name("detailsProduitsMaintenanceHome")
public class DetailsProduitsMaintenanceHome extends
		EntityHome<DetailsProduitsMaintenance> {

	@In(create = true)
	MaintenanceHome maintenanceHome;

	@Logger
	Log logger;
	
	private String libelleProduit;
	
	private String entrepot;
	
	@In
	EntityManager entityManager;
	
	
	public String getEntrepot() 
	{
		return (getInstance().getEntrepot()!=null ? getInstance().getEntrepot().getDenomination() : this.entrepot);
	}

	public void setEntrepot(String entrepot) {
		this.entrepot = entrepot;
		setInstanceEntrepot();
	}

	private void setInstanceEntrepot() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepot)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepot(entrepot);
		}
		
	}

	public String getLibelleProduit() 
	{
		return (getInstance().getProduit()!= null ? getInstance().getProduit().getDesignation() : this.libelleProduit);
	}

	public void setLibelleProduit(String libelleProduit) 
	{
		this.libelleProduit = libelleProduit;
		setInstanceProduit();
	}

	private void setInstanceProduit() 
	{
		Intrant intrantInstance =null;
		
		if(!this.libelleProduit.equals(""))
		{
			try
			{
				intrantInstance = (Intrant)entityManager.createQuery("select intrant from Intrant intrant where " +
												"intrant.designation =:param")
				.setParameter("param", this.libelleProduit)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(intrantInstance!=null)
			{
				getInstance().setProduit(intrantInstance);
			}
		}
	}
	
	public void setDetailsProduitsMaintenanceIdDetailsProduitsMaintenance(
			Long id) {
		setId(id);
	}

	public Long getDetailsProduitsMaintenanceIdDetailsProduitsMaintenance() {
		return (Long) getId();
	}

	@Override
	protected DetailsProduitsMaintenance createInstance() {
		DetailsProduitsMaintenance detailsProduitsMaintenance = new DetailsProduitsMaintenance();
		return detailsProduitsMaintenance;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		Maintenance maintenance = maintenanceHome.getDefinedInstance();
		if (maintenance != null) {
			getInstance().setMaintenance(maintenance);
		}		
	}

	public boolean isWired() {
		
		if (getInstance().getMaintenance() == null)
			return false;
		
		if (getInstance().getProduit() == null)
			return false;
		return true;
	}

	public DetailsProduitsMaintenance getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void produitChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleProduit(designation);
			logger.info(">>>>>>>>>>>>>>>>> Produit changed : "+designation);
		}
	}
	
	public void entrepotChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepot(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt changed : "+designation);
		}
	}
}
