package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.CaisseRamassage;
import com.agritrace.entity.production.DetailsRecolteCaisses;
import com.agritrace.entity.production.Recolte;

@Name("detailsRecolteCaissesHome")
public class DetailsRecolteCaissesHome extends
		EntityHome<DetailsRecolteCaisses> {

	@In(create = true)
	CaisseRamassageHome caisseRamassageHome;
	
	
	@In(create = true)
	RecolteHome recolteHome;
	
	@Logger
	Log logger;
	
	@In(create=true)
	EntityManager entityManager;
	
	private String caisse;
	
	
	public String getCaisse() 
	{
		return (getInstance().getCaisseRamassage()!= null ? getInstance().getCaisseRamassage().getDesignation() : this.caisse);
	}

	public void setCaisse(String caisse) 
	{
		this.caisse = caisse;
		setInstanceCaisse();
	}

	
	private void setInstanceCaisse() 
	{
		// TODO Auto-generated method stub
		CaisseRamassage caisseRamassageInstance =null;
		
		if(!this.caisse.equals(""))
		{
			try
			{
				caisseRamassageInstance = (CaisseRamassage)entityManager.createQuery("select caisse.designation from CaisseRamassage caisse where " +
												"caisse.designation =:param")
				.setParameter("param", this.caisse)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(caisseRamassageInstance!=null)
			{
				getInstance().setCaisseRamassage(caisseRamassageInstance);
			}
		}
	}

	public void setDetailsRecolteCaissesIdDetailsRecolteCaisses(Long id) {
		setId(id);
	}

	public Long getDetailsRecolteCaissesIdDetailsRecolteCaisses() {
		return (Long) getId();
	}

	@Override
	protected DetailsRecolteCaisses createInstance() {
		DetailsRecolteCaisses detailsRecolteCaisses = new DetailsRecolteCaisses();
		return detailsRecolteCaisses;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}
	
	

	public void wire() {
		getInstance();
		CaisseRamassage caisseRamassage = caisseRamassageHome
				.getDefinedInstance();
		if (caisseRamassage != null) {
			getInstance().setCaisseRamassage(caisseRamassage);
		}
		Recolte recolte = recolteHome.getDefinedInstance();
		if (recolte != null) {
			getInstance().setRecolte(recolte);
		}
	}

	@Override
	public String persist() 
	{
		
		String result=super.persist();
		
		setPoidsTotalRecolte();
		
		return result;
	}

	@Override
	public String remove() {
		
		String result=super.remove();
		
		setPoidsTotalRecolte();
		
		return result;
	}

	@Override
	public String update() {
		
		String result=super.update();
		
		setPoidsTotalRecolte();
		
		return result;
	}

	public boolean isWired() {
		if (getInstance().getCaisseRamassage() == null)
			return false;
		if (getInstance().getRecolte() == null)
			return false;
		return true;
	}

	public DetailsRecolteCaisses getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void caisseChanged(ValueChangeEvent event)
	{
		
		System.out.println("******************** calling caisseSelected() méthode");
		
		CaisseRamassage caisseRamassage = (CaisseRamassage)event.getNewValue();

		getInstance().setCaisseRamassage(caisseRamassage);
		
		logger.info("********************* L'objet caisse de ramassage a été mis à jour : "+caisseRamassage.getDesignation());

	}
	
	
	public void setPoidsTotalRecolte()
	{
		
		/////////////////////////////////////Parcours des lignes de récoltes
		
		double poidsTotalNet = 0;
		
		List<DetailsRecolteCaisses> detailsRecolte = new ArrayList<DetailsRecolteCaisses>(getInstance().getRecolte().getDetailsRecolteCaisses());
		
		if(detailsRecolte != null)
		{
			for(DetailsRecolteCaisses ligneRecolte : detailsRecolte)
			{
				/////Formule (1) (Si poids brute personnalisé n'est pas null) ==> PoidsTotalNet += (PoidsBrute2 - TareCaisse) * qtitéCaisse;   
				if(ligneRecolte.getPoidsBrute() != 0.0)
				{
					
					poidsTotalNet += ((ligneRecolte.getPoidsBrute() - ligneRecolte.getCaisseRamassage().getTare()) * ligneRecolte.getQteCaisses());
									
				} 
				
				/////Formule (2) (Si poids brute personnalisé est null) ==> PoidsTotalNet += (PoidsBrute1 - TareCaisse) * qtitéCaisse;   
				else
				{
					
					poidsTotalNet += ((ligneRecolte.getCaisseRamassage().getPoidsBrute() - ligneRecolte.getCaisseRamassage().getTare()) * ligneRecolte.getQteCaisses());
									
				}
			}
		}
		
		/////////////////////// Setter le poidsTotal de la récolte///////////////////////////////////////////////////////////
		
		//getInstance().getRecolte().setPoidsTotalNet(poidsTotalNet);
		
		System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>> Poids total de la récolte actuelle est : "+poidsTotalNet+" kg");
		
		//Conversion du poids résultat en Tonne et l'affecter à l'instance Récolte en cours
		
		recolteHome.getInstance().setPoidsTotalNet(poidsTotalNet/1000);		
		
		System.out.println("Is updated :"+recolteHome.update());
		
	}

}
