package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.domaine.Toilette;
import com.agritrace.entity.production.DetailsToilettesNettoyage;
import com.agritrace.entity.production.NettoyageToilette;

@Name("detailsToilettesNettoyageHome")
public class DetailsToilettesNettoyageHome extends
		EntityHome<DetailsToilettesNettoyage> {

	@In(create = true)
	NettoyageToiletteHome nettoyageToiletteHome;
	
	/*
	@In(create = true)
	ToiletteHome toiletteHome;
	*/
	
	@In(create = true)
	EntityManager entityManager;

	private String numeroToilette="";
	
	@Logger
	Log logger;
	
	

	public String getNumeroToilette() 
	{
		return (getInstance().getToilette()!=null ? getInstance().getToilette().getNumeroToilette() : this.numeroToilette);
	}

	public void setNumeroToilette(String numeroToilette) {
		this.numeroToilette = numeroToilette;
		setInstanceToilette();
	}

	public void setInstanceToilette()
	{
		Toilette toiletteInstance =null;
		
		if(!this.numeroToilette.equals(""))
		{
			try
			{
				toiletteInstance = (Toilette)entityManager.createQuery("select toilette from Toilette toilette where " +
												"toilette.numeroToilette =:param")
				.setParameter("param", this.numeroToilette)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(toiletteInstance!=null)
			{
				getInstance().setToilette(toiletteInstance);
			}
		}
		
	}
	
	public void setDetailsToilettesNettoyageIdDetailsToilettesNettoyage(Long id) {
		setId(id);
	}

	public Long getDetailsToilettesNettoyageIdDetailsToilettesNettoyage() {
		return (Long) getId();
	}

	@Override
	protected DetailsToilettesNettoyage createInstance() {
		DetailsToilettesNettoyage detailsToilettesNettoyage = new DetailsToilettesNettoyage();
		return detailsToilettesNettoyage;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		NettoyageToilette nettoyageToilette = nettoyageToiletteHome
				.getDefinedInstance();
		if (nettoyageToilette != null) {
			getInstance().setNettoyageToilette(nettoyageToilette);
		}
	
	}

	public boolean isWired() {
		if (getInstance().getNettoyageToilette() == null)
			return false;
		if (getInstance().getToilette() == null)
			return false;
		return true;
	}

	public DetailsToilettesNettoyage getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void toiletteChanged(ValueChangeEvent event)
	{
		String numeroToilette = (String)event.getNewValue();
			
		if(!numeroToilette.trim().equals(""))
		{
			setNumeroToilette(numeroToilette);
			logger.info(">>>>>>>>>>>>>>>>> Toilette changed : "+numeroToilette);
		}
		else
		{
			setNumeroToilette("");
		}
		
	}

	
}
