package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import com.agritrace.entity.gestionCommercial.*;
import com.agritrace.entity.tiers.Client;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("detailslVentesHome")
public class DetailslVentesHome extends EntityHome<DetailslVentes> {

	@In(create = true)
	LivraisonHome livraisonHome;

	@Logger
	Log logger;
	
	private String nomClient;
	
	@In
	EntityManager entityManager;
	
	
	public String getNomClient() {
		return (getInstance().getClient()!=null ? getInstance().getClient().getLibelleTiers() : this.nomClient);
	}

	public void setNomClient(String nomClient) 
	{
		this.nomClient = nomClient;
		setInstanceClient();
	}

	
	private void setInstanceClient() 
	{
		Client clientInstance =null;
		
		if(!this.nomClient.equals(""))
		{
			try
			{
				clientInstance = (Client)entityManager.createQuery("select client from Client client where " +
												"client.libelleTiers =:param")
				.setParameter("param", this.nomClient)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(clientInstance!=null)
			{
				getInstance().setClient(clientInstance);
			}
		}
	}
	
	public void setDetailslVentesIdDetailslVentes(Long id) {
		setId(id);
	}

	public Long getDetailslVentesIdDetailslVentes() {
		return (Long) getId();
	}

	@Override
	protected DetailslVentes createInstance() {
		DetailslVentes detailslVentes = new DetailslVentes();
		return detailslVentes;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Livraison livraison = livraisonHome.getDefinedInstance();
		if (livraison != null) 
		{
			getInstance().setLivraison(livraison);
		}
	}

	public boolean isWired() 
	{
		if (getInstance().getLivraison() == null)
			return false;
		return true;
	}

	public DetailslVentes getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void clientChanged(ValueChangeEvent event)
	{
		String nomClient=(String)event.getNewValue();
		
		if(!nomClient.trim().equals(""))
		{
			setNomClient(nomClient);
			logger.info(">>>>>>>>>>>>>>>>> Client changed : "+nomClient);
		}
	}

}
