package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("detailslVentesList")
public class DetailslVentesList extends EntityQuery<DetailslVentes> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select detailslVentes from DetailslVentes detailslVentes";

	private static final String[] RESTRICTIONS = 
	{
		"lower(detailslVentes.livraison.numeroLivraison) like lower(concat(#{detailslVentesList.numeroLivraison},'%'))",
		" detailslVentes.livraison.campagne.campagne = #{campagneSession.campagne.campagne}",
		" detailslVentes.livraison.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
		
	};

	private DetailslVentes detailslVentes = new DetailslVentes();
	
	private String numeroLivraison = "";

	public DetailslVentesList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public DetailslVentes getDetailslVentes() {
		return detailslVentes;
	}

	public String getNumeroLivraison() {
		return numeroLivraison;
	}

	public void setNumeroLivraison(String numeroLivraison) {
		this.numeroLivraison = numeroLivraison;
	}
	
	
	
}
