package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.devise.Devise;

@Name("deviseList")
public class DeviseList extends EntityQuery<Devise> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select devise from Devise devise";

	private static final String[] RESTRICTIONS = {
			"lower(devise.isoDevise) like lower(concat(#{deviseList.devise.isoDevise},'%'))",
			"lower(devise.libelleDevise) like lower(concat(#{deviseList.devise.libelleDevise},'%'))", };

	private Devise devise = new Devise();

	public DeviseList() 
	{
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Devise getDevise() 
	{
		return devise;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeDevises")
	public List<Devise> getListeDevise()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeDesDevises")
	public List<Devise> getListeDevises()
	{
		return entityManager.createQuery("select devise.isoDevise from Devise devise order by devise.isoDevise asc").getResultList();
	}
}
