package com.agritrace.session;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.domaine.CertificationsDomaine;
import com.agritrace.entity.domaine.ChateauEau;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.domaine.Parcelle;
import com.agritrace.entity.domaine.Toilette;
import com.agritrace.entity.domaine.TypeSol;
import com.agritrace.entity.entrepots.Entrepot;

@Name("domaineHome")
public class DomaineHome extends EntityHome<Domaine> {

	@In(create = true)
	TypeSolHome typeSolHome;
	
	@Out(required=false)
	private List<String> listDesVilles;

	@Logger
	Log logger;
	
	public void setDomaineIdDomaine(Long id) {
		setId(id);
	}

	public Long getDomaineIdDomaine() {
		return (Long) getId();
	}

	@Override
	protected Domaine createInstance() {
		Domaine domaine = new Domaine();
		return domaine;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		TypeSol typeSol = typeSolHome.getDefinedInstance();
		if (typeSol != null) {
			getInstance().setTypeSol(typeSol);
		}
	}
	
	public List<CertificationsDomaine> getListeCertifications() {
		return getInstance() == null ? null : new ArrayList<CertificationsDomaine>(
				getInstance().getListeCertifications());
	}

	public boolean isWired() {
		if (getInstance().getTypeSol() == null)
			return false;
		return true;
	}

	public Domaine getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<ChateauEau> getListeChateauxEau() {
		return getInstance() == null ? null : new ArrayList<ChateauEau>(
				getInstance().getListeChateauxEau());
	}

	public List<Parcelle> getListeParcelles() {
		return getInstance() == null ? null : new ArrayList<Parcelle>(
				getInstance().getListeParcelles());
	}

	public List<Entrepot> getListeEntrepots() {
		return getInstance() == null ? null : new ArrayList<Entrepot>(
				getInstance().getListeEntrepots());
	}
	
	public List<Toilette> getListeToilettes() {
		return getInstance() == null ? null : new ArrayList<Toilette>(
				getInstance().getListeToilettes());
	}
	
	
	@Factory("listDesVilles")
	public List<String> getListVilles()
	{
	    String ville []= {"Agadir", "Al-Hoceima", "Azrou", "Beni Mellal", "Bou Craâ", "Boujdour", "Dakhla",
	    		"Berkane", "Bou Arfa", "Casablanca", "El Jadida","El Menzel", "Essaouira", 
	    		"Fès", "Figuig", "Ifrane", "Kénitra", "Khemis Zemamra", "Larache", "Lâayoune", "Marrakech",
	    		"Meknès", "Mohammedia", "Moulay Idriss", "Nador", "Ouarzazate", "Ouezzane", 
	    		"Oujda", "Rabat", "Rachidia", "Safi", "Salé", "Sefrou", "Settat", "Sidi Kacem",
	    		"Tanger", "Tan-Tan","Taourirte ", "Tarfaya", "Taroudant", "Tata", "Taza", "Tétouan",
	    		"Tinghir", "Tiznit", "Oualili","Khénifra", "khouribga",
	    		"Smara"};	

	    
	   listDesVilles=new ArrayList<String>(Arrays.asList(ville));
		
	   Collections.sort(listDesVilles);
	   return listDesVilles;
	}
	
	public void typeSolChanged(ValueChangeEvent event)
	{
		TypeSol typeSol = (TypeSol)event.getNewValue();
		
		logger.info("*********** Objet Typesol changed : "+typeSol.getIdTypeSol());
		
		getInstance().setTypeSol(typeSol);
		
	}
	
	
	

}
