package com.agritrace.session;

import com.agritrace.entity.domaine.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("domaineList")
public class DomaineList extends EntityQuery<Domaine> {

	@In(create=true)
	EntityManager entityManager;
	
	
	private static final String EJBQL = "select domaine from Domaine domaine";

	private static final String[] RESTRICTIONS = {
			"lower(domaine.adresse) like lower(concat(#{domaineList.domaine.adresse},'%'))",
			"lower(domaine.libelleDomaine) like lower(concat(#{domaineList.domaine.libelleDomaine},'%'))",
			"lower(domaine.numeroDomaine) like lower(concat(#{domaineList.domaine.numeroDomaine},'%'))",
			"lower(domaine.observation) like lower(concat(#{domaineList.domaine.observation},'%'))",
			"lower(domaine.ville) like lower(concat(#{domaineList.domaine.ville},'%'))", };

	private Domaine domaine = new Domaine();

	public DomaineList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Domaine getDomaine() {
		return domaine;
	}
	
	@Factory("listeDomaines")
	public List<Domaine> getListeDomaines()
	{
		return entityManager.createQuery(this.EJBQL).getResultList();
	}
}
