package com.agritrace.session;

import com.agritrace.entity.entrepots.*;
import com.agritrace.entity.tiers.Personnel;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("emplacementList")
public class EmplacementList extends EntityQuery<Emplacement> {

	@In(create=true)
	EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	
	private static final String EJBQL = "select emplacement from Emplacement emplacement";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(emplacement.numeroEmplacement) like lower(concat(#{emplacementList.emplacement.numeroEmplacement},'%'))", 
		"emplacement.entrepot.denomination = #{emplacementList.denominationEntrepot}",
		"emplacement.entrepot.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Emplacement emplacement = new Emplacement();
	
	private String denominationEntrepot;

	public String getDenominationEntrepot() {
		return denominationEntrepot;
	}

	public void setDenominationEntrepot(String denominationEntrepot) {
		this.denominationEntrepot = denominationEntrepot;
	}

	public EmplacementList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Emplacement getEmplacement() {
		return emplacement;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeEmplacements")
	public List<Personnel> getListePersonnel()
	{
		return entityManager.createQuery("select concat((concat(emplacement.numeroEmplacement,'-')),emplacement.entrepot.denomination) from Emplacement emplacement " +
				"where emplacement.entrepot.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}")
				.getResultList();

	}
}
