package com.agritrace.session;

import com.agritrace.entity.articles.*;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("engraisList")
public class EngraisList extends EntityQuery<Engrais> {

	private static final String EJBQL = "select engrais from Engrais engrais";

	private static final String[] RESTRICTIONS = {
		
		"lower(engrais.designation) like lower(concat(#{engraisList.engrais.designation}, '%'))",
		"lower(engrais.natureEngrais) like lower(concat(#{engraisList.engrais.natureEngrais}, '%'))",
	};

	private Engrais engrais = new Engrais();

	public EngraisList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Engrais getEngrais() {
		return engrais;
	}
}
