package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("ennemisCultureList")
public class EnnemisCultureList extends EntityQuery<EnnemisCulture> {


	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select ennemisCulture from EnnemisCulture ennemisCulture";

	private static final String[] RESTRICTIONS = {
			"lower(ennemisCulture.libelleEnnemiCulture) like lower(concat(#{ennemisCultureList.ennemisCulture.libelleEnnemiCulture},'%'))",
			"lower(ennemisCulture.typeEnnemiCulture) like lower(concat(#{ennemisCultureList.ennemisCulture.typeEnnemiCulture},'%'))", };

	private EnnemisCulture ennemisCulture = new EnnemisCulture();

	public EnnemisCultureList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public EnnemisCulture getEnnemisCulture() {
		return ennemisCulture;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeEnnemisCultures")
	public List<EnnemisCulture> getListeEnnemisCulture()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeEnnemis")
	public List<EnnemisCulture> getListeEnnemisCulture2()
	{
		return entityManager.createQuery("select ennemisCulture.libelleEnnemiCulture from EnnemisCulture ennemisCulture" +
											" order by ennemisCulture.libelleEnnemiCulture asc").getResultList();
	}
}
