package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.entrepots.Emplacement;
import com.agritrace.entity.entrepots.Entrepot;

@Name("entrepotHome")
public class EntrepotHome extends EntityHome<Entrepot> {

	@In(create = true)
	DomaineHome domaineHome;
	
	@In
	DomaineSession domaineSession;

	@In(create=true)
	EntityManager entityManager;
	
	public void setEntrepotIdEntrepot(Long id) {
		setId(id);
	}

	public Long getEntrepotIdEntrepot() {
		return (Long) getId();
	}

	@Override
	protected Entrepot createInstance() {
		Entrepot entrepot = new Entrepot();
		return entrepot;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() 
	{
		getInstance();
		/*
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
		*/
		
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public Entrepot getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<Emplacement> getListeEmplacements() {
		return getInstance() == null ? null : new ArrayList<Emplacement>(
				getInstance().getListeEmplacements());
	}


}
