package com.agritrace.session;

import com.agritrace.entity.entrepots.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.framework.EntityQuery;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

@Name("entrepotList")
public class EntrepotList extends EntityQuery<Entrepot> {

	private static final String EJBQL = "select entrepot from Entrepot entrepot";
    
	@In(create=true)
	private EntityManager entityManager;
	
	@Out(required=false)
	private List<String> listDesEntrepots;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String[] RESTRICTIONS = 
	{
			"lower(entrepot.denomination) like lower(concat(#{entrepotList.entrepot.denomination},'%'))",
			"lower(entrepot.numeroEntrepot) like lower(concat(#{entrepotList.entrepot.numeroEntrepot},'%'))",
			"lower(entrepot.typeEntreport) like lower(concat(#{entrepotList.entrepot.typeEntreport},'%'))", 
			"entrepot.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Entrepot entrepot = new Entrepot();

	public EntrepotList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Entrepot getEntrepot() {
		return entrepot;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listDesEntrepots")
	public List<String> getListEntrepots()
	{	
		listDesEntrepots=new ArrayList<String>();
		
		try
		{
			listDesEntrepots=entityManager.createQuery("select entrepot.denomination from Entrepot entrepot where entrepot.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}" +
					" order by entrepot.denomination asc")
			.getResultList();
		}
		catch(NoResultException nre )
		{
			nre.getStackTrace();
		}
		
	    
		return listDesEntrepots;
	}
	
	
	@SuppressWarnings("unchecked")
	@Factory("listAllEntrepots")
	public List<String> getListAllEntrepots()
	{	
		listDesEntrepots=new ArrayList<String>();
		
		try
		{
			listDesEntrepots=entityManager.createQuery("select entrepot.denomination from Entrepot entrepot order by entrepot.denomination asc")
			.getResultList();
		}
		catch(NoResultException nre )
		{
			nre.getStackTrace();
		}
		
	    
		return listDesEntrepots;
	}
}
