package com.agritrace.session;

import com.agritrace.entity.articles.*;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("equipementList")
public class EquipementList extends EntityQuery<Equipement> {

	private static final String EJBQL = "select equipement from Equipement equipement";

	private static final String[] RESTRICTIONS = { "lower(equipement.numeroEquipement) like lower(concat(#{equipementList.equipement.numeroEquipement},'%'))", };

	private Equipement equipement = new Equipement();

	public EquipementList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Equipement getEquipement() {
		return equipement;
	}
}
