package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

@Name("especeList")
public class EspeceList extends EntityQuery<Espece> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select espece from Espece espece";

	private static final String[] RESTRICTIONS = {
			"lower(espece.description) like lower(concat(#{especeList.espece.description},'%'))",
			"lower(espece.designationEspece) like lower(concat(#{especeList.espece.designationEspece},'%'))", };

	private Espece espece = new Espece();

	public EspeceList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Espece getEspece() {
		return espece;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeEspeces")
	public List<Espece> getListeEspece()
	{	
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
}
