package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import com.agritrace.entity.production.*;
import com.agritrace.entity.convention.Semaine;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("estimationProductionSemaineHome")
public class EstimationProductionSemaineHome extends
		EntityHome<EstimationProductionSemaine> {

	@In(create = true)
	ParcelleCulturaleHome parcelleCulturaleHome;
	@In(create = true)
	SemaineHome semaineHome;

	public void setEstimationProductionSemaineIdEstimationProductionSemaine(
			Long id) {
		setId(id);
	}

	public Long getEstimationProductionSemaineIdEstimationProductionSemaine() {
		return (Long) getId();
	}

	@Override
	protected EstimationProductionSemaine createInstance() {
		EstimationProductionSemaine estimationProductionSemaine = new EstimationProductionSemaine();
		return estimationProductionSemaine;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		ParcelleCulturale parcelleCulturale = parcelleCulturaleHome
				.getDefinedInstance();
		if (parcelleCulturale != null) {
			getInstance().setParcelleCulturale(parcelleCulturale);
		}
		Semaine semaine = semaineHome.getDefinedInstance();
		if (semaine != null) {
			getInstance().setSemaine(semaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getParcelleCulturale() == null)
			return false;
		if (getInstance().getSemaine() == null)
			return false;
		return true;
	}

	public EstimationProductionSemaine getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void tonnageChanged(ValueChangeEvent event)
	{
		try
		{
			double valeur = ((Double)event.getNewValue()).doubleValue();
			
			if(valeur>0)
			{
				getInstance().setTonnageEstime(valeur);
			}
				
		}catch(Exception e)
		{
			e.getStackTrace();
		}
		
		
		
		
	}

}
