package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.tiers.FonctionPersonnel;

@Name("fonctionPersonnelList")
public class FonctionPersonnelList extends EntityQuery<FonctionPersonnel> {
	
	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select fonctionPersonnel from FonctionPersonnel fonctionPersonnel";

	private static final String[] RESTRICTIONS = { "lower(fonctionPersonnel.fonctionPersonnel) like lower(concat(#{fonctionPersonnelList.fonctionPersonnel.fonctionPersonnel},'%'))", };

	private FonctionPersonnel fonctionPersonnel = new FonctionPersonnel();

	public FonctionPersonnelList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public FonctionPersonnel getFonctionPersonnel() {
		return fonctionPersonnel;
	}
	

	@SuppressWarnings("unchecked")
	@Factory("listeFonctions")
	public List<FonctionPersonnel> getListeFonctionPersonnel()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeCategorieMo")
	public List<String> getListeCategorieMo()
	{
		return entityManager.createQuery("select fonctionPersonnel.fonctionPersonnel from FonctionPersonnel fonctionPersonnel " +
										"order by fonctionPersonnel.fonctionPersonnel asc").getResultList();
	}
	
	
}
