package com.agritrace.session;

import com.agritrace.entity.tiers.*;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("formationHome")
public class FormationHome extends EntityHome<Formation> {

	/*
	@In(create = true)
	CampagneHome campagneHome;
	*/
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In
	DomaineSession domaineSession;
	
	@In(create = true)
	PersonnelHome personnelHome;
	

	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	private String personnel;
	
	
	public String getPersonnel() {
		
		return (getInstance().getPersonnel()!=null ? getInstance().getPersonnel().getNomPersonnel()+" "+getInstance().getPersonnel().getPrenomPersonnel() : personnel);
	}

	public void setPersonnel(String personnel) 
	{
		this.personnel = personnel;
		setInstancePersonnel();
	}
	
	public void setInstancePersonnel()
	{
		String [] nomPrenom = getPersonnel().split(" ");
		
		logger.info("L'employé choisi comme tuteur est : >>>>>>>>>>>>>>>> "+getPersonnel());
		
		Personnel personnel=null;
		
		try
		{
			personnel = (Personnel) entityManager.createQuery("select personnel from Personnel personnel where personnel.nomPersonnel =:nom " +
			"and personnel.prenomPersonnel =:prenom")
			.setParameter("nom", nomPrenom[0])
			.setParameter("prenom", nomPrenom[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(personnel!=null)
		{
			getInstance().setPersonnel(personnel);
		}
	}

	public void setFormationIdFormation(Long id) {
		setId(id);
	}

	public Long getFormationIdFormation() {
		return (Long) getId();
	}

	@Override
	protected Formation createInstance() {
		Formation formation = new Formation();
		return formation;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		//////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		System.out.println("Pre-Affectatation campagne => formation");
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
			
			System.out.println("Post-Affectatation campagne => formation");
		}
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if(getInstance().getCampagne()==null)
		 return false;
		if(getInstance().getDomaine()==null)
			 return false;
		if (getInstance().getPersonnel() == null)
			return false;
		return true;
	}

	public Formation getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<PersonnelFormation> getAffectationsPersonnelFormation() {
		return getInstance() == null ? null
				: new ArrayList<PersonnelFormation>(getInstance()
						.getAffectationsPersonnelFormation());
	}
	
	public void personnelChanged(ValueChangeEvent event)
	{
		String personnelSelected=(String)event.getNewValue();
		
		if(!personnelSelected.trim().equals(""))
		{
			setPersonnel(personnelSelected);
		}
		else
		{
			setPersonnel(null);
		}
	}


}
