package com.agritrace.session;

import com.agritrace.entity.tiers.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("formationList")
public class FormationList extends EntityQuery<Formation> {

	
	@In
	DomaineSession domaineSession;
	
	@In
	CampagneSession campagneSession;
	
	private static final String EJBQL = "select formation from Formation formation";

	private static final String[] RESTRICTIONS = 
	{
			"lower(formation.description) like lower(concat(#{formationList.formation.description},'%'))",
			"lower(formation.numeroFormation) like lower(concat(#{formationList.formation.numeroFormation},'%'))", 
			"formation.campagne.campagne = #{campagneSession.campagne.campagne}",
			"formation.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Formation formation = new Formation();

	public FormationList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Formation getFormation() {
		return formation;
	}
}
