package com.agritrace.session;

import com.agritrace.entity.tiers.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("fournisseurList")
public class FournisseurList extends EntityQuery<Fournisseur> 
{


	@In
	EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select fournisseur from Fournisseur fournisseur";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(fournisseur.libelleTiers) like lower(concat(#{fournisseurList.fournisseur.libelleTiers},'%'))", 
		"fournisseur.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Fournisseur fournisseur = new Fournisseur();

	public FournisseurList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Fournisseur getFournisseur() {
		return fournisseur;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeFournisseurs")
	public List<Fournisseur> getListeFounrisseurs()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
	
	@SuppressWarnings("unchecked")
	@Factory("listeFournisseur")
	public List<String> getListeFounrisseur()
	{
		return entityManager.createQuery("select fournisseur.libelleTiers from Fournisseur fournisseur order by fournisseur.libelleTiers asc").getResultList();
	}
	
}
