package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Name("interventionList")
public class InterventionList extends EntityQuery<Intervention> 
{

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select intervention from Intervention intervention";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(intervention.numeroIntervention) like lower(concat(#{interventionList.intervention.numeroIntervention},'%'))",
		"intervention.campagne.campagne = #{campagneSession.campagne.campagne}",
		"intervention.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Intervention intervention = new Intervention();

	public InterventionList() 
	{
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Intervention getIntervention() {
		return intervention;
	}
	
	public List<Intervention> getListeInterventionFiltred()
	{
		List<Intervention> listeDeBase = this.getResultList();
		
		List<Intervention> listeFiltred = new ArrayList<Intervention>();
		
		for(Intervention intervention : listeDeBase)
		{
			if(intervention.getOperation()!=null)
			{
				listeFiltred.add(intervention);
			}
		}
		
		return listeFiltred;
	}
	
}
