package com.agritrace.session;

import java.io.Serializable;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlInputText;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.Query;

import org.jboss.seam.Component;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.faces.Validator;
import org.jboss.seam.annotations.intercept.BypassInterceptors;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.Intervention;



@Name("interventionValidator")
@Validator
@BypassInterceptors
public class InterventionValidator implements javax.faces.validator.Validator, Serializable 
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;


	@Logger
	Log logger;
	
	/*
	@In
	InterventionHome interventionHome;
	*/
	
	public void validate(FacesContext context, UIComponent cmp, Object value) throws ValidatorException 
	{
		if (value != null) 
		{

			  
			 logger.info("starting validation : ==> Value received : "+(String)value);
			 
			  EntityManager entityManager = (EntityManager) Component
					.getInstance("entityManager");

			  InterventionHome interventionHome=(InterventionHome)Component.getInstance("interventionHome");
			
			  Query query=entityManager.createQuery("from Intervention intervention where intervention.numeroIntervention =:numero").
			  setParameter("numero",(String)value);
			  
			  try 
			  {  
				    try
				    {  
				    	  
				          if(query.getSingleResult()!= null)
				          { 
				        	  
			        	    Long IdIntervention=null;
			        	    
			        	    
			        	    	IdIntervention=((Intervention)query.getSingleResult()).getIdIntervention();
		
				        	    if(interventionHome.isManaged())
				        	    {
				        	    	    //On teste si l'objet en cours de modification change de n° est choisi un autre 
				        	    	    //N° d'un objet existant déjà
				        	    	
					        	    	if(!IdIntervention.equals(interventionHome.getInterventionIdIntervention()))
					        	        {
					        	    		throw new ValidatorException(new FacesMessage("Une intervention avec le même N° existe " +
											"déjà dans la base de données"));
					        	        }
					        	    	else
					        	        //Cas de la modification mais on change pas de N° 
					        	    	{
								            ((HtmlInputText)cmp).setValid(true);
					        	    	}
				        	    }
				        	    
				        	    //On est dans le cas de l'ajout mais on a choisi un n° déjà existant 
				        	    else
				        	    {
				        	    	throw new ValidatorException(new FacesMessage("Une intervention avec le même N° existe " +
									"déjà dans la base de données"));
				        	    }	
				          }  
				    }
				    catch(javax.persistence.NoResultException nre){}  
				           
			    }catch (EntityNotFoundException enfe) 
			    {  
		               System.out.println("EntityNotFoundException caught");  
		               ((HtmlInputText)cmp).setValid(true);
				}
			
		}
	}

}
