package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("intrantList")
public class IntrantList extends EntityQuery<Intrant> {

	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select intrant from Intrant intrant";

	private static final String[] RESTRICTIONS = { "lower(intrant.designation) like lower(concat(#{intrantList.intrant.designation},'%'))", };

	private Intrant intrant = new Intrant();

	public IntrantList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Intrant getIntrant() {
		return intrant;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeIntrants")
	public List<String> getListeIntrants()
	{
		return entityManager.createQuery("select intrant.designation from Intrant intrant order by intrant.designation asc")
		.getResultList();
	}
}
