package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import com.agritrace.entity.articles.*;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Client;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("inventaireClientCaissesHome")
public class InventaireClientCaissesHome extends
		EntityHome<InventaireClientCaisses> {

	/*
	@In(create = true)
	CaisseRamassageHome caisseRamassageHome;
	*/
	
	/*
	@In(create = true)
	ClientHome clientHome;
	*/
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	@Logger
	Log logger;
	
	private String nomClient;
	
	private String libelleCaisse;
	
	@In
	EntityManager entityManager;
	
	
	public String getLibelleCaisse() 
	{
		return (getInstance().getCaisseRamassage()!=null ? getInstance().getCaisseRamassage().getDesignation() : this.libelleCaisse);
	}

	public void setLibelleCaisse(String libelleCaisse) 
	{
		this.libelleCaisse = libelleCaisse;
		setInstanceCaisse();
	}

	private void setInstanceCaisse() 
	{
		CaisseRamassage caisseRamassageInstance =null;
		
		if(!this.libelleCaisse.equals(""))
		{
			try
			{
				caisseRamassageInstance = (CaisseRamassage)entityManager.createQuery("select caisseRamassage from CaisseRamassage caisseRamassage where " +
												"caisseRamassage.designation =:param")
				.setParameter("param", this.libelleCaisse)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(caisseRamassageInstance!=null)
			{
				getInstance().setCaisseRamassage(caisseRamassageInstance);
			}
		}
	}
	
	public String getNomClient() 
	{
		return (getInstance().getClient()!=null ? getInstance().getClient().getLibelleTiers() : this.nomClient);
	}

	public void setNomClient(String nomClient) {
		this.nomClient = nomClient;
		setInstanceClient();
	}

	
	private void setInstanceClient() 
	{
		Client clientInstance =null;
		
		if(!this.nomClient.equals(""))
		{
			try
			{
				clientInstance = (Client)entityManager.createQuery("select client from Client client where " +
												"client.libelleTiers =:param")
				.setParameter("param", this.nomClient)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(clientInstance!=null)
			{
				getInstance().setClient(clientInstance);
			}
		}
	}

	public void setInventaireClientCaissesIdInventaireClientCaisses(Long id) {
		setId(id);
	}

	public Long getInventaireClientCaissesIdInventaireClientCaisses() {
		return (Long) getId();
	}

	@Override
	protected InventaireClientCaisses createInstance() {
		InventaireClientCaisses inventaireClientCaisses = new InventaireClientCaisses();
		return inventaireClientCaisses;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		/*
		CaisseRamassage caisseRamassage = caisseRamassageHome
				.getDefinedInstance();
		if (caisseRamassage != null) {
			getInstance().setCaisseRamassage(caisseRamassage);
		}
		*/
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
		
		///////////////////////L'objet domaine va être affecté implicitement
		
		Domaine domaine=domaineSession.getDomaine();
		
		if (campagne != null) {
			getInstance().setDomaine(domaine);
		}
		
		/*
		Client client = clientHome.getDefinedInstance();
		if (client != null) {
			getInstance().setClient(client);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getCaisseRamassage() == null)
			return false;
		if (getInstance().getClient() == null)
			return false;
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public InventaireClientCaisses getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void clientChanged(ValueChangeEvent event)
	{
		String nomClient=(String)event.getNewValue();
		
		if(!nomClient.trim().equals(""))
		{
			setNomClient(nomClient);
			logger.info(">>>>>>>>>>>>>>>>> Client changed : "+nomClient);
		}
	}
	
	public void caisseChanged(ValueChangeEvent event)
	{
		String libelleCaisse=(String)event.getNewValue();
		
		if(!libelleCaisse.trim().equals(""))
		{
			setLibelleCaisse(libelleCaisse);
			logger.info(">>>>>>>>>>>>>>>>> Caisse ramassage changed : "+libelleCaisse);
		}
	}
}
