package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("inventaireClientCaissesList")
public class InventaireClientCaissesList extends
		EntityQuery<InventaireClientCaisses> {

	@In(create=true)
	private CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select inventaireClientCaisses from InventaireClientCaisses inventaireClientCaisses";

	private static final String[] RESTRICTIONS = {
		
		"CAST(inventaireClientCaisses.dateInventaire AS date) = CAST(#{inventaireClientCaissesList.inventaireClientCaisses.dateInventaire} AS date)",
		"lower(inventaireClientCaisses.caisseRamassage.designation) like lower(#{inventaireClientCaissesList.caisseRamassage.designation})",
		"inventaireClientCaisses.campagne.campagne = #{campagneSession.campagne.campagne}",
		"inventaireClientCaisses.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private InventaireClientCaisses inventaireClientCaisses = new InventaireClientCaisses();
	
	private CaisseRamassage  caisseRamassage = new CaisseRamassage();

	public InventaireClientCaissesList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public InventaireClientCaisses getInventaireClientCaisses() {
		return inventaireClientCaisses;
	}

	public CaisseRamassage getCaisseRamassage() {
		return caisseRamassage;
	}

	public void setCaisseRamassage(CaisseRamassage caisseRamassage) {
		this.caisseRamassage = caisseRamassage;
	}

	public void setCampagneSession(CampagneSession campagneSession) {
		this.campagneSession = campagneSession;
	}

	public CampagneSession getCampagneSession() {
		return campagneSession;
	}
	
	
}
