package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Article;
import com.agritrace.entity.articles.Inventaire;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.entrepots.Entrepot;

@Name("inventaireHome")
public class InventaireHome extends EntityHome<Inventaire> {

	/*
	@In(create = true)
	ArticleHome articleHome;
	*/
	
	@In(create = true)
	CampagneHome campagneHome;
	
	@In(create=true)
	CampagneSession campagneSession;

	@In(create=true)
	DomaineSession domaineSession;
	
	@Logger
	Log logger;
	
	private String libelleArticle;
	
    //private String emplacement;
	
	private String entrepot;
	
	@In
	EntityManager entityManager;
	
	
	/*
	public String getEmplacement() 
	{
		return (getInstance().getEmplacement()!=null 
				? 
						getInstance().getEmplacement().getNumeroEmplacement()+"-"+getInstance().getEmplacement().getEntrepot().getDenomination() 
				:
						this.emplacement);
	}

	public void setEmplacement(String emplacement) {
		this.emplacement = emplacement;
		setInstanceEmplacement();
	}

	private void setInstanceEmplacement() 
	{
			//On va essayer de décrotiquer le String Emplacement qui est sous la forme [NumeroEmplacement-DénominationEntrepot]
		    //En vue de chercher l'objet emplacement ayant le n° indiquer dans la chaine
		
		
		String [] stringEmplacement = this.emplacement.split("-");
		
		System.out.println("N° Emplacement : >>>>>>>>>>>>>>>> "+stringEmplacement[0]+"\n Entrepôt : >>>>>>>>>>>>>>>>>> "+stringEmplacement[1]);
		
		Emplacement emplacement=null;
		
		try
		{
			emplacement = (Emplacement) entityManager.createQuery("select emplacement from Emplacement emplacement where " +
			"emplacement.numeroEmplacement =:param1 " +
			"and emplacement.entrepot.denomination =:param2")
			.setParameter("param1", stringEmplacement[0])
			.setParameter("param2", stringEmplacement[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(emplacement!=null)
		{
			getInstance().setEmplacement(emplacement);
		}
		
	}
	*/
	

	public String getEntrepot() 
	{
		return (getInstance().getEntrepot()!=null ? getInstance().getEntrepot().getDenomination() : this.entrepot);
	}

	public void setEntrepot(String entrepot) {
		this.entrepot = entrepot;
		setInstanceEntrepot();
	}

	private void setInstanceEntrepot() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepot)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepot(entrepot);
		}
		
	}

	public String getLibelleArticle() 
	{
		return (getInstance().getArticle()!= null ? getInstance().getArticle().getDesignation() : this.libelleArticle);
	}

	public void setLibelleArticle(String libelleArticle) {
		this.libelleArticle = libelleArticle;
		setInstanceArticle();
	}

	private void setInstanceArticle() 
	{
		
		Article articleInstance =null;
		
		if(!this.libelleArticle.equals(""))
		{
			try
			{
				articleInstance = (Article)entityManager.createQuery("select article from Article article where " +
												"article.designation =:param")
				.setParameter("param", this.libelleArticle)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(articleInstance!=null)
			{
				getInstance().setArticle(articleInstance);
			}
		}
	}

	public void setInventaireIdInventaire(Long id) {
		setId(id);
	}

	public Long getInventaireIdInventaire() {
		return (Long) getId();
	}

	@Override
	protected Inventaire createInstance() {
		Inventaire inventaire = new Inventaire();
		return inventaire;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		/*
		Article article = articleHome.getDefinedInstance();
		if (article != null) {
			getInstance().setArticle(article);
		}
		*/
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
		
		//////////////////////////////////////////////////////////////////////////
		
		
		///////////////////////L'objet domaine va être affecté implicitement
		
		Domaine domaine=domaineSession.getDomaine();
		
		if (campagne != null) {
			getInstance().setDomaine(domaine);
		}
		
		
	}

	public boolean isWired() 
	{
		if (getInstance().getArticle() == null)
			return false;
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		if (getInstance().getEntrepot() == null)
			return false;	
		return true;
	}

	public Inventaire getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	

	public void articleChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleArticle(designation);
			logger.info(">>>>>>>>>>>>>>>>> Article changed : "+designation);
		}
	}
	
	public void entrepotChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepot(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt changed : "+designation);
		}
	}
	
	/*
	public void emplacementChanged(ValueChangeEvent event)
	{
		String emplacement = (String)event.getNewValue();
		
		if(!emplacement.trim().equals(""))
		{
			setEmplacement(emplacement);
			logger.info(">>>>>>>>>>>>>>>>> Emplacement changed : "+emplacement);
		}
	}
	*/

}
