package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("inventaireList")
public class InventaireList extends EntityQuery<Inventaire> {

	@In(create=true)
	private CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	
	private static final String EJBQL = "select inventaire from Inventaire inventaire";

	private static final String[] RESTRICTIONS = {
			"lower(inventaire.numeroInventaire) like lower(concat(#{inventaireList.inventaire.numeroInventaire},'%'))",
			"inventaire.dateInventaire = #{inventaireList.inventaire.dateInventaire}",
			"inventaire.campagne.campagne = #{campagneSession.campagne.campagne}",
			"inventaire.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Inventaire inventaire = new Inventaire();

	public InventaireList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public Inventaire getInventaire() {
		return inventaire;
	}

	public void setCampagneSession(CampagneSession campagneSession) {
		this.campagneSession = campagneSession;
	}

	public CampagneSession getCampagneSession() {
		return campagneSession;
	}
}
