package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Article;
import com.agritrace.entity.gestionCommercial.Commande;
import com.agritrace.entity.gestionCommercial.LigneCommande;

@Name("ligneCommandeHome")
public class LigneCommandeHome extends EntityHome<LigneCommande> {

	/*
	@In(create = true)
	ArticleHome articleHome;
	*/
	
	@In(create = true)
	CommandeHome commandeHome;
	
	@Logger
	Log logger;
	
	private String libelleArticle;
	
	@In
	EntityManager entityManager;
	

	
	public String getLibelleArticle() 
	{
		return (getInstance().getArticle()!= null ? getInstance().getArticle().getDesignation() : this.libelleArticle);
	}

	public void setLibelleArticle(String libelleArticle) 
	{
		this.libelleArticle = libelleArticle;
		setInstanceArticle();
	}

	private void setInstanceArticle() 
	{
		
		Article articleInstance =null;
		
		if(!this.libelleArticle.equals(""))
		{
			try
			{
				articleInstance = (Article)entityManager.createQuery("select article from Article article where " +
												"article.designation =:param")
				.setParameter("param", this.libelleArticle)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(articleInstance!=null)
			{
				getInstance().setArticle(articleInstance);
			}
		}
	}
	
	public void setLigneCommandeIdLigneCommande(Long id) {
		setId(id);
	}

	public Long getLigneCommandeIdLigneCommande() {
		return (Long) getId();
	}

	@Override
	protected LigneCommande createInstance() {
		LigneCommande ligneCommande = new LigneCommande();
		return ligneCommande;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		/*
		Article article = articleHome.getDefinedInstance();
		if (article != null) {
			getInstance().setArticle(article);
		}
		*/
		
		Commande commande = commandeHome.getDefinedInstance();
		if (commande != null) {
			getInstance().setCommande(commande);
		}
	}

	public boolean isWired() {
		if (getInstance().getArticle() == null)
			return false;
		if (getInstance().getCommande() == null)
			return false;
		return true;
	}

	public LigneCommande getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}


	public void articleChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleArticle(designation);
			logger.info(">>>>>>>>>>>>>>>>> Article changed : "+designation);
		}
	}
}
