package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import org.jboss.seam.log.Log;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Name("ligneCommandeList")
public class LigneCommandeList extends EntityQuery<LigneCommande> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	//Injection de l'objet ligneReceptionHome et ce pour récupérer le fournisseur en question qu'on va utiliser pour
	//Le filtre des ligneCommmande ==>where ligneCommande.commande.founrisseur .....
	
	/*
	@In(create=true)
	ReceptionHome receptionHome;
	 */
	
	@In(create=true)
	LigneReceptionHome ligneReceptionHome;
	
	@Logger
	Log logger;
	
	private static final String EJBQL = "select ligneCommande from LigneCommande ligneCommande";

	private static final String[] RESTRICTIONS = 
	{  
		"lower(ligneCommande.commande.numeroCommande) like lower(concat(#{ligneCommandeList.numeroCommande},'%'))",
		"ligneCommande.commande.campagne.campagne = #{campagneSession.campagne.campagne}",
		"ligneCommande.commande.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
		
		/////Ajouter un filtre permettant de lister juste les commande du fournisseur en question
		"ligneCommande.commande.fournisseur.idTiers = #{ligneReceptionHome.instance.reception.fournisseur.idTiers}", 
		"ligneCommande.article.idArticle = #{ligneReceptionHome.instance.article.idArticle}"
	};

	private LigneCommande ligneCommande = new LigneCommande();
	
	private String numeroCommande = "";
	
	public LigneCommandeList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public LigneCommande getLigneCommande() {
		return ligneCommande;
	}

	public String getNumeroCommande() {
		return numeroCommande;
	}

	public void setNumeroCommande(String numeroCommande) {
		this.numeroCommande = numeroCommande;
	}
	
	public List<LigneCommande> getLignesCommmandes()
	{
		List<LigneCommande> listeLignesCommandes = this.getResultList();
		
		List<LigneCommande> filtredLignesCommandes = new ArrayList<LigneCommande>();
		
		//Essayer de faire un filtre sur les les lignes de commandes du fournisseur en question
		//On essayera d'afficher juste les lignes de commandes dont le total des quantité réceptionné
		//est inférieur à la quantité commandée
		
		for(LigneCommande ligneCommande : listeLignesCommandes)
		{
			////si la commande n'a pas encore été satisfaite (Total_réception < Quantité_Commandée)
			if(ligneCommande.getTotalReception()<ligneCommande.getQteCommandee())
			{
				filtredLignesCommandes.add(ligneCommande);
			}
		}
		
		logger.info("Le nombre total des ligne de commande du fournisseur avant le filtre :"+listeLignesCommandes.size());
		
		logger.info("Le nombre total des ligne de commande du fournisseur après le filtre :"+filtredLignesCommandes);
		
		return filtredLignesCommandes;
	}
}
