package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import com.agritrace.entity.entrepots.*;
import com.agritrace.entity.articles.Article;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("ligneMouvementInterEntrepotsHome")
public class LigneMouvementInterEntrepotsHome extends
		EntityHome<LigneMouvementInterEntrepots> {

	/*
	@In(create = true)
	ArticleHome articleHome;
	
	@In(create = true)
	EntrepotHome entrepotHome;
	*/
	
	@In(create = true)
	MouvementInterEntrepotsHome mouvementInterEntrepotsHome;
	
	private String entrepotSource;
	
	private String entrepotDestination;
	
	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	private String libelleArticle;
	
	
	public String getEntrepotSource() 
	{
		return (getInstance().getEntrepotSource()!=null ? getInstance().getEntrepotSource().getDenomination() : this.entrepotSource);
	}

	public void setEntrepotSource(String entrepotSource) 
	{
		this.entrepotSource = entrepotSource;
		setInstanceEntrepotSource();
	}

	private void setInstanceEntrepotSource() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepotSource)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepotSource(entrepot);
		}
	}
	
	public String getEntrepotDestination() 
	{
		return (getInstance().getEntrepotDestination()!=null ? getInstance().getEntrepotDestination().getDenomination() : this.entrepotDestination);
	}

	public void setEntrepotDestination(String entrepotDestination) {
		this.entrepotDestination = entrepotDestination;
		setInstanceEntrepotDestination();
	}

	
	
	private void setInstanceEntrepotDestination() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepotDestination)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepotDestination(entrepot);
		}
	}
	
	public String getLibelleArticle() 
	{
		return (getInstance().getArticle()!= null ? getInstance().getArticle().getDesignation() : this.libelleArticle);
	}

	public void setLibelleArticle(String libelleArticle) {
		this.libelleArticle = libelleArticle;
		setInstanceArticle();
	}

	private void setInstanceArticle() 
	{
		
		Article articleInstance =null;
		
		if(!this.libelleArticle.equals(""))
		{
			try
			{
				articleInstance = (Article)entityManager.createQuery("select article from Article article where " +
												"article.designation =:param")
				.setParameter("param", this.libelleArticle)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(articleInstance!=null)
			{
				getInstance().setArticle(articleInstance);
			}
		}
	}
	
	public void setLigneMouvementInterEntrepotsIdLigneMouvementInterEntrepots(
			Long id) {
		setId(id);
	}

	public Long getLigneMouvementInterEntrepotsIdLigneMouvementInterEntrepots() {
		return (Long) getId();
	}

	@Override
	protected LigneMouvementInterEntrepots createInstance() {
		LigneMouvementInterEntrepots ligneMouvementInterEntrepots = new LigneMouvementInterEntrepots();
		return ligneMouvementInterEntrepots;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		/*Article article = articleHome.getDefinedInstance();
		if (article != null) {
			getInstance().setArticle(article);
		}
		
		Entrepot entrepotDestination = entrepotHome.getDefinedInstance();
		if (entrepotDestination != null) {
			getInstance().setEntrepotDestination(entrepotDestination);
		}
		Entrepot entrepotSource = entrepotHome.getDefinedInstance();
		if (entrepotSource != null) {
			getInstance().setEntrepotSource(entrepotSource);
		}
		*/
		
		MouvementInterEntrepots mouvementInterEntrepots = mouvementInterEntrepotsHome
				.getDefinedInstance();
		if (mouvementInterEntrepots != null) {
			getInstance().setMouvementInterEntrepots(mouvementInterEntrepots);
		}
	}

	public boolean isWired() {
		if (getInstance().getArticle() == null)
			return false;
		if (getInstance().getEntrepotDestination() == null)
			return false;
		if (getInstance().getEntrepotSource() == null)
			return false;
		if (getInstance().getMouvementInterEntrepots() == null)
			return false;
		return true;
	}

	public LigneMouvementInterEntrepots getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void articleChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleArticle(designation);
			logger.info(">>>>>>>>>>>>>>>>> Article changed : "+designation);
		}
	}

	public void entrepotSourceChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepotSource(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt source changed : "+designation);
		}
	}
	
	public void entrepotDestinationChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepotDestination(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt destination changed : "+designation);
		}
	}
	
	public void quantiteChanged(ValueChangeEvent event)
	{
		try
		{
			double quantite = ((Double)event.getNewValue()).doubleValue();
			getInstance().setQuantiteMouvement(quantite);
		}catch(NumberFormatException nfe)
		{	
		}
		
	}
	
	public void numeroLotChanged(ValueChangeEvent event)
	{
		String numeroLot = (String)event.getNewValue();
		
		getInstance().setNumeroLot(numeroLot);
	}
	
}
