package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;
import com.agritrace.entity.articles.Article;
import com.agritrace.entity.entrepots.Entrepot;
import com.agritrace.entity.gestionCommercial.LigneCommande;
import com.agritrace.entity.gestionCommercial.LigneReception;
import com.agritrace.entity.gestionCommercial.Reception;

@Name("ligneReceptionHome")
public class LigneReceptionHome extends EntityHome<LigneReception> {

	
	@In(create = true)
	LigneCommandeHome ligneCommandeHome;
	
	@In(create = true)
	ReceptionHome receptionHome;

	@In(create=true)
	EntityManager entityManager;
	
	
	private String entrepot;	
	
	@Logger
	Log logger;
	
	private String libelleArticle;
	
	
	public String getLibelleArticle() 
	{
		return (getInstance().getArticle()!= null ? getInstance().getArticle().getDesignation() : this.libelleArticle);
	}

	public void setLibelleArticle(String libelleArticle) {
		this.libelleArticle = libelleArticle;
		setInstanceArticle();
	}

	private void setInstanceArticle() 
	{
		
		Article articleInstance =null;
		
		if(!this.libelleArticle.equals(""))
		{
			try
			{
				articleInstance = (Article)entityManager.createQuery("select article from Article article where " +
												"article.designation =:param")
				.setParameter("param", this.libelleArticle)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(articleInstance!=null)
			{
				getInstance().setArticle(articleInstance);
			}
		}
	}
	
	public String getEntrepot() 
	{
		return (getInstance().getEntrepot()!=null ? getInstance().getEntrepot().getDenomination() : this.entrepot);
	}

	public void setEntrepot(String entrepot) {
		this.entrepot = entrepot;
		setInstanceEntrepot();
	}

	private void setInstanceEntrepot() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepot)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepot(entrepot);
		}
		
	}
	
	/*
	public String getEmplacement() 
	{
		return (getInstance().getEmplacement()!=null 
				? 
						getInstance().getEmplacement().getNumeroEmplacement()+"-"+getInstance().getEmplacement().getEntrepot().getDenomination() 
				:
						this.emplacement);
	}

	public void setEmplacement(String emplacement) {
		this.emplacement = emplacement;
		setInstanceEmplacement();
	}

	private void setInstanceEmplacement() 
	{
			//On va essayer de décrotiquer le String Emplacement qui est sous la forme [NumeroEmplacement-DénominationEntrepot]
		    //En vue de chercher l'objet emplacement ayant le n° indiquer dans la chaine
		
		
		String [] stringEmplacement = this.emplacement.split("-");
		
		System.out.println("N° Emplacement : >>>>>>>>>>>>>>>> "+stringEmplacement[0]+"\n Entrepôt : >>>>>>>>>>>>>>>>>> "+stringEmplacement[1]);
		
		Emplacement emplacement=null;
		
		try
		{
			emplacement = (Emplacement) entityManager.createQuery("select emplacement from Emplacement emplacement where " +
			"emplacement.numeroEmplacement =:param1 " +
			"and emplacement.entrepot.denomination =:param2")
			.setParameter("param1", stringEmplacement[0])
			.setParameter("param2", stringEmplacement[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(emplacement!=null)
		{
			getInstance().setEmplacement(emplacement);
		}
		
	}
    */
	
	public void setLigneReceptionIdLigneReception(Long id) {
		setId(id);
	}

	public Long getLigneReceptionIdLigneReception() {
		return (Long) getId();
	}

	@Override
	protected LigneReception createInstance() {
		LigneReception ligneReception = new LigneReception();
		return ligneReception;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		/*
		Emplacement emplacement = emplacementHome.getDefinedInstance();
		if (emplacement != null) {
			getInstance().setEmplacement(emplacement);
		}
		*/
		
		LigneCommande ligneCommande = ligneCommandeHome.getDefinedInstance();
		if (ligneCommande != null) {
			getInstance().setLigneCommande(ligneCommande);
		}
		Reception reception = receptionHome.getDefinedInstance();
		if (reception != null) {
			getInstance().setReception(reception);
		}
	}

	public boolean isWired() {
		if (getInstance().getEntrepot() == null)
			return false;
		if (getInstance().getReception() == null)
			return false;
		return true;
	}

	public LigneReception getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void entrepotChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepot(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt changed : "+designation);
		}
	}
	
	/*
	public void emplacementChanged(ValueChangeEvent event)
	{
		
		String emplacement = (String)event.getNewValue();
		
		if(!emplacement.trim().equals(""))
		{
			setEmplacement(emplacement);
			logger.info(">>>>>>>>>>>>>>>>> Emplacement changed : "+emplacement);
		}
	}
	*/
	
	public void quantiteChanged(ValueChangeEvent event)
	{
		try
		{
			double quantite = ((Double)event.getNewValue()).doubleValue();
			getInstance().setQteReceptionnee(quantite);
		}catch(NumberFormatException nfe)
		{	
		}
		
	}
	
	public void prixUnitaireChanged(ValueChangeEvent event)
	{
		try
		{
			double prixUnitaire = ((Double)event.getNewValue()).doubleValue();
			getInstance().setPrixUnitaire(prixUnitaire);
		}catch(NumberFormatException nfe)
		{	
		}
		
	}
	
	public void numeroLotChanged(ValueChangeEvent event)
	{
		String numeroLot = (String)event.getNewValue();
		
		getInstance().setNumeroLotReception(numeroLot);
	}
	
	public void articleChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setLibelleArticle(designation);
			logger.info(">>>>>>>>>>>>>>>>> Article changed : "+designation);
		}
	}
}
