package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("ligneReceptionList")
public class LigneReceptionList extends EntityQuery<LigneReception> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select ligneReception from LigneReception ligneReception";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(ligneReception.numeroLotReception) like lower(concat(#{ligneReceptionList.ligneReception.numeroLotReception},'%'))", 
		"lower(ligneReception.ligneCommande.article.designation) like lower(concat(#{ligneReceptionList.designationArticle},'%'))",		
		"ligneReception.ligneCommande.commande.campagne.campagne = #{campagneSession.campagne.campagne}",
		"ligneReception.reception.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}"
	};

	private LigneReception ligneReception = new LigneReception();
	
	private String designationArticle = "";

	public LigneReceptionList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public LigneReception getLigneReception() {
		return ligneReception;
	}

	public String getDesignationArticle() {
		return designationArticle;
	}

	public void setDesignationArticle(String designationArticle) {
		this.designationArticle = designationArticle;
	}
	
	
}
