package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.CaisseRamassage;
import com.agritrace.entity.entrepots.Entrepot;
import com.agritrace.entity.gestionCommercial.LigneRetourCaisses;
import com.agritrace.entity.gestionCommercial.RetourCaisses;

@Name("ligneRetourCaissesHome")
public class LigneRetourCaissesHome extends EntityHome<LigneRetourCaisses> {

	@In(create = true)
	CaisseRamassageHome caisseRamassageHome;
	
	@In(create = true)
	RetourCaissesHome retourCaissesHome;
	
	@Logger
	Log logger;
	
	private String entrepot;
	
	private String libelleCaisse;
	
	@In
	EntityManager entityManager;

	public String getLibelleCaisse() 
	{
		return (getInstance().getCaisseRamassage()!=null ? getInstance().getCaisseRamassage().getDesignation() : this.libelleCaisse);
	}

	public void setLibelleCaisse(String libelleCaisse) 
	{
		this.libelleCaisse = libelleCaisse;
		setInstanceCaisse();
	}

	private void setInstanceCaisse() 
	{
		CaisseRamassage caisseRamassageInstance =null;
		
		if(!this.libelleCaisse.equals(""))
		{
			try
			{
				caisseRamassageInstance = (CaisseRamassage)entityManager.createQuery("select caisseRamassage from CaisseRamassage caisseRamassage where " +
												"caisseRamassage.designation =:param")
				.setParameter("param", this.libelleCaisse)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(caisseRamassageInstance!=null)
			{
				getInstance().setCaisseRamassage(caisseRamassageInstance);
			}
		}
	}
	
	public String getEntrepot() 
	{
		return (getInstance().getEntrepot()!=null ? getInstance().getEntrepot().getDenomination() : this.entrepot);
	}

	public void setEntrepot(String entrepot) {
		this.entrepot = entrepot;
		setInstanceEntrepot();
	}

	private void setInstanceEntrepot() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepot)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepot(entrepot);
		}
		
	}
	
	public void setLigneRetourCaissesIdLigneRetourCaisses(Long id) {
		setId(id);
	}

	public Long getLigneRetourCaissesIdLigneRetourCaisses() {
		return (Long) getId();
	}

	@Override
	protected LigneRetourCaisses createInstance() {
		LigneRetourCaisses ligneRetourCaisses = new LigneRetourCaisses();
		return ligneRetourCaisses;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		CaisseRamassage caisseRamassage = caisseRamassageHome
				.getDefinedInstance();
		if (caisseRamassage != null) {
			getInstance().setCaisseRamassage(caisseRamassage);
		}
		
		RetourCaisses retourCaisses = retourCaissesHome.getDefinedInstance();
		if (retourCaisses != null) {
			getInstance().setRetourCaisses(retourCaisses);
		}
	}

	public boolean isWired() {
		if (getInstance().getCaisseRamassage() == null)
			return false;
		if (getInstance().getRetourCaisses() == null)
			return false;
		if (getInstance().getEntrepot() == null)
			return false;
		return true;
	}

	public LigneRetourCaisses getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void entrepotChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepot(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt changed : "+designation);
		}
	}
	
	public void caisseChanged(ValueChangeEvent event)
	{
		String libelleCaisse=(String)event.getNewValue();
		
		if(!libelleCaisse.trim().equals(""))
		{
			setLibelleCaisse(libelleCaisse);
			logger.info(">>>>>>>>>>>>>>>>> Caisse ramassage changed : "+libelleCaisse);
		}
	}
	
}
