package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.entrepots.Entrepot;
import com.agritrace.entity.gestionCommercial.LigneReception;
import com.agritrace.entity.gestionCommercial.LigneRetourFournisseur;
import com.agritrace.entity.gestionCommercial.RetourFournisseur;

@Name("ligneRetourFournisseurHome")
public class LigneRetourFournisseurHome extends
		EntityHome<LigneRetourFournisseur> {


	@In(create = true)
	LigneReceptionHome ligneReceptionHome;
	
	@In(create = true)
	RetourFournisseurHome retourFournisseurHome;
	
	@Logger
	Log logger;
	
	private String entrepot;
	
	@In
	EntityManager entityManager;

	public String getEntrepot() 
	{
		return (getInstance().getEntrepot()!=null ? getInstance().getEntrepot().getDenomination() : this.entrepot);
	}

	public void setEntrepot(String entrepot) {
		this.entrepot = entrepot;
		setInstanceEntrepot();
	}

	private void setInstanceEntrepot() 
	{
		Entrepot entrepot=null;
		
		try
		{
			entrepot = (Entrepot) entityManager.createQuery("select entrepot from Entrepot entrepot where " +
			"entrepot.denomination =:param1")
			.setParameter("param1", this.entrepot)
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(entrepot!=null)
		{
			getInstance().setEntrepot(entrepot);
		}
		
	}
	
	public void setLigneRetourFournisseurIdLigneRetourFournisseur(Long id) {
		setId(id);
	}

	public Long getLigneRetourFournisseurIdLigneRetourFournisseur() {
		return (Long) getId();
	}

	@Override
	protected LigneRetourFournisseur createInstance() {
		LigneRetourFournisseur ligneRetourFournisseur = new LigneRetourFournisseur();
		return ligneRetourFournisseur;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		LigneReception ligneReception = ligneReceptionHome.getDefinedInstance();
		if (ligneReception != null) {
			getInstance().setLigneReception(ligneReception);
		}
		RetourFournisseur retourFournisseur = retourFournisseurHome
				.getDefinedInstance();
		if (retourFournisseur != null) {
			getInstance().setRetourFournisseur(retourFournisseur);
		}
	}

	public boolean isWired() 
	{
		if (getInstance().getLigneReception() == null)
			return false;
		if (getInstance().getRetourFournisseur() == null)
			return false;
		if (getInstance().getEntrepot() == null)
			return false;
		return true;
	}

	public LigneRetourFournisseur getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void entrepotChanged(ValueChangeEvent event)
	{	
		String designation = (String)event.getNewValue();
		
		if(!designation.trim().equals(""))
		{
			setEntrepot(designation);
			logger.info(">>>>>>>>>>>>>>>>> Entrepôt changed : "+designation);
		}
	}

}
