package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.TypeCulture;
import com.agritrace.entity.convention.Convention;
import com.agritrace.entity.convention.LignesConvention;
import com.agritrace.entity.convention.PesticidesHomologues;
import com.agritrace.entity.devise.Devise;

@Name("lignesConventionHome")
public class LignesConventionHome extends EntityHome<LignesConvention> {

	@In(create = true)
	ConventionHome conventionHome;
	
	@In(create = true)
	DeviseHome deviseHome;
	
	/*
	@In(create = true)
	VarieteHome varieteHome;
	*/
	
	@In(create = true)
	TypeCultureHome typeCultureHome;
	
	
	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	
	private String typeCulture;
	
	private String devise;
	
	
	public String getDevise() 
	{
		return (getInstance().getDevise()!= null ? getInstance().getDevise().getIsoDevise() : this.devise);
	}

	public void setDevise(String devise) {
		this.devise = devise;
		setInstanceDevise();
	}

	private void setInstanceDevise() 
	{
		Devise deviseInstance =null;
		
		if(!this.devise.equals(""))
		{
			try
			{
				deviseInstance = (Devise)entityManager.createQuery("select devise from Devise devise where " +
												"devise.isoDevise =:param")
				.setParameter("param", this.devise)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(deviseInstance!=null)
			{
				getInstance().setDevise(deviseInstance);
			}
		}
	}
	
	

	public String getTypeCulture() 
	{
		return (getInstance().getTypeCulture()!= null ? getInstance().getTypeCulture().getTypeCulture() : this.typeCulture);
	}

	public void setTypeCulture(String typeCulture) {
		this.typeCulture = typeCulture;
		setTypeCultureInstance();
	}

	private void setTypeCultureInstance() 
	{
		TypeCulture typeCultureInstance = null;
		
		if(!typeCulture.trim().equals(""))
		{
			typeCultureInstance = (TypeCulture) entityManager.createQuery("select typeCulture from TypeCulture typeCulture where " +
					"typeCulture.typeCulture =:param")
					.setParameter("param", this.typeCulture)
					.getSingleResult();
		}
		
		if(typeCultureInstance!=null)
		{
			getInstance().setTypeCulture(typeCultureInstance);
		}
	}

	
	public void setLignesConventionIdLigneConvention(Long id) {
		setId(id);
	}

	public Long getLignesConventionIdLigneConvention() {
		return (Long) getId();
	}

	@Override
	protected LignesConvention createInstance() {
		LignesConvention lignesConvention = new LignesConvention();
		return lignesConvention;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Convention convention = conventionHome.getDefinedInstance();
		if (convention != null) {
			getInstance().setConvention(convention);
		}
		Devise devise = deviseHome.getDefinedInstance();
		if (devise != null) {
			getInstance().setDevise(devise);
		}
		
		/*Variete variete = varieteHome.getDefinedInstance();
		if (variete != null) {
			getInstance().setVariete(variete);
		}*/
		
	}

	public boolean isWired() {
		if (getInstance().getConvention() == null)
			return false;
		if (getInstance().getDevise() == null)
			return false;
		if (getInstance().getTypeCulture() == null)
			return false;
		return true;
	}

	public LignesConvention getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	
	public List<PesticidesHomologues> getListePesticidesHomologues() {
		return getInstance() == null ? null
				: new ArrayList<PesticidesHomologues>(getInstance()
						.getListePesticidesHomologues());
	}
	
	public void deviseChanged(ValueChangeEvent event)
	{
		String designation = (String)event.getNewValue();

		if(!designation.trim().equals(""))
		{
			setDevise(designation);
			
			logger.info("********************* L'objet Devise a été mis à jour : "+designation);	
		}
	}
	
	
	public void typeCultureChanged(ValueChangeEvent event)
	{
		String designation = (String)event.getNewValue();

		if(!designation.trim().equals(""))
		{
			setTypeCulture(designation);
			
			logger.info("********************* Type Culture est mis à jour : "+designation);	
		}

	}
	
	
}
