package com.agritrace.session;

import com.agritrace.entity.convention.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("lignesConventionList")
public class LignesConventionList extends EntityQuery<LignesConvention> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select lignesConvention from LignesConvention lignesConvention";

	private static final String[] RESTRICTIONS = {
		
		"lignesConvention.convention.campagne.campagne = #{campagneSession.campagne.campagne}",
		"lignesConvention.convention.numeroConvention = #{lignesConventionList.numeroConvention}",
		"lignesConvention.convention.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private String numeroConvention="";
	
	private LignesConvention lignesConvention = new LignesConvention();

	public LignesConventionList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public LignesConvention getLignesConvention() {
		return lignesConvention;
	}

	public String getNumeroConvention() {
		return numeroConvention;
	}

	public void setNumeroConvention(String numeroConvention) {
		this.numeroConvention = numeroConvention;
	}
	
	
}
