package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.gestionCommercial.CaissesRamassageLivraison;
import com.agritrace.entity.gestionCommercial.DetailslVentes;
import com.agritrace.entity.gestionCommercial.Livraison;
import com.agritrace.entity.production.Recolte;
import com.agritrace.entity.tiers.Client;

@Name("livraisonHome")
public class LivraisonHome extends EntityHome<Livraison> {

	/*
	@In(create = true)
	CampagneHome campagneHome;
	*/

	@In(create=true)
	CampagneSession campagneSession;
	
	
	@In(create=true)
	DomaineSession domaineSession;
	

	@Logger
	Log logger;
	
	private String nomClient;
	
	private String numeroRecolte;
	
	@In
	EntityManager entityManager;
	
	
	
	public String getNumeroRecolte() 
	{
		return (getInstance().getRecolte()!=null ? getInstance().getRecolte().getNumeroIntervention() : this.numeroRecolte);
	}

	public void setNumeroRecolte(String numeroRecolte) {
		this.numeroRecolte = numeroRecolte;
		setInstanceRecolte();
		
	}

	private void setInstanceRecolte() 
	{
		// TODO Auto-generated method stub
		
		Recolte recolteInstance =null;
		
		if(!this.numeroRecolte.equals(""))
		{
			try
			{
				recolteInstance = (Recolte)entityManager.createQuery("select recolte from Recolte recolte where " +
												"recolte.numeroIntervention =:param")
				.setParameter("param", this.numeroRecolte)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(recolteInstance!=null)
			{
				getInstance().setRecolte(recolteInstance);
			}
		}
	}

	public String getNomClient() 
	{
		return (getInstance().getClient()!=null ? getInstance().getClient().getLibelleTiers() : this.nomClient);
	}

	public void setNomClient(String nomClient) 
	{
		this.nomClient = nomClient;
		setInstanceClient();
	}

	
	private void setInstanceClient() 
	{
		Client clientInstance =null;
		
		if(!this.nomClient.equals(""))
		{
			try
			{
				clientInstance = (Client)entityManager.createQuery("select client from Client client where " +
												"client.libelleTiers =:param")
				.setParameter("param", this.nomClient)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(clientInstance!=null)
			{
				getInstance().setClient(clientInstance);
			}
		}
	}

	public void setLivraisonIdLivraison(Long id) {
		setId(id);
	}

	public Long getLivraisonIdLivraison() {
		return (Long) getId();
	}

	@Override
	protected Livraison createInstance() {
		Livraison livraison = new Livraison();
		return livraison;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
		
		/*
		Client client = clientHome.getDefinedInstance();
		if (client != null) {
			getInstance().setClient(client);
		}
		*/
	}

	public boolean isWired() 
	{
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getClient() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public Livraison getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<CaissesRamassageLivraison> getCaissesRamassageLivraison() {
		return getInstance() == null ? null
				: new ArrayList<CaissesRamassageLivraison>(getInstance()
						.getCaissesRamassageLivraison());
	}
	
	public List<DetailslVentes> getDetailslVentes() {
		return getInstance() == null ? null
				: new ArrayList<DetailslVentes>(getInstance()
						.getDetailslVentes());
	}

	public void clientChanged(ValueChangeEvent event)
	{
		String nomClient=(String)event.getNewValue();
		
		if(!nomClient.trim().equals(""))
		{
			setNomClient(nomClient);
			logger.info(">>>>>>>>>>>>>>>>> Client changed : "+nomClient);
		}
	}

	public void recolteChanged(ValueChangeEvent event)
	{
		String numeroRecolte=(String)event.getNewValue();
		
		if(!numeroRecolte.trim().equals(""))
		{
			setNumeroRecolte(numeroRecolte);
			logger.info(">>>>>>>>>>>>>>>>> Récolte changed : "+numeroRecolte);
		}
	}

	
}
