package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("livraisonList")
public class LivraisonList extends EntityQuery<Livraison> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	@In(create=true)
	DetailslVentesHome detailslVentesHome;
	
	private static final String EJBQL = "select livraison from Livraison livraison";

	private static final String[] RESTRICTIONS = {
			"lower(livraison.chauffeur) like lower(concat(#{livraisonList.livraison.chauffeur},'%'))",
			"lower(livraison.matriculeCamion) like lower(concat(#{livraisonList.livraison.matriculeCamion},'%'))",
			"lower(livraison.numeroLivraison) like lower(concat(#{livraisonList.livraison.numeroLivraison},'%'))", 
			"livraison.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
			"livraison.campagne.campagne = #{campagneSession.campagne.campagne}",
			"livraison.client.libelleTiers = #{detailslVentesHome.instance.client.libelleTiers}",	
	};

	private Livraison livraison = new Livraison();

	public LivraisonList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Livraison getLivraison() {
		return livraison;
	}
}
