package com.agritrace.session;

import java.io.Serializable;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlInputText;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import javax.persistence.EntityManager;
import javax.persistence.EntityNotFoundException;
import javax.persistence.Query;

import org.jboss.seam.Component;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.faces.Validator;
import org.jboss.seam.annotations.intercept.BypassInterceptors;
import org.jboss.seam.log.Log;

import com.agritrace.entity.gestionCommercial.LigneReception;



@Name("lotReceptionValidator")
@Validator
@BypassInterceptors
public class LotReceptionValidator implements javax.faces.validator.Validator, Serializable 
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@Logger
	Log logger;
	

	public void validate(FacesContext context, UIComponent cmp, Object value) throws ValidatorException 
	{
		if (value != null) 
		{
			  logger.info(">>>>>> Starting validation Lot Réception : ==> Value received : "+(String)value);
			 
			  EntityManager entityManager = (EntityManager) Component
					.getInstance("entityManager");

			  LigneReceptionHome ligneReceptionHome=(LigneReceptionHome)Component.getInstance("ligneReceptionHome");
			
			  Query query=entityManager.createQuery("from LigneReception ligneReception where ligneReception.numeroLotReception =:numeroLot").
			  setParameter("numeroLot",(String)value);
			  
			  try 
			  {  
				    try
				    {  
				    	  
				          if(query.getSingleResult()!= null)
				          { 
				        	  
			        	    Long idLigneReception=null;
			        	    
			        	    
			        	    	idLigneReception=((LigneReception)query.getSingleResult()).getIdLigneReception();
		
				        	    if(ligneReceptionHome.isManaged())
				        	    {
				        	    	    //On teste si l'objet en cours de modification change de n° est choisi un autre 
				        	    	    //N° d'un objet existant déjà
				        	    	
					        	    	if(!idLigneReception.equals(ligneReceptionHome.getLigneReceptionIdLigneReception()))
					        	        {
					        	    		throw new ValidatorException(new FacesMessage("Une réception avec le même N° de Lot a été " +
											"déjà ajoutée !!"));
					        	        }
					        	    	else
					        	        //Cas de la modification mais on change pas de N° de Lot 
					        	    	{
								            ((HtmlInputText)cmp).setValid(true);
					        	    	}
				        	    }
				        	    
				        	    //On est dans le cas de l'ajout mais on a choisi un n° de Lot déjà existant 
				        	    else
				        	    {
				        	    	throw new ValidatorException(new FacesMessage("Une réception avec le même N° de Lot a été " +
									"déjà ajoutée !!"));
				        	    }	
				          }  
				    }
				    catch(javax.persistence.NoResultException nre){}  
				           
			    }catch (EntityNotFoundException enfe) 
			    {  
		               System.out.println("EntityNotFoundException caught");  
		               ((HtmlInputText)cmp).setValid(true);
				}
			
		}
	}

}
