package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("lutteBiologiqueList")
public class LutteBiologiqueList extends EntityQuery<LutteBiologique> {
	
	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select lutteBiologique from LutteBiologique lutteBiologique";

	private static final String[] RESTRICTIONS = {
			"lower(lutteBiologique.designation) like lower(concat(#{lutteBiologiqueList.lutteBiologique.designation},'%'))", };

	private LutteBiologique lutteBiologique = new LutteBiologique();

	public LutteBiologiqueList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public LutteBiologique getLutteBiologique() {
		return lutteBiologique;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeLutteBiologiques")
	public List<LutteBiologique> getListeLutteBiologiques()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
}
