package com.agritrace.session;

import com.agritrace.entity.production.*;
import com.agritrace.entity.articles.Materiel;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Personnel;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("maintenanceHome")
public class MaintenanceHome extends EntityHome<Maintenance> {

	/*
	@In(create = true)
	CampagneHome campagneHome;
	*/
	
	@In(create = true)
	MaterielHome materielHome;
	@In(create = true)
	OrdreInterventionHome ordreInterventionHome;
	@In(create = true)
	PersonnelHome personnelHome;
	
	@In(create = true)
	EntityManager entityManager;
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In
	DomaineSession domaineSession;
	
	
	private String numeroOrdre="";
	

	private String materiel ="";
	
	private String personnel=""; 
	
	@Logger
	Log logger;

	
	public String getPersonnel() 
	{
		return (getInstance().getPersonnel()!=null ? getInstance().getPersonnel().getNomPersonnel()+" "+getInstance().getPersonnel().getPrenomPersonnel() : this.personnel);
	}

	public void setPersonnel(String personnel) 
	{
		this.personnel = personnel;
		setInstancePersonnel();
	}

	public void setInstancePersonnel()
	{
		String [] nomPrenom = this.personnel.split(" ");
		
		Personnel personnel=null;
		
		try
		{
			personnel = (Personnel) entityManager.createQuery("select personnel from Personnel personnel where personnel.nomPersonnel =:nom " +
			"and personnel.prenomPersonnel =:prenom")
			.setParameter("nom", nomPrenom[0])
			.setParameter("prenom", nomPrenom[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(personnel!=null)
		{
			getInstance().setPersonnel(personnel);
		}
	}
	
	public String getMateriel() 
	{
		return (getInstance().getMateriel()!=null ? getInstance().getMateriel().getDesignation() : this.materiel);
	}

	public void setMateriel(String materiel) {
		this.materiel = materiel;
		setInstanceMateriel();
		
	}

	public void setInstanceMateriel()
	{
		Materiel materielInstance =null;
		
		if(!this.materiel.equals(""))
		{
			try
			{
				materielInstance = (Materiel)entityManager.createQuery("select materiel from Materiel materiel where " +
												"materiel.designation =:param")
				.setParameter("numero", this.numeroOrdre)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(materielInstance!=null)
			{
				getInstance().setMateriel(materielInstance);
			}
		}
		
	}
	
	public String getNumeroOrdre() 
	{
		return (getInstance().getOrdreIntervention()!=null ? getInstance().getOrdreIntervention().getNumeroOrdreIntervention() : this.numeroOrdre);
	}

	public void setNumeroOrdre(String numeroOrdre) {
		this.numeroOrdre = numeroOrdre;
		setInstanceOrdreIntervention();
	}
	
	public void setInstanceOrdreIntervention()
	{
		OrdreIntervention ordreInterventionInstance =null;
		
		if(!this.numeroOrdre.equals(""))
		{
			try
			{
				ordreInterventionInstance = (OrdreIntervention)entityManager.createQuery("select ordreIntervention from OrdreIntervention ordreIntervention where " +
												"ordreIntervention.numeroOrdreIntervention =:numero")
				.setParameter("numero", this.numeroOrdre)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(ordreInterventionInstance!=null)
			{
				getInstance().setOrdreIntervention(ordreInterventionInstance);
			}
		}
		
	}

	@Override
	public String remove() 
	{
		String result = super.remove();

		if(getInstance().getOrdreIntervention()!=null)
		{
			Long idOrdreIntervention = getInstance().getOrdreIntervention().getIdOrdreIntervention();
			
			entityManager.createQuery("update OrdreIntervention ordre set ordre.ordreExecute = false where " +
					"ordre.idOrdreIntervention = :id")
					.setParameter("id", idOrdreIntervention)
					.executeUpdate();
		}
		
		return result;
	}

	@Override
	public String persist() 
	{
		
		String result =  super.persist();
		
		System.out.println("I'm inside persist méthode !!!!!!!!!!!!!!!!!!");
		
		if(getInstance().getOrdreIntervention()!=null)
		{
			Long idOrdreIntervention = getInstance().getOrdreIntervention().getIdOrdreIntervention();
			
			entityManager.createQuery("update OrdreIntervention ordre set ordre.ordreExecute = true where " +
					"ordre.idOrdreIntervention = :id")
					.setParameter("id", idOrdreIntervention)
					.executeUpdate();
			
			System.out.println("Ordre not null");
			
		}
				
		return result;
		
	}
	
	@Override
	public String update() 
	{
		String result = super.update();

		if(getInstance().getOrdreIntervention()!=null)
		{
			Long idOrdreIntervention = getInstance().getOrdreIntervention().getIdOrdreIntervention();
			
			entityManager.createQuery("update OrdreIntervention ordre set ordre.ordreExecute = true where " +
					"ordre.idOrdreIntervention = :id")
					.setParameter("id", idOrdreIntervention)
					.executeUpdate();
		}
		
		return result;
	}
	
	public void setMaintenanceIdMaintenance(Long id) {
		setId(id);
	}

	public Long getMaintenanceIdMaintenance() {
		return (Long) getId();
	}

	@Override
	protected Maintenance createInstance() {
		Maintenance maintenance = new Maintenance();
		return maintenance;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() 
	{
		
		getInstance();
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
		
		/*
		Materiel materiel = materielHome.getDefinedInstance();
		if (materiel != null) {
			getInstance().setMateriel(materiel);
		}
		*/
		
		/*
		OrdreIntervention ordreIntervention = ordreInterventionHome
				.getDefinedInstance();
		if (ordreIntervention != null) {
			getInstance().setOrdreIntervention(ordreIntervention);
		}
		*/
		
		Personnel personnel = personnelHome.getDefinedInstance();
		if (personnel != null) {
			getInstance().setPersonnel(personnel);
		}
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		if (getInstance().getMateriel() == null)
			return false;
		if (getInstance().getPersonnel() == null)
			return false;
		return true;
	}

	public Maintenance getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<DetailsOutillageUtilise> getDetailsOutillageUtilise() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOutillageUtilise>(getInstance()
						.getDetailsOutillageUtilise());
	}

	public List<DetailsProduitsMaintenance> getDetailsProduitsMaintenance() {
		return getInstance() == null ? null
				: new ArrayList<DetailsProduitsMaintenance>(getInstance()
						.getDetailsProduitsMaintenance());
	}
	
	public void ordreInterventionChanged(ValueChangeEvent event)
	{
		String ordrInterventionOld=(String)event.getOldValue();
		
		String ordrInterventionNew=(String)event.getNewValue();
		
		///////////////////////////////////////// The older
		if(!ordrInterventionOld.trim().equals(""))
		{
			logger.info(">>>>>>>>>>>>>>>>> Ordre Intervention Old : "+ordrInterventionOld);
			
			entityManager.createQuery("update OrdreIntervention ordre set ordre.ordreExecute = false where " +
					"ordre.numeroOrdreIntervention = :numero")
					.setParameter("numero", ordrInterventionOld)
					.executeUpdate();
		}
		
		/////////////////////////////////////// The New Value
		if(!ordrInterventionNew.trim().equals(""))
		{
			setNumeroOrdre(ordrInterventionNew);
			logger.info(">>>>>>>>>>>>>>>>> Ordre Intervention New : "+ordrInterventionNew);
		}
		else
		{
			setNumeroOrdre("");
		}
		
	}
	
	public void materielChanged(ValueChangeEvent event)
	{
	
		String materiel = (String)event.getNewValue();
		
		if (!materiel.trim().equals("")) 
		{
			setMateriel(materiel);
			logger.info(">>>>>>>>>>>>>>>>> Materiel changed >>>>>>>> : "+materiel);
		}
		else
		{
			setMateriel("");
		}
		
	}
	
	
	public void intervenantChanged(ValueChangeEvent event)
	{
		
		System.out.println("******************** calling materielSelected() méthode");
		
		Materiel materiel = (Materiel)event.getNewValue();

		getInstance().setMateriel(materiel);
		
		logger.info("********************* L'objet Matériel a été mis à jour : "+materiel.getDesignation());

	}
	
	public void heureDebutChanged(ValueChangeEvent event)
	{
		Date dateChoosed = (Date)event.getNewValue();
	
		if(dateChoosed!=null)
		{
			logger.info("La date est valide :) :) :) :) :) :) :) :)");
			getInstance().setHeureDebutMaintenance(dateChoosed);
			getInstance().setHeureFinMaintenance(dateChoosed);
			logger.info("Toutes les dates ont été mise à jour :) :) :) :) :) :) :) :)");
		}
	
		
	}
	
	public void personnelChanged(ValueChangeEvent event)
	{
		String personnelSelected=(String)event.getNewValue();
		
		if(!personnelSelected.trim().equals(""))
		{
			setPersonnel(personnelSelected);
			logger.info(">>>>>>>>>>>>>>>>> Employé changé >>>>>> : "+personnelSelected);
		}
		else
		{
			setPersonnel("");
		}
	}
	

}
