package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("maintenanceList")
public class MaintenanceList extends EntityQuery<Maintenance> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select maintenance from Maintenance maintenance";

	private static final String[] RESTRICTIONS = 
	{
			"lower(maintenance.numeroMaintenance) like lower(concat(#{maintenanceList.maintenance.numeroMaintenance},'%'))",
			"lower(maintenance.campagne.campagne) = #{campagneSession.campagne.campagne}",
			"maintenance.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Maintenance maintenance = new Maintenance();

	public MaintenanceList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Maintenance getMaintenance() {
		return maintenance;
	}
}
