package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("marqueEquipementList")
public class MarqueEquipementList extends EntityQuery<MarqueEquipement> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select marqueEquipement from MarqueEquipement marqueEquipement";

	private static final String[] RESTRICTIONS = {
			"lower(marqueEquipement.description) like lower(concat(#{marqueEquipementList.marqueEquipement.description},'%'))",
			"lower(marqueEquipement.marqueEquipement) like lower(concat(#{marqueEquipementList.marqueEquipement.marqueEquipement},'%'))", };

	private MarqueEquipement marqueEquipement = new MarqueEquipement();

	public MarqueEquipementList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(14);
	}

	public MarqueEquipement getMarqueEquipement() {
		return marqueEquipement;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeMarqueEquipement")
	public List<MarqueEquipement> getListeMarqueEquipement()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
}
