package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("materielList")
public class MaterielList extends EntityQuery<Materiel> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select materiel from Materiel materiel";

	private static final String[] RESTRICTIONS = 
	{
		"lower(materiel.designation) like lower(concat(#{materielList.materiel.designation},'%'))", 
	};

	private Materiel materiel = new Materiel();

	public MaterielList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Materiel getMateriel() {
		return materiel;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeMateriels")
	public List<String> getListeMateriels()
	{
		return entityManager.createQuery("select materiel.designation from Materiel materiel order by materiel.designation asc")
										.getResultList();
	}
}
