package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.entrepots.LigneMouvementInterEntrepots;
import com.agritrace.entity.entrepots.MouvementInterEntrepots;

@Name("mouvementInterEntrepotsHome")
public class MouvementInterEntrepotsHome extends
		EntityHome<MouvementInterEntrepots> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;

	@Logger
	Log logger;
	
	public void setMouvementInterEntrepotsIdMouvementInterEntrepots(Long id) {
		setId(id);
	}

	public Long getMouvementInterEntrepotsIdMouvementInterEntrepots() {
		return (Long) getId();
	}

	@Override
	protected MouvementInterEntrepots createInstance() {
		MouvementInterEntrepots mouvementInterEntrepots = new MouvementInterEntrepots();
		return mouvementInterEntrepots;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) 
		{
			getInstance().setCampagne(campagne);
		}
		
        Domaine domaine=domaineSession.getDomaine();
		
		if (domaine != null) 
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public MouvementInterEntrepots getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<LigneMouvementInterEntrepots> getLignesMouvementInterEntrepots() {
		return getInstance() == null ? null
				: new ArrayList<LigneMouvementInterEntrepots>(getInstance()
						.getLignesMouvementInterEntrepots());
	}

}
