package com.agritrace.session;

import com.agritrace.entity.entrepots.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("mouvementInterEntrepotsList")
public class MouvementInterEntrepotsList extends
		EntityQuery<MouvementInterEntrepots> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select mouvementInterEntrepots from MouvementInterEntrepots mouvementInterEntrepots";

	private static final String[] RESTRICTIONS = 
	{ 
		
		"lower(mouvementInterEntrepots.numeroMouvementInterEntrepots) like lower(concat(#{mouvementInterEntrepotsList.mouvementInterEntrepots.numeroMouvementInterEntrepots},'%'))",
		"mouvementInterEntrepots.campagne.campagne = #{campagneSession.campagne.campagne}",
		"mouvementInterEntrepots.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private MouvementInterEntrepots mouvementInterEntrepots = new MouvementInterEntrepots();

	public MouvementInterEntrepotsList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public MouvementInterEntrepots getMouvementInterEntrepots() {
		return mouvementInterEntrepots;
	}
}
