package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("nettoyageChateauEauList")
public class NettoyageChateauEauList extends EntityQuery<NettoyageChateauEau> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select nettoyageChateauEau from NettoyageChateauEau nettoyageChateauEau";

	private static final String[] RESTRICTIONS = {
		
		"lower(nettoyageChateauEau.numeroIntervention) like lower(concat(#{nettoyageChateauEauList.nettoyageChateauEau.numeroIntervention},'%'))",
		"nettoyageChateauEau.campagne.campagne = #{campagneSession.campagne.campagne}",
		"nettoyageChateauEau.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private NettoyageChateauEau nettoyageChateauEau = new NettoyageChateauEau();

	public NettoyageChateauEauList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public NettoyageChateauEau getNettoyageChateauEau() {
		return nettoyageChateauEau;
	}
}
