package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("nettoyageToiletteList")
public class NettoyageToiletteList extends EntityQuery<NettoyageToilette> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select nettoyageToilette from NettoyageToilette nettoyageToilette";

	private static final String[] RESTRICTIONS = {
		
		"lower(nettoyageToilette.numeroIntervention) like lower(concat(#{nettoyageToiletteList.nettoyageToilette.numeroIntervention},'%'))",
		"nettoyageToilette.campagne.campagne = #{campagneSession.campagne.campagne}",
		"nettoyageToilette.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private NettoyageToilette nettoyageToilette = new NettoyageToilette();

	public NettoyageToiletteList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public NettoyageToilette getNettoyageToilette() {
		return nettoyageToilette;
	}
}
