package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.production.Operation;
import com.agritrace.entity.production.OrdreIntervention;

@Name("operationList")
public class OperationList extends EntityQuery<Operation> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select operation.operation from Operation operation";

	private static final String[] RESTRICTIONS = {
			"lower(operation.description) like lower(concat(#{operationList.operation.description},'%'))",
			"lower(operation.operation) like lower(concat(#{operationList.operation.operation},'%'))", };

	private Operation operation = new Operation();

	public OperationList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Operation getOperation() {
		return operation;
	}
	
	/*
	@SuppressWarnings("unchecked")
	@Factory("listeOperations")
	public List<Operation> getListeOperations()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	*/
	
	@SuppressWarnings("unchecked")
	@Factory("listeOperations")
	public List<OrdreIntervention> getListeOrdreInterventions()
	{
		return entityManager.createQuery("select operation.operation from Operation operation").getResultList();
	}
}
