package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import com.agritrace.entity.production.*;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("ordreInterventionHome")
public class OrdreInterventionHome extends EntityHome<OrdreIntervention> {

	@In(create = true)
	AnalyseHome analyseHome;
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In
	DomaineSession domaineSession;

	private String libelleOperation="";
	
	@Logger
	Log logger;
	
	@In(create = true)
	EntityManager entityManager;
	
	public void setLibelleOperation(String libelleOperation) 
	{
		this.libelleOperation = libelleOperation;
		setInstanceOperation();
	}

	public String getLibelleOperation() 
	{
		return (getInstance().getOperation()!=null ? getInstance().getOperation().getOperation() : this.libelleOperation);
	}
	
	public void setInstanceOperation()
	{
		Operation operationInstance =null;
		
		if(!this.libelleOperation.equals(""))
		{
			try
			{
				operationInstance = (Operation)entityManager.createQuery("select operation from Operation operation where " +
												"operation.operation =:param")
				.setParameter("param", this.libelleOperation)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(operationInstance!=null)
			{
				getInstance().setOperation(operationInstance);
			}
		}
		
	}
	
	
	public void setOrdreInterventionIdOrdreIntervention(Long id) {
		setId(id);
	}

	public Long getOrdreInterventionIdOrdreIntervention() {
		return (Long) getId();
	}

	@Override
	protected OrdreIntervention createInstance() {
		OrdreIntervention ordreIntervention = new OrdreIntervention();
		return ordreIntervention;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Analyse analyse = analyseHome.getDefinedInstance();
		if (analyse != null) {
			getInstance().setAnalyse(analyse);
		}
		//Campagne campagne = campagneHome.getDefinedInstance();
		Campagne campagne=campagneSession.getCampagne();
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
		
		Domaine domaine=domaineSession.getDomaine();
			
		if (domaine != null) 
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getCampagne() == null || getInstance().getDomaine()== null)
			return false;
		return true;
	}

	public OrdreIntervention getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public List<DetailsOrdreCategorieMo> getDetailsOrdreCategorieMo() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOrdreCategorieMo>(getInstance()
						.getDetailsOrdreCategorieMo());
	}

	public List<DetailsOrdreMainOeuvre> getDetailsOrdreMainOeuvre() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOrdreMainOeuvre>(getInstance()
						.getDetailsOrdreMainOeuvre());
	}

	public List<DetailsOrdreMateriel> getDetailsOrdreMateriel() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOrdreMateriel>(getInstance()
						.getDetailsOrdreMateriel());
	}

	public List<DetailsOrdreOutillage> getDetailsOrdreOutillage() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOrdreOutillage>(getInstance()
						.getDetailsOrdreOutillage());
	}

	public List<DetailsOrdreParcelleCulturale> getDetailsOrdreParcelleCulturales() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOrdreParcelleCulturale>(getInstance()
						.getDetailsOrdreParcelleCulturales());
	}

	public List<DetailsOrdreProduits> getDetailsOrdreProduits() {
		return getInstance() == null ? null
				: new ArrayList<DetailsOrdreProduits>(getInstance()
						.getDetailsOrdreProduits());
	}

	
	public void operationChanged(ValueChangeEvent event)
	{
		String libelleOperation = (String)event.getNewValue();
			
		if(!libelleOperation.trim().equals(""))
		{
			setLibelleOperation(libelleOperation);
			logger.info(">>>>>>>>>>>>>>>>> Opération changed : "+libelleOperation);
		}
		else
		{
			setLibelleOperation("");
		}
		
	}

}
