package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("ordreInterventionList")
public class OrdreInterventionList extends EntityQuery<OrdreIntervention> {

	@In
	EntityManager entityManager;
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select ordreIntervention from OrdreIntervention ordreIntervention";

	private static final String[] RESTRICTIONS = {
			"lower(ordreIntervention.numeroOrdreIntervention) like lower(concat(#{ordreInterventionList.ordreIntervention.numeroOrdreIntervention},'%'))",
			"ordreIntervention.campagne.campagne = #{campagneSession.campagne.campagne}",
			"ordreIntervention.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}"
	 };
	
	private OrdreIntervention ordreIntervention = new OrdreIntervention();

	public OrdreInterventionList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public OrdreIntervention getOrdreIntervention() {
		return ordreIntervention;
	}
	
	
	@SuppressWarnings("unchecked")
	@Factory("listeOrdresIntervention")
	public List<OrdreIntervention> getListeOrdreIntervention()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeOrdresInterventions")
	public List<OrdreIntervention> getListeOrdreInterventions()
	{
		return entityManager.createQuery("select ordreIntervention.numeroOrdreIntervention from OrdreIntervention ordreIntervention " +
				"where ordreIntervention.campagne.campagne = #{campagneSession.campagne.campagne} and " +
				"ordreIntervention.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine} and " +
				"ordreIntervention.ordreExecute = false").getResultList();
	}
	
}
