package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("outillageList")
public class OutillageList extends EntityQuery<Outillage> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select outillage from Outillage outillage";

	private static final String[] RESTRICTIONS = {
		
		"lower(outillage.designation) like lower(concat(#{outillageList.outillage.designation},'%'))", 
		
	};

	private Outillage outillage = new Outillage();

	public OutillageList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Outillage getOutillage() {
		return outillage;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeOutillage")
	public List<String> listeOutillage()
	{
		return entityManager.createQuery("select outillage.designation from Outillage outillage order by outillage.designation asc")
									.getResultList();
	}
}
