package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.ParcelleCulturale;

@Name("parcelleCulturaleList")
public class ParcelleCulturaleList extends EntityQuery<ParcelleCulturale> {

	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In
	EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	@Logger
	Log logger;
	
	private static final String EJBQL = "select parcelleCulturale from ParcelleCulturale parcelleCulturale";

	private static final String[] RESTRICTIONS = {
			"lower(parcelleCulturale.numeroParcelleCulturale) like lower(concat(#{parcelleCulturaleList.parcelleCulturale.numeroParcelleCulturale},'%'))",
			"parcelleCulturale.cyclePlanningProduction.planningProduction.campagne.campagne = #{campagneSession.campagne.campagne}",
			"parcelleCulturale.parcelle.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private ParcelleCulturale parcelleCulturale = new ParcelleCulturale();


	public ParcelleCulturaleList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public ParcelleCulturale getParcelleCulturale() {
		return parcelleCulturale;
	}
	
	/////////////On doit filtrer les parcelles culturales aussi par domaine & campagne
	@SuppressWarnings("unchecked")
	@Factory("listeParcelleCulturales")
	public List<ParcelleCulturale> getListeParcelleCulturale()
	{
		String query = "select parcelleCulturale.numeroParcelleCulturale from ParcelleCulturale parcelleCulturale " +
						"where parcelleCulturale.cyclePlanningProduction.planningProduction.campagne.campagne = #{campagneSession.campagne.campagne} " + 
						"and parcelleCulturale.parcelle.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}";
		
		return entityManager.createQuery(query).getResultList();
	}
	
	
}
