package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.domaine.Parcelle;
import com.agritrace.entity.domaine.Secteur;
import com.agritrace.entity.domaine.TypeIrrigation;
import com.agritrace.entity.domaine.TypeParcelle;



@Name("parcelleHome")
public class ParcelleHome extends EntityHome<Parcelle> {

	@In(create = true)
	DomaineHome domaineHome;
	
	@In(create = true)
	SecteurHome secteurHome;
	
	/*
	@In(create = true)
	TypeParcelleHome typeParcelleHome;
	
	@In(create = true)
	TypeIrrigationHome typeIrrigationHome;
	*/
	
	private String typeParcelle;
	
	
	private String typeIrrigation;
	
	
	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	
	public String getTypeParcelle() 
	{
		return (getInstance().getTypeParcelle()!=null ? getInstance().getTypeParcelle().getTypeParcelle() : this.typeParcelle);
	}

	public void setTypeParcelle(String typeParcelle) 
	{
		this.typeParcelle = typeParcelle;
		setInstanceTypeParcelle();
	}

	public void setInstanceTypeParcelle()
	{
		TypeParcelle typeParcelleInstance =null;
		
		if(!this.typeParcelle.equals(""))
		{
			try
			{
				typeParcelleInstance = (TypeParcelle)entityManager.createQuery("select typeParcelle from TypeParcelle typeParcelle where " +
												"typeParcelle.typeParcelle =:param")
				.setParameter("param", this.typeParcelle)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(typeParcelleInstance!=null)
			{
				getInstance().setTypeParcelle(typeParcelleInstance);
			}
		}
		
	}
	
	public String getTypeIrrigation() 
	{
		return (getInstance().getTypeIrrigation()!=null ? getInstance().getTypeIrrigation().getLibelleTypeIrrigation() : this.typeIrrigation);
	}

	public void setTypeIrrigation(String typeIrrigation) 
	{
		this.typeIrrigation = typeIrrigation;
		setInstanceTypeIrrigation();
	}

	public void setInstanceTypeIrrigation()
	{
		TypeIrrigation typeIrrigationInstance =null;
		
		if(!this.typeIrrigation.equals(""))
		{
			try
			{
				typeIrrigationInstance = (TypeIrrigation)entityManager.createQuery("select typeIrrigation from TypeIrrigation typeIrrigation where " +
												"typeIrrigation.libelleTypeIrrigation =:param")
				.setParameter("param", this.typeIrrigation)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(typeIrrigationInstance!=null)
			{
				getInstance().setTypeIrrigation(typeIrrigationInstance);
			}
		}
		
	}
	
	public void setParcelleIdParcelle(Long id) {
		setId(id);
	}

	public Long getParcelleIdParcelle() {
		return (Long) getId();
	}

	@Override
	protected Parcelle createInstance() {
		Parcelle parcelle = new Parcelle();
		return parcelle;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
		Secteur secteur = secteurHome.getDefinedInstance();
		if (secteur != null) {
			getInstance().setSecteur(secteur);
		}
		
		/*
		TypeParcelle typeParcelle = typeParcelleHome.getDefinedInstance();
		if (typeParcelle != null) {
			getInstance().setTypeParcelle(typeParcelle);
		}
		
		TypeIrrigation typeIrrigation = typeIrrigationHome.getDefinedInstance();
		
		if (typeIrrigation != null) {
			getInstance().setTypeIrrigation(typeIrrigation);
		}
		*/
	}

	public boolean isWired() {
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public Parcelle getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void typeParcelleChanged(ValueChangeEvent event)
	{
		String typeParcelle = (String)event.getNewValue();
			
		if(!typeParcelle.trim().equals(""))
		{
			setTypeParcelle(typeParcelle);
			logger.info(">>>>>>>>>>>>>>>>> Type Parcelle changed : "+typeParcelle);
		}
		else
		{
			setTypeParcelle("");
		}
		
	}

	public void typeIrriagtionChanged(ValueChangeEvent event)
	{
		String typeIrrigation = (String)event.getNewValue();
			
		if(!typeIrrigation.trim().equals(""))
		{
			setTypeIrrigation(typeIrrigation);
			logger.info(">>>>>>>>>>>>>>>>> Type Irrigation changed : "+typeIrrigation);
		}
		else
		{
			setTypeIrrigation("");
		}
		
	}
}
