package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.domaine.Parcelle;

@Name("parcelleList")
public class ParcelleList extends EntityQuery<Parcelle> {

	
	@In(create=true)
	EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select parcelle from Parcelle parcelle";

	private static final String[] RESTRICTIONS = {
			"lower(parcelle.numeroParcelle) like lower(concat(#{parcelleList.parcelle.numeroParcelle},'%'))",
			"lower(parcelle.referencesCadastrale) like lower(concat(#{parcelleList.parcelle.referencesCadastrale},'%'))",
			"parcelle.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",		
	};

	private Parcelle parcelle = new Parcelle();

	public ParcelleList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Parcelle getParcelle() {
		return parcelle;
	}
	
	/*
	@SuppressWarnings("unchecked")
	@Factory("listeParcelles")
	public List<Parcelle> getListeParcelles()
	{
		return entityManager.createQuery("select parcelle.numeroParcelle from Parcelle parcelle " +
				"where parcelle.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}").getResultList();
	}
	*/
	
	
	@SuppressWarnings("unchecked")
	@Factory("listeParcelles")
	public List<String> getListeParcelles()
	{
		String query = "select parcelle.numeroParcelle from Parcelle parcelle " +
						"where parcelle.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}";
		
		return entityManager.createQuery(query).getResultList();
	}
	
	
}
