package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import com.agritrace.entity.tiers.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("personnelFormationHome")
public class PersonnelFormationHome extends EntityHome<PersonnelFormation> {

	@In(create = true)
	FormationHome formationHome;
	
	@In(create = true)
	PersonnelHome personnelHome;
	
	private String personnel;
	
	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	

	public String getPersonnel() 
	{
		return (getInstance().getPersonnel()!=null ? getInstance().getPersonnel().getNomPersonnel()+" "+getInstance().getPersonnel().getPrenomPersonnel() : personnel);
	}

	public void setPersonnel(String personnel) {
		this.personnel = personnel;
		setInstancePersonnel();
	}
	
	public void setInstancePersonnel()
	{
		String [] nomPrenom = getPersonnel().split(" ");
		
		logger.info("L'employé choisi comme tuteur est : >>>>>>>>>>>>>>>> "+getPersonnel());
		
		Personnel personnel=null;
		
		try
		{
			personnel = (Personnel) entityManager.createQuery("select personnel from Personnel personnel where personnel.nomPersonnel =:nom " +
			"and personnel.prenomPersonnel =:prenom")
			.setParameter("nom", nomPrenom[0])
			.setParameter("prenom", nomPrenom[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(personnel!=null)
		{
			getInstance().setPersonnel(personnel);
			logger.info("Ouvrier affecté :"+this.personnel);
		}
	}


	public void setPersonnelFormationIdPersonnelFormation(Integer id) {
		setId(id);
	}

	public Integer getPersonnelFormationIdPersonnelFormation() {
		return (Integer) getId();
	}

	@Override
	protected PersonnelFormation createInstance() {
		PersonnelFormation personnelFormation = new PersonnelFormation();
		return personnelFormation;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Formation formation = formationHome.getDefinedInstance();
		if (formation != null) {
			getInstance().setFormation(formation);
		}
		Personnel personnel = personnelHome.getDefinedInstance();
		if (personnel != null) {
			getInstance().setPersonnel(personnel);
		}
	}

	public boolean isWired() {
		if (getInstance().getFormation() == null)
			return false;
		if (getInstance().getPersonnel() == null)
			return false;
		return true;
	}

	public PersonnelFormation getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public void personnelChanged(ValueChangeEvent event)
	{
		String personnelSelected=(String)event.getNewValue();
		
		if(!personnelSelected.trim().equals(""))
		{
			getInstance().setPersonnel(null);
			setPersonnel(personnelSelected);
		}
		else
		{
			setPersonnel(null);
		}
	}
}
