package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.AffectationTravail;
import com.agritrace.entity.tiers.Personnel;
import com.agritrace.entity.tiers.PersonnelFormation;

@Name("personnelHome")
public class PersonnelHome extends TiersHome<Personnel> {

	@In(create=true)
	DomaineSession domaineSession;
	
	public void setPersonnelIdTiers(Integer id) {
		setId(id);
	}

	public Integer getPersonnelIdTiers() {
		return (Integer) getId();
	}

	@Override
	protected Personnel createInstance() {
		Personnel personnel = new Personnel();
		return personnel;
	}

	public Personnel getInstance() {
		return (Personnel) super.getInstance();
	}
	
	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
		
		
		super.wire();
	}

	public boolean isWired() {
		return super.isWired();
	}

	public Personnel getDefinedInstance() {
		return isIdDefined() ? (Personnel)getInstance() : null;
	}

	public List<AffectationTravail> getListeAffectationTravail() {
		return getInstance() == null ? null
				: new ArrayList<AffectationTravail>(((Personnel)getInstance())
						.getListeAffectationTravail());
	}

	public List<PersonnelFormation> getListeAffectationFormation() {
		return getInstance() == null ? null
				: new ArrayList<PersonnelFormation>(getInstance()
						.getListeAffectationFormation());
	}
}
