package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.tiers.Personnel;

@Name("personnelList")
public class PersonnelList extends EntityQuery<Personnel> {
	
	@In
	EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select personnel from Personnel personnel";

	private static final String[] RESTRICTIONS = {
			"lower(personnel.cin) like lower(concat(#{personnelList.personnel.cin},'%'))",
			"lower(personnel.gsmPersonnel) like lower(concat(#{personnelList.personnel.gsmPersonnel},'%'))",
			"lower(personnel.matriculePersonnel) like lower(concat(#{personnelList.personnel.matriculePersonnel},'%'))",
			"lower(personnel.nomPersonnel) like lower(concat(#{personnelList.personnel.nomPersonnel},'%'))",
			"lower(personnel.nomPersonnel) like lower(concat(#{personnelList.personnel.nomPersonnel},'%'))",
			"lower(personnel.prenomPersonnel) like lower(concat(#{personnelList.personnel.prenomPersonnel},'%'))", 
			"personnel.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Personnel personnel = new Personnel();

	private String categorie;
	
	public String getCategorie() {
		return categorie;
	}

	public void setCategorie(String categorie) {
		this.categorie = categorie;
	}

	public PersonnelList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(12);
	}

	public Personnel getPersonnel() {
		return personnel;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listePersonnel")
	public List<String> getListePersonnel()
	{
		return entityManager.createQuery("select concat((concat(personnel.nomPersonnel,' ')),personnel.prenomPersonnel) from Personnel personnel " +
				"where personnel.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}")
				.getResultList();

	}
	
}
