package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.CiblesPesticides;
import com.agritrace.entity.articles.CompatibiliteLutteBiologique;
import com.agritrace.entity.articles.Pesticide;
import com.agritrace.entity.unitesMesure.UniteMesure;

@Name("pesticideHome")
public class PesticideHome extends IntrantHome<Pesticide> {

	/*
	@In(create = true)
	NatureTraitementHome natureTraitementHome;
	*/
	
	public void setPesticideIdArticle(Long id) {
		setId(id);
	}

	public Long getPesticideIdArticle() {
		return (Long) getId();
	}

	@Override
	protected Pesticide createInstance() {
		Pesticide pesticide = new Pesticide();
		return pesticide;
	}

	public Pesticide getInstance() 
	{
		return (Pesticide)super.getInstance();
	}
	
	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		super.wire();
		
	}

	public boolean isWired() {
		
		if(getInstance().getUniteMesure() == null)
		{
			return false;
		}
		
		return true;
	}

	
	public Pesticide getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<CiblesPesticides> getListeCiblesPesticides() {
		return getInstance() == null ? null : new ArrayList<CiblesPesticides>(
				getInstance().getListeCiblesPesticides());
	}

	public List<CompatibiliteLutteBiologique> getListeCompatibiliteLutteBio() {
		return getInstance() == null ? null
				: new ArrayList<CompatibiliteLutteBiologique>(getInstance()
						.getListeCompatibiliteLutteBio());
	}
	
	public void uniteChanged(ValueChangeEvent event)
	{
		UniteMesure uniteMesure = (UniteMesure)event.getNewValue();
		
		if(uniteMesure!=null)
		{
			System.out.println("****************** Une nouvelle unité de mesure a été choisi : "+uniteMesure.getSymboleUom());
			getInstance().setUniteMesure(uniteMesure);
		}
	}

}
