package com.agritrace.session;

import java.util.Arrays;
import java.util.List;
import javax.persistence.EntityManager;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.articles.Pesticide;

@Name("pesticideList")
public class PesticideList extends EntityQuery<Pesticide> {

	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select pesticide from Pesticide pesticide";

	private static final String[] RESTRICTIONS = { 
		
		"lower(pesticide.matiereActive) like lower(concat(#{pesticideList.pesticide.matiereActive},'%'))",
		"lower(pesticide.designation) like lower(concat(#{pesticideList.pesticide.designation},'%'))", 
		
	};

	private Pesticide pesticide = new Pesticide();

	public PesticideList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Pesticide getPesticide() {
		return pesticide;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listePesticides")
	public List<String> getListePesticides()
	{
		return entityManager.createQuery("select pesticide.designation from Pesticide pesticide order by pesticide.designation asc")
				.getResultList();

	}
}
