package com.agritrace.session;

import java.math.BigDecimal;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.articles.Pesticide;
import com.agritrace.entity.convention.LignesConvention;
import com.agritrace.entity.convention.PesticidesHomologues;

@Name("pesticidesHomologuesHome")
public class PesticidesHomologuesHome extends EntityHome<PesticidesHomologues> {

	@In(create = true)
	LignesConventionHome lignesConventionHome;
	
	@In(create = true)
	PesticideHome pesticideHome;
	
	@In(create = true)
	UniteMesureHome uniteMesureHome;
	
	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	private String unite;
	
	private String pesticide="";

	
	public String getPesticide() 
	{
		return (getInstance().getPesticide()!= null ? getInstance().getPesticide().getDesignation() : this.pesticide);
	}

	public void setPesticide(String pesticide) {
		this.pesticide = pesticide;
		setInstancePesticide();
	}
	
	private void setInstancePesticide() 
	{
		// TODO Auto-generated method stub
		
		Pesticide pesticideInstance =null;
		
		if(!this.pesticide.equals(""))
		{
			try
			{
				pesticideInstance = (Pesticide)entityManager.createQuery("select pesticide from Pesticide pesticide where " +
												"pesticide.designation =:param")
				.setParameter("param", this.pesticide)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(pesticideInstance!=null)
			{
				getInstance().setPesticide(pesticideInstance);
			}
		}
		
	}

	/*
	public String getUnite() 
	{
		return (getInstance().getUniteMesure()!= null ? getInstance().getUniteMesure().getSymboleUom() : this.unite);
	}

	public void setUnite(String unite) {
		this.unite = unite;
		setInstanceUnite();
	}

	private void setInstanceUnite() 
	{
		// TODO Auto-generated method stub
		
		UniteMesure uniteMesureInstance =null;
		
		if(!this.unite.equals(""))
		{
			try
			{
				uniteMesureInstance = (UniteMesure)entityManager.createQuery("select unite from UniteMesure unite where " +
												"unite.symboleUom =:param")
				.setParameter("param", this.unite)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(uniteMesureInstance!=null)
			{
				getInstance().setUniteMesure(uniteMesureInstance);
			}
		}
		
	}

*/
	
	public void setPesticidesHomologuesIdHomologation(Long id) {
		setId(id);
	}

	public Long getPesticidesHomologuesIdHomologation() {
		return (Long) getId();
	}

	@Override
	protected PesticidesHomologues createInstance() {
		PesticidesHomologues pesticidesHomologues = new PesticidesHomologues();
		return pesticidesHomologues;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		LignesConvention lignesConvention = lignesConventionHome
				.getDefinedInstance();
		if (lignesConvention != null) {
			getInstance().setLignesConvention(lignesConvention);
		}
		
		/*
		Pesticide pesticide = pesticideHome.getDefinedInstance();
		if (pesticide != null) {
			getInstance().setPesticide(pesticide);
		}*/
		
		/*
		UniteMesure uniteMesure = uniteMesureHome.getDefinedInstance();
		if (uniteMesure != null) {
			getInstance().setUniteMesure(uniteMesure);
		}
		*/
		
	}

	public boolean isWired() {
		if (getInstance().getLignesConvention() == null)
			return false;
		if (getInstance().getPesticide() == null)
			return false;
		return true;
	}

	public PesticidesHomologues getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	/*
	public void uniteChanged(ValueChangeEvent event)
	{
		String uom = (String)event.getNewValue();

		if(!uom.trim().equals(""))
		{
			setUnite(uom);
			
			logger.info("********************* L'objet unite de mesure a été mis à jour : "+uom);	
		}

	}
	*/
	
	public void pesticideChanged(ValueChangeEvent event)
	{
		String designation = (String)event.getNewValue();

		if(!designation.trim().equals(""))
		{
			setPesticide(designation);
			
			logger.info("********************* L'objet pesticide a été mis à jour : "+designation);	
		}

	}
	
	public void darChanged(ValueChangeEvent event)
	{
		try
		{
			Integer dar = (Integer)event.getNewValue();
			
			getInstance().setDar(dar.intValue());
			
			logger.info("********************* La DAR a été mis à jour : "+dar+" jours");	
		}
		catch(NumberFormatException nfe)
		{
		}
	}
	
	public void doseChanged(ValueChangeEvent event)
	{
		try
		{
			BigDecimal dose = new BigDecimal((String)event.getNewValue());
			
			getInstance().setDose(dose);
			
			logger.info("********************* La dose a été mis à jour : "+dose);	
		}
		catch(NumberFormatException nfe)
		{
		}
	}
	
	public void uniteDoseChanged(ValueChangeEvent event)
	{
		
			String unite = (String)event.getNewValue();
			
			getInstance().setUniteDose(unite);
			
			logger.info("********************* Unité de dose mise à jour : "+unite);	
	}
}
