package com.agritrace.session;

import com.agritrace.entity.production.*;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.convention.LignesConvention;

import java.util.ArrayList;
import java.util.List;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("planningProductionHome")
public class PlanningProductionHome extends EntityHome<PlanningProduction> {

	@In(create = true)
	CampagneHome campagneHome;
	
	@In(create = true)
	LignesConventionHome lignesConventionHome;
	
	@In(create=true)
	CampagneSession campagneSession;

	public void setPlanningProductionIdPlanningProduction(Long id) {
		setId(id);
	}

	public Long getPlanningProductionIdPlanningProduction() {
		return (Long) getId();
	}

	@Override
	protected PlanningProduction createInstance() {
		PlanningProduction planningProduction = new PlanningProduction();
		return planningProduction;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		System.out.println("Pre-Affectatation campagne => convention");
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
			
			System.out.println("Post-Affectatation campagne => convention");
		}
		
		LignesConvention lignesConvention = lignesConventionHome
		.getDefinedInstance();
		if (lignesConvention != null) 
		{
			getInstance().setLignesConvention(lignesConvention);
		}
	}

	public boolean isWired() {
		
		if (getInstance().getLignesConvention() == null)
			return false;
		
		if(getInstance().getCampagne()==null)
			return false;
		return true;
	}

	public PlanningProduction getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<CyclePlanningProduction> getCyclesPlanningProduction() {
		return getInstance() == null ? null
				: new ArrayList<CyclePlanningProduction>(getInstance()
						.getCyclesPlanningProduction());
	}

}
