package com.agritrace.session;

import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("planningProductionList")
public class PlanningProductionList extends EntityQuery<PlanningProduction> {

	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select planningProduction from PlanningProduction planningProduction";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(planningProduction.numeroPlanningProduction) like lower(concat(#{planningProductionList.planningProduction.numeroPlanningProduction},'%'))", 
		"planningProduction.lignesConvention.convention.campagne.campagne = #{campagneSession.campagne.campagne}",
		"planningProduction.lignesConvention.convention.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private PlanningProduction planningProduction = new PlanningProduction();

	public PlanningProductionList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public PlanningProduction getPlanningProduction() {
		return planningProduction;
	}

}
