package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.tiers.Personnel;
import com.agritrace.entity.tiers.Pointage;

@Name("pointageHome")
public class PointageHome extends EntityHome<Pointage> 
{

	/*
	@In(create = true)
	CampagneHome campagneHome;
	*/
	
	@In(create = true)
	PersonnelHome personnelHome;
	
	private String personnel; 
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In
	DomaineSession domaineSession;
	
	@In(create=true)
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	@In(create=true)
	PersonnelList personnelList;
	
	
	public String getPersonnel() 
	{
		return (getInstance().getPersonnel()!=null ? getInstance().getPersonnel().getNomPersonnel()+" "+getInstance().getPersonnel().getPrenomPersonnel() : personnel);
	}

	public void setPersonnel(String personnel) 
	{
		this.personnel = personnel;
		setInstancePersonnel();
		
	}

	public void setPointageIdPointage(Long id) 
	{
		setId(id);
	}

	public Long getPointageIdPointage() {
		return (Long) getId();
	}

	@Override
	protected Pointage createInstance() {
		Pointage pointage = new Pointage();
		return pointage;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	
	@Override
	public String persist() 
	{
		return super.persist();
	
	}

	
	@Override
	public String update() 
	{
		return super.update();
	}

	public void wire() 
	{
		getInstance();
		
		///////////////////////L'objet campagne va être affecté implicitement
		
		//Campagne campagne = campagneHome.getDefinedInstance();
		
		Campagne campagne=campagneSession.getCampagne();

		if(campagne != null) 
		{
			getInstance().setCampagne(campagne);
		}
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
		
		//generateData();
	}

	public boolean isWired() 
	{
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getPersonnel() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public Pointage getDefinedInstance() 
	{
		return isIdDefined() ? getInstance() : null;
	}
	
	public void setInstancePersonnel()
	{
		String [] nomPrenom = getPersonnel().split(" ");
		
		System.out.println("L'employé est : >>>>>>>>>>>>>>>> "+getPersonnel());
		
		Personnel personnel=null;
		
		try
		{
			personnel = (Personnel) entityManager.createQuery("select personnel from Personnel personnel where personnel.nomPersonnel =:nom " +
			"and personnel.prenomPersonnel =:prenom")
			.setParameter("nom", nomPrenom[0])
			.setParameter("prenom", nomPrenom[1])
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			
		}
		
		if(personnel!=null)
		{
			getInstance().setPersonnel(personnel);
		}
	}
	
	public void personnelChanged(ValueChangeEvent event)
	{
		String personnelSelected=(String)event.getNewValue();
		
		if(!personnelSelected.trim().equals(""))
		{
			setPersonnel(personnelSelected);
			logger.info(">>>>>>>>>>>>>>>>> Employé changed : "+personnelSelected);
		}
		else
		{
			setPersonnel(null);
		}
	}
	
}
