package com.agritrace.session;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.tiers.Pointage;

@Name("pointageList")
public class PointageList extends EntityQuery<Pointage> {

	private static final String EJBQL = "select pointage from Pointage pointage";
	
	@In(create=true)
	private EntityManager entityManager;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@Out(required=false)
	private List<String> listDesCampagne;
	
	private static final String[] RESTRICTIONS = {
		
		"CAST(pointage.datePointage AS date) = CAST(#{pointageList.pointage.datePointage} AS date)",
		"pointage.campagne.campagne = #{campagneSession.campagne.campagne}",
		"pointage.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private Pointage pointage = new Pointage();

	public PointageList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Pointage getPointage() {
		return pointage;
	}


	public void setPointage(Pointage pointage) {
		this.pointage = pointage;
	}
	
	/*
	@Factory("listDesCampagne")
	public List<String> getListPays()
	{	
		listDesCampagne=new ArrayList<String>();
		
		try
		{
			listDesCampagne=entityManager.createQuery("select C.campagne from Campagne C")
			.getResultList();
			System.out.print("Nbre de campagnes trouvées : "+listDesCampagne.size());
		}
		catch(NoResultException nre )
		{
			nre.getStackTrace();
		}
		
	    
		return listDesCampagne;
	}
	*/
	
}
