package com.agritrace.session;

import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;

import com.agritrace.entity.articles.PorteGreffe;
import com.agritrace.entity.articles.Variete;
import com.agritrace.entity.unitesMesure.UniteMesure;

@Name("porteGreffeHome")
public class PorteGreffeHome extends ArticleHome<PorteGreffe> {

	@In(create = true)
	VarieteHome varieteHome;

	public void setPorteGreffeIdArticle(Long id) {
		setId(id);
	}

	public Long getPorteGreffeIdArticle() {
		return (Long) getId();
	}

	@Override
	protected PorteGreffe createInstance() {
		PorteGreffe porteGreffe = new PorteGreffe();
		return porteGreffe;
	}
	
	

	@Override
	public PorteGreffe getInstance() {
		// TODO Auto-generated method stub
		return (PorteGreffe)super.getInstance();
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		super.wire();
		
		Variete variete = varieteHome.getDefinedInstance();
		if (variete != null) {
			getInstance().setVariete(variete);
		}
		
		////////////////	Affectation Unité de mesure		///////////////////////////////
		
		/*Recherche d'une instance UniteMesure ayant le symbole like "U" pour l'affecter
		 *à l'instance du porte-greffe pour que l'utilisateur ne se trouve pas toujours  
		 *  oubliger de sélectionner à chaque fois l'Unité de mesure "U" qui est évidente
		 *  
		*/
		
		/////////////// Insertion/Affectation de l'Unité de mesure//////////////////////////
		final String symboleUom = "U";
		
		UniteMesure unite=null;
		
		try
		{
			unite = (UniteMesure) entityManager
			.createQuery(
					"select unite from UniteMesure unite where lower(unite.symboleUom) like :symbole")
			.setParameter("symbole",
					symboleUom.toLowerCase())
			.getSingleResult();
		}
		catch(NoResultException nre)
		{
			logger.debug("L'unité de mesure concernée "+symboleUom+" n'existe pas dans la base : >>>>>> ");
		}
		
		
		if (unite == null) 
		{

			logger.info(":::::::::::::::::::::::::::::::Création de l'Unité de mesure::::::::::::::::");
			
			
			unite=new UniteMesure("U","Unité");

			// /Persistance de l'objet UOM
			entityManager.persist(unite);
			
		} 
		else 
		{
			System.out.println("-----------------------L'unité de Mesure concernée existe déjà dans la base : "
											+unite.getSymboleUom());
		}
		
		////////////////Affectation de l'unite trouvée à l'instance du PORTE-GREFFE
		
		getInstance().setUniteMesure(unite);
		
	}

	public boolean isWired() {
		return true;
	}

	public PorteGreffe getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

}
