package com.agritrace.session;

import java.util.Arrays;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.tiers.Producteur;

@Name("producteurList")
public class ProducteurList extends EntityQuery<Producteur> {
	
	private static final String EJBQL = "select producteur from Producteur producteur";

	private static final String[] RESTRICTIONS = 
	{ 
		"lower(producteur.libelleTiers) like lower(concat(#{producteurList.producteur.libelleTiers},'%'))", 
	};

	private Producteur producteur = new Producteur();

	public ProducteurList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Producteur getProducteur() {
		return producteur;
	}
	
	
	//////////////Pour tester si une définition du producteur a été déjà faite  ====> Nbre producteur == 1
	
	public boolean isProducteurAlreadyDefined()
	{
		return (this.getResultCount() >= 0 ? true : false);
	}
	
}
