package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;
import com.agritrace.entity.tiers.Fournisseur;
import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

@Name("receptionHome")
public class ReceptionHome extends EntityHome<Reception> {

	/*
	@In(create = true)
	CampagneHome campagneHome;
	*/
	
	@In(create=true)
	CampagneSession campagneSession;

	@In
	DomaineSession domaineSession;
	
	@Logger
	Log logger;
	
	private String nomFournisseur;
	
	@In
	EntityManager entityManager;
	
	
	public String getNomFournisseur() 
	{
		return (getInstance().getFournisseur()!=null ? getInstance().getFournisseur().getLibelleTiers() : this.nomFournisseur);
	}

	public void setNomFournisseur(String nomFournisseur) {
		this.nomFournisseur = nomFournisseur;
		setInstanceFournisseur();
	}

	
	private void setInstanceFournisseur() 
	{
		
		Fournisseur fournisseurInstance =null;
		
		if(!this.nomFournisseur.equals(""))
		{
			try
			{
				fournisseurInstance = (Fournisseur)entityManager.createQuery("select fournisseur from Fournisseur fournisseur where " +
												"fournisseur.libelleTiers =:param")
				.setParameter("param", this.nomFournisseur)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(fournisseurInstance!=null)
			{
				getInstance().setFournisseur(fournisseurInstance);
			}
		}
	}

	public void setReceptionIdReception(Long id) {
		setId(id);
	}

	public Long getReceptionIdReception() {
		return (Long) getId();
	}

	@Override
	protected Reception createInstance() {
		Reception reception = new Reception();
		return reception;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		/*
		Campagne campagne = campagneHome.getDefinedInstance();
		*/
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine!=null)
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() 
	{
		if (getInstance().getCampagne() == null)
			return false;
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public Reception getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<LigneReception> getLignesReception() {
		return getInstance() == null ? null : new ArrayList<LigneReception>(
				getInstance().getLignesReception());
	}
	
	public void fournisseurChanged(ValueChangeEvent event)
	{
		//Fournisseur fournisseur=(Fournisseur)event.getNewValue();
		
		String nomFournisseur = (String)event.getNewValue();
		
		if(!nomFournisseur.trim().equals(""))
		{
			setNomFournisseur(nomFournisseur);
			logger.info(">>>>>>>>>>>>>>>>> Fournisseur changed : "+nomFournisseur);
		}
	}

}
