package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("receptionList")
public class ReceptionList extends EntityQuery<Reception> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select reception from Reception reception";

	private static final String[] RESTRICTIONS = { 
		
		"lower(reception.numeroReception) like lower(concat(#{receptionList.reception.numeroReception},'%'))",
		"reception.campagne.campagne = #{campagneSession.campagne.campagne}",
		"reception.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
		
	};

	private Reception reception = new Reception();

	public ReceptionList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Reception getReception() {
		return reception;
	}
}
