package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.log.Log;

import com.agritrace.entity.production.DetailsRecolteCaisses;
import com.agritrace.entity.production.ParcelleCulturale;
import com.agritrace.entity.production.Recolte;

@Name("recolteHome")
public class RecolteHome extends InterventionHome<Recolte> 
{
	
	@In(create = true)
	ParcelleCulturaleHome parcelleCulturaleHome;
		
	private String numeroParcelleCulturale="";

	@Logger
	Log logger;

	
	
	public void setNumeroParcelleCulturale(String numeroParcelleCulturale) 
	{
		this.numeroParcelleCulturale = numeroParcelleCulturale;
		setInstanceParcelleCulturale();
	}
	
	public String getNumeroParcelleCulturale() 
	{
		return (getInstance().getParcelleCulturale()!=null ? getInstance().getParcelleCulturale().getNumeroParcelleCulturale() : numeroParcelleCulturale);
	}
	
	
	public void setRecolteIdIntervention(Long id) {
		setId(id);
	}

	public Long getRecolteIdIntervention() {
		return (Long) getId();
	}

	@Override
	protected Recolte createInstance() {
		Recolte recolte = new Recolte();
		return recolte;
	}

	public void load() 
	{
		if (isIdDefined()) {
			wire();
		}
	}
	
	@Override
	public Recolte getInstance() {
		return (Recolte) super.getInstance();
	}

	public void wire() 
	{
		getInstance();
		
		super.wire();
		
		/*
		ParcelleCulturale parcelleCulturale = parcelleCulturaleHome.getDefinedInstance();
		
		if (parcelleCulturale != null) 
		{
			getInstance().setParcelleCulturale(parcelleCulturale);
		}
		*/		
	}

	public boolean isWired() 
	{
		//J'ai éviter de faire super.iswired() pour ne pas appliquer la condition de la présence de l'objet 
		//Operation car ce n'est pas obligatoire pr le cas de la sous classe Recole
		
		if(getInstance().getCampagne()==null || getInstance().getParcelleCulturale()==null || getInstance().getDomaine()==null)
		{
			return false;
		}
		else
		{
			return true;	
		}
		
	}

	public Recolte getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<DetailsRecolteCaisses> getDetailsRecolteCaisses() 
	{
		return getInstance() == null ? null
				: new ArrayList<DetailsRecolteCaisses>(getInstance()
						.getDetailsRecolteCaisses());
	}
	
	public void setInstanceParcelleCulturale()
	{
		ParcelleCulturale parcelleCulturaleInstance =null;
		
		if(!this.numeroParcelleCulturale.trim().equals(""))
		{
			try
			{
				parcelleCulturaleInstance = (ParcelleCulturale) entityManager.createQuery("select parcelleCulturale from ParcelleCulturale parcelleCulturale where " +
												"parcelleCulturale.numeroParcelleCulturale =:numero")
				.setParameter("numero", this.numeroParcelleCulturale)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(parcelleCulturaleInstance!=null)
			{
				logger.info("La parcelle culturale à persister est : >>>>>>>>>>>>>>>>>"+parcelleCulturaleInstance.getNumeroParcelleCulturale());
				getInstance().setParcelleCulturale(parcelleCulturaleInstance);
			}
		}
		
	}
	
	public void parcelleCulturaleChanged(ValueChangeEvent event)
	{
		String parcelleCulturaleSelected=(String)event.getNewValue();
		
		if(!parcelleCulturaleSelected.trim().equals(""))
		{
			setNumeroParcelleCulturale(parcelleCulturaleSelected);
			logger.info(">>>>>>>>>>>>>>>>> Parcelle culturale changed : "+parcelleCulturaleSelected);
		}
		else
		{
			setNumeroParcelleCulturale(null);
		}
	}


}
