package com.agritrace.session;

import com.agritrace.entity.domaine.Parcelle;
import com.agritrace.entity.production.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("recolteList")
public class RecolteList extends EntityQuery<Recolte> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	@In(create=true)
	EntityManager entityManager;
	
	
	private static final String EJBQL = "select recolte from Recolte recolte where " +
			"recolte.campagne.campagne = #{campagneSession.campagne.campagne} and " +
			"recolte.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}";

	private static final String[] RESTRICTIONS = { 
		
		"lower(recolte.numeroIntervention) like lower(concat(#{recolteList.recolte.numeroIntervention},'%'))",
		"lower(recolte.numeroLotRecolte) like lower(concat(#{recolteList.recolte.numeroLotRecolte},'%'))",
	};

	private Recolte recolte = new Recolte();

	public RecolteList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Recolte getRecolte() {
		return recolte;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeRecoltes")
	public List<String> getListeRecoltes()
	{
		return entityManager.createQuery("select recolte.numeroIntervention from Recolte recolte where " +
				"recolte.campagne.campagne = #{campagneSession.campagne.campagne} and " +
				"recolte.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine} " +
				"order by recolte.numeroIntervention asc").getResultList();
	}
}
