package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.log.Log;

import com.agritrace.entity.gestionCommercial.LigneRetourCaisses;
import com.agritrace.entity.gestionCommercial.RetourCaisses;
import com.agritrace.entity.tiers.Client;

@Name("retourCaissesHome")
public class RetourCaissesHome extends RetourHome<RetourCaisses> {
	
	/*
	@In(create = true)
	ClientHome clientHome;
	*/
	
	@Logger
	Log logger;
	
	private String nomClient;
	
	@In
	EntityManager entityManager;
	
	
	public String getNomClient() 
	{
		return (getInstance().getClient()!=null ? getInstance().getClient().getLibelleTiers() : this.nomClient);
	}

	public void setNomClient(String nomClient) 
	{
		this.nomClient = nomClient;
		setInstanceClient();
	}

	
	private void setInstanceClient() 
	{
		Client clientInstance =null;
		
		if(!this.nomClient.equals(""))
		{
			try
			{
				clientInstance = (Client)entityManager.createQuery("select client from Client client where " +
												"client.libelleTiers =:param")
				.setParameter("param", this.nomClient)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(clientInstance!=null)
			{
				getInstance().setClient(clientInstance);
			}
		}
	}

	public void setRetourCaissesIdRetour(Long id) {
		setId(id);
	}

	public Long getRetourCaissesIdRetour() {
		return (Long) getId();
	}

	@Override
	protected RetourCaisses createInstance() {
		RetourCaisses retourCaisses = new RetourCaisses();
		return retourCaisses;
	}

	@Override
	public RetourCaisses getInstance() 
	{
		return (RetourCaisses)super.getInstance();
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		super.wire();

	}

	public boolean isWired() {
		
		if(!super.isWired())
			return false;
		if(getInstance().getClient()==null)
			return false;
		return true;
	}

	public RetourCaisses getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<LigneRetourCaisses> getLignesRetourCaisses() {
		return getInstance() == null ? null
				: new ArrayList<LigneRetourCaisses>(getInstance()
						.getLignesRetourCaisses());
	}
	
	public void clientChanged(ValueChangeEvent event)
	{
		String nomClient=(String)event.getNewValue();
		
		if(!nomClient.trim().equals(""))
		{
			setNomClient(nomClient);
			logger.info(">>>>>>>>>>>>>>>>> Client changed : "+nomClient);
		}
	}

}
