package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("retourCaissesList")
public class RetourCaissesList extends EntityQuery<RetourCaisses> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select retourCaisses from RetourCaisses retourCaisses";

	private static final String[] RESTRICTIONS = { 
			
			"lower(retourCaisses.numeroRetour) like lower(concat(#{retourCaissesList.retourCaisses.numeroRetour},'%'))", 
			"retourCaisses.campagne.campagne = #{campagneSession.campagne.campagne}",
			"retourCaisses.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private RetourCaisses retourCaisses = new RetourCaisses();

	public RetourCaissesList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public RetourCaisses getRetourCaisses() {
		return retourCaisses;
	}
}
