package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.log.Log;

import com.agritrace.entity.gestionCommercial.LigneRetourFournisseur;
import com.agritrace.entity.gestionCommercial.RetourFournisseur;
import com.agritrace.entity.tiers.Fournisseur;

@Name("retourFournisseurHome")
public class RetourFournisseurHome extends RetourHome<RetourFournisseur> {
	
	@Logger
	Log logger;
	
	private String nomFournisseur;
	
	@In
	EntityManager entityManager;
	
	
	public String getNomFournisseur() 
	{
		return (getInstance().getFournisseur()!=null ? getInstance().getFournisseur().getLibelleTiers() : this.nomFournisseur);
	}

	public void setNomFournisseur(String nomFournisseur) 
	{
		this.nomFournisseur = nomFournisseur;	
		setInstanceFournisseur();
	}
	
	private void setInstanceFournisseur() 
	{
		
		Fournisseur fournisseurInstance =null;
		
		if(!this.nomFournisseur.equals(""))
		{
			try
			{
				fournisseurInstance = (Fournisseur)entityManager.createQuery("select fournisseur from Fournisseur fournisseur where " +
												"fournisseur.libelleTiers =:param")
				.setParameter("param", this.nomFournisseur)
				.getSingleResult();
			}
			catch(NoResultException nre)
			{
			}
			
			if(fournisseurInstance!=null)
			{
				getInstance().setFournisseur(fournisseurInstance);
			}
		}
	}

	public void setRetourFournisseurIdRetour(Long id) {
		setId(id);
	}

	public Long getRetourFournisseurIdRetour() {
		return (Long) getId();
	}

	@Override
	protected RetourFournisseur createInstance() {
		RetourFournisseur retourFournisseur = new RetourFournisseur();
		return retourFournisseur;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}
	
	@Override
	public RetourFournisseur getInstance() {
		return (RetourFournisseur)super.getInstance();
	}
	
	public void wire() 
	{
		getInstance();
		super.wire();
	}

	public boolean isWired() 
	{
		return super.isWired();
	}

	public RetourFournisseur getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<LigneRetourFournisseur> getLignesRetourFournisseur() {
		return getInstance() == null ? null
				: new ArrayList<LigneRetourFournisseur>(getInstance()
						.getLignesRetourFournisseur());
	}
	
	public void fournisseurChanged(ValueChangeEvent event)
	{
		//Fournisseur fournisseur=(Fournisseur)event.getNewValue();
		
		String nomFournisseur = (String)event.getNewValue();
		
		if(!nomFournisseur.trim().equals(""))
		{
			setNomFournisseur(nomFournisseur);
			logger.info(">>>>>>>>>>>>>>>>> Fournisseur changed : "+nomFournisseur);
		}
	}

}
