package com.agritrace.session;

import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("retourFournisseurList")
public class RetourFournisseurList extends EntityQuery<RetourFournisseur> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	private static final String EJBQL = "select retourFournisseur from RetourFournisseur retourFournisseur";

	private static final String[] RESTRICTIONS = {
		
		"lower(retourFournisseur.numeroRetour) like lower(concat(#{retourFournisseurList.retourFournisseur.numeroRetour},'%'))", 
		"retourFournisseur.campagne.campagne = #{campagneSession.campagne.campagne}",
		"retourFournisseur.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",
	};

	private RetourFournisseur retourFournisseur = new RetourFournisseur();

	public RetourFournisseurList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public RetourFournisseur getRetourFournisseur() {
		return retourFournisseur;
	}
}
