package com.agritrace.session;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.gestionCommercial.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("retourHome")
public class RetourHome<E> extends EntityHome<Retour> {
	
	@In(create=true)
	CampagneSession campagneSession;
	
	@In(create=true)
	DomaineSession domaineSession;
	
	
	public void setRetourIdRetour(Long id) {
		setId(id);
	}

	public Long getRetourIdRetour() {
		return (Long) getId();
	}

	@Override
	protected Retour createInstance() {
		Retour retour = new Retour();
		return retour;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		
		getInstance();
		
		Campagne campagne=campagneSession.getCampagne();
		
		if (campagne != null) 
		{
			getInstance().setCampagne(campagne);
		}
		
		Domaine domaine= domaineSession.getDomaine();
		
		if(domaine != null)
		{
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		
		if(getInstance().getDomaine()==null || getInstance().getCampagne()==null)
			return false;
		return true;
	}

	public Retour getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

}
