package com.agritrace.session;

import com.agritrace.entity.domaine.*;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("secteurList")
public class SecteurList extends EntityQuery<Secteur> {

	private static final String EJBQL = "select secteur from Secteur secteur";

	private static final String[] RESTRICTIONS = {
			"lower(secteur.description) like lower(concat(#{secteurList.secteur.description},'%'))",
			"lower(secteur.libelleSecteur) like lower(concat(#{secteurList.secteur.libelleSecteur},'%'))",
			"lower(secteur.numeroSecteur) like lower(concat(#{secteurList.secteur.numeroSecteur},'%'))", };

	private Secteur secteur = new Secteur();

	public SecteurList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Secteur getSecteur() {
		return secteur;
	}
}
