package com.agritrace.session;

import java.util.Calendar;
import java.util.Date;

import javax.faces.event.ValueChangeEvent;

import com.agritrace.entity.convention.*;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("semaineHome")
public class SemaineHome extends EntityHome<Semaine> {

	@In(create = true)
	CampagneHome campagneHome;

	public void setSemaineIdSemaine(Long id) {
		setId(id);
	}

	public Long getSemaineIdSemaine() {
		return (Long) getId();
	}

	@Override
	protected Semaine createInstance() {
		Semaine semaine = new Semaine();
		return semaine;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Campagne campagne = campagneHome.getDefinedInstance();
		if (campagne != null) {
			getInstance().setCampagne(campagne);
		}
	}

	public boolean isWired() {
		return true;
	}

	public Semaine getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void semaineDuChanged(ValueChangeEvent event)
	{
		Date dateChoosed = (Date)event.getNewValue();
	
		if(dateChoosed!=null)
		{
			getInstance().setSemaineDu(dateChoosed);
			
			getInstance().setSemaineAu(dateChoosed);
		}
	}

}
