package com.agritrace.session;

import com.agritrace.entity.convention.*;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("semaineList")
public class SemaineList extends EntityQuery<Semaine> {

	@In(create=true)
	CampagneSession campagneSession;
	
	private static final String EJBQL = "select semaine from Semaine semaine";

	private static final String[] RESTRICTIONS = 
	{ 
		"semaine.numeroSemaine = #{semaineList.semaine.numeroSemaine}",
		"semaine.campagne.campagne = #{campagneSession.campagne.campagne}",
	};

	private Semaine semaine = new Semaine();

	public SemaineList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public Semaine getSemaine() {
		return semaine;
	}
}
