package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

import com.agritrace.entity.location.Adresse;
import com.agritrace.entity.tiers.CategorieTiers;
import com.agritrace.entity.tiers.Tiers;

@Name("tiersHome")
public class TiersHome<E> extends EntityHome<Tiers> {

	@In(create = true)
	CategorieTiersHome categorieTiersHome;

	public void setTiersIdTiers(Integer id) {
		setId(id);
	}

	public Integer getTiersIdTiers() {
		return (Integer) getId();
	}

	@Override
	protected Tiers createInstance() {
		Tiers tiers = new Tiers();
		return tiers;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() 
	{
		getInstance();
		
		CategorieTiers categorieTiers = categorieTiersHome.getDefinedInstance();
		if (categorieTiers != null) {
			getInstance().setCategorieTiers(categorieTiers);
		}
		
		
	}

	public boolean isWired() 
	{
		return true;
	}

	public Tiers getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<Adresse> getListeAdresses() {
		return getInstance() == null ? null : new ArrayList<Adresse>(
				getInstance().getListeAdresses());
	}

}
