package com.agritrace.session;

import com.agritrace.entity.tiers.*;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;

@Name("tiersList")
public class TiersList extends EntityQuery<Tiers> {

	private static final String EJBQL = "select tiers from Tiers tiers";

	private static final String[] RESTRICTIONS = { "lower(tiers.libelleTiers) like lower(concat(#{tiersList.tiers.libelleTiers},'%'))", };

	private Tiers tiers = new Tiers();

	public TiersList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public Tiers getTiers() {
		return tiers;
	}
}
