package com.agritrace.session;

import com.agritrace.entity.domaine.*;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("toiletteHome")
public class ToiletteHome extends EntityHome<Toilette> {

	@In(create = true)
	DomaineHome domaineHome;

	public void setToiletteIdToilette(Long id) {
		setId(id);
	}

	public Long getToiletteIdToilette() {
		return (Long) getId();
	}

	@Override
	protected Toilette createInstance() {
		Toilette toilette = new Toilette();
		return toilette;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
	}

	public boolean isWired() {
		if (getInstance().getDomaine() == null)
			return false;
		return true;
	}

	public Toilette getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

}
