package com.agritrace.session;

import com.agritrace.entity.domaine.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("toiletteList")
public class ToiletteList extends EntityQuery<Toilette> {

	
	@In(create=true)
	DomaineSession domaineSession;
	
	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select toilette from Toilette toilette";

	private static final String[] RESTRICTIONS = {
			"lower(toilette.description) like lower(concat(#{toiletteList.toilette.description},'%'))",
			"lower(toilette.numeroToilette) like lower(concat(#{toiletteList.toilette.numeroToilette},'%'))",
			"toilette.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}",		
	};

	private Toilette toilette = new Toilette();

	public ToiletteList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public Toilette getToilette() {
		return toilette;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeToilettes")
	public List<Parcelle> getListeParcelles()
	{
		return entityManager.createQuery("select toilette.numeroToilette from Toilette toilette " +
				"where toilette.domaine.libelleDomaine = #{domaineSession.domaine.libelleDomaine}").getResultList();
	}
	
}
