package com.agritrace.session;

import com.agritrace.entity.articles.*;
import java.util.ArrayList;
import java.util.List;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

@Name("typeCultureHome")
public class TypeCultureHome extends EntityHome<TypeCulture> {

	@In(create = true)
	CultureHome cultureHome;

	public void setTypeCultureIdTypeCulture(Long id) {
		setId(id);
	}

	public Long getTypeCultureIdTypeCulture() {
		return (Long) getId();
	}

	@Override
	protected TypeCulture createInstance() {
		TypeCulture typeCulture = new TypeCulture();
		return typeCulture;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		Culture culture = cultureHome.getDefinedInstance();
		if (culture != null) {
			getInstance().setCulture(culture);
		}
	}

	public boolean isWired() {
		if (getInstance().getCulture() == null)
			return false;
		return true;
	}

	public TypeCulture getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}

	public List<Variete> getListeVarietes() {
		return getInstance() == null ? null : new ArrayList<Variete>(
				getInstance().getListeVarietes());
	}

}
