package com.agritrace.session;

import com.agritrace.entity.articles.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("typeCultureList")
public class TypeCultureList extends EntityQuery<TypeCulture> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select typeCulture from TypeCulture typeCulture";

	private static final String[] RESTRICTIONS = {
			"lower(typeCulture.description) like lower(concat('%',concat(#{typeCultureList.typeCulture.description},'%')))",
			"lower(typeCulture.typeCulture) like lower(concat('%',concat(#{typeCultureList.typeCulture.typeCulture},'%')))", };

	private TypeCulture typeCulture = new TypeCulture();

	public TypeCultureList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setRestrictionLogicOperator("or");
	}

	public TypeCulture getTypeCulture() {
		return typeCulture;
	}
	
	
	@SuppressWarnings("unchecked")
	@Factory("listeTypesCultures")
	public List<String> getListeTypesCultures()
	{
		return entityManager.createQuery("select typeCulture.typeCulture from TypeCulture typeCulture " +
				"order by typeCulture.typeCulture asc").getResultList();
	}
	
}
