package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.articles.TypeEquipement;

@Name("typeEquipementList")
public class TypeEquipementList extends EntityQuery<TypeEquipement> {

	@In
	EntityManager entityManager;
	
	private static final String EJBQL = "select typeEquipement from TypeEquipement typeEquipement";

	private static final String[] RESTRICTIONS = {
			"lower(typeEquipement.description) like lower(concat(#{typeEquipementList.typeEquipement.description},'%'))",
			"lower(typeEquipement.typeEquipement) like lower(concat(#{typeEquipementList.typeEquipement.typeEquipement},'%'))", };

	private TypeEquipement typeEquipement = new TypeEquipement();

	public TypeEquipementList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public TypeEquipement getTypeEquipement() {
		return typeEquipement;
	}

	@SuppressWarnings("unchecked")
	@Factory("listeTypeEquipement")
	public List<TypeEquipement> getListeTypeEquipement()
	{
		return entityManager.createQuery(EJBQL)
								.getResultList();
	}
}
