package com.agritrace.session;

import com.agritrace.entity.domaine.*;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

@Name("typeIrrigationList")
public class TypeIrrigationList extends EntityQuery<TypeIrrigation> {

	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select typeIrrigation from TypeIrrigation typeIrrigation";

	private static final String[] RESTRICTIONS = {
			"lower(typeIrrigation.description) like lower(concat(#{typeIrrigationList.typeIrrigation.description},'%'))",
			"lower(typeIrrigation.libelleTypeIrrigation) like lower(concat(#{typeIrrigationList.typeIrrigation.libelleTypeIrrigation},'%'))", };

	private TypeIrrigation typeIrrigation = new TypeIrrigation();

	public TypeIrrigationList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public TypeIrrigation getTypeIrrigation() {
		return typeIrrigation;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeTypesIrrigation")
	public List<TypeIrrigation> getListeTypesIrrigation()
	{
		return entityManager.createQuery("select typeIrrigation.libelleTypeIrrigation from TypeIrrigation typeIrrigation").
		getResultList();
	}
}
