package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.domaine.TypeParcelle;

@Name("typeParcelleList")
public class TypeParcelleList extends EntityQuery<TypeParcelle> {

	@In(create=true)
	EntityManager entityManager;
	
	private static final String EJBQL = "select typeParcelle from TypeParcelle typeParcelle";

	private static final String[] RESTRICTIONS = {
			"lower(typeParcelle.description) like lower(concat(#{typeParcelleList.typeParcelle.description},'%'))",
			"lower(typeParcelle.typeParcelle) like lower(concat(#{typeParcelleList.typeParcelle.typeParcelle},'%'))", };

	private TypeParcelle typeParcelle = new TypeParcelle();

	public TypeParcelleList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public TypeParcelle getTypeParcelle() 
	{
		return typeParcelle;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeTypesParcelles")
	public List<TypeParcelle> getListeTypesParcelles()
	{
		return entityManager.createQuery("select typeParcelle.typeParcelle from TypeParcelle typeParcelle").getResultList();
	}
}
