package com.agritrace.session;

import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.domaine.TypeSol;

@Name("typeSolList")
public class TypeSolList extends EntityQuery<TypeSol> {

	@In
	EntityManager entityManager;
	
	
	private static final String EJBQL = "select typeSol from TypeSol typeSol";

	private static final String[] RESTRICTIONS = {
			"lower(typeSol.description) like lower(concat(#{typeSolList.typeSol.description},'%'))",
			"lower(typeSol.designationSol) like lower(concat(#{typeSolList.typeSol.designationSol},'%'))", };

	private TypeSol typeSol = new TypeSol();

	public TypeSolList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(25);
	}

	public TypeSol getTypeSol() {
		return typeSol;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeTypeSols")
	public List<TypeSol> getListeSols()
	{
		return entityManager.createQuery(EJBQL).getResultList();
	}
}
