package com.agritrace.session;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityQuery;

import com.agritrace.entity.unitesMesure.UniteMesure;

@Name("uniteMesureList")
public class UniteMesureList extends EntityQuery<UniteMesure> {

	private static final String EJBQL = "select uniteMesure from UniteMesure uniteMesure";

	@In(create=true)
	private EntityManager entityManager;

	private static final String[] RESTRICTIONS = {
			"lower(uniteMesure.designationUom) like lower(concat(#{uniteMesureList.uniteMesure.designationUom},'%'))",
			"lower(uniteMesure.symboleUom) like lower(concat(#{uniteMesureList.uniteMesure.symboleUom},'%'))", };

	private UniteMesure uniteMesure = new UniteMesure();

	public UniteMesureList() {
		setEjbql(EJBQL);
		setRestrictionExpressionStrings(Arrays.asList(RESTRICTIONS));
		setMaxResults(13);
	}

	public UniteMesure getUniteMesure() {
		return uniteMesure;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listDesUnites")
	public List<UniteMesure> getListUom()
	{	
		List<UniteMesure> listDesUnites=new ArrayList<UniteMesure>();
		
		try
		{
			listDesUnites=entityManager.createQuery("select U from UniteMesure U order by U.symboleUom asc")
			.getResultList();
		}
		catch(NoResultException nre )
		{
			nre.getStackTrace();
		}
		
	    
		return listDesUnites;
	}
	
	@SuppressWarnings("unchecked")
	@Factory("listeUnites")
	public List<UniteMesure> getListeUnites()
	{	
		List<UniteMesure> listeDesUnites=new ArrayList<UniteMesure>();
		
		try
		{
			listeDesUnites=entityManager.createQuery("select U.symboleUom from UniteMesure U order by U.symboleUom asc")
			.getResultList();
		}
		catch(NoResultException nre )
		{
			nre.getStackTrace();
		}
		
	    
		return listeDesUnites;
	}
	
	@Factory("listeUnitesDoses")
	public String [] getListeUnitesDoses()
	{	
		String[] listeDesUnites= {"g/hl", "g/ha","cc/hl", "cc/ha", "l/hl", "l/ha"};
		
		return listeDesUnites;
	}
}
