package com.agritrace.session;

import javax.faces.event.ValueChangeEvent;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.convention.Campagne;
import com.agritrace.entity.domaine.Domaine;
import com.agritrace.entity.userRoles.UserAffectationDomaine;
import com.agritrace.entity.userRoles.Users;

@Name("userAffectationDomaineHome")
public class UserAffectationDomaineHome extends
		EntityHome<UserAffectationDomaine> {

	/*
	@In(create = true)
	DomaineHome domaineHome;
	*/
	
	@In(create = true)
	UsersHome usersHome;
	
	@Logger
	Log logger;


	public void setUserAffectationDomaineIdUserAffectationDomaine(Long id) {
		setId(id);
	}

	public Long getUserAffectationDomaineIdUserAffectationDomaine() {
		return (Long) getId();
	}

	
	
	@Override
	protected UserAffectationDomaine createInstance() {
		UserAffectationDomaine userAffectationDomaine = new UserAffectationDomaine();
		return userAffectationDomaine;
	}

	public void load() {
		if (isIdDefined()) {
			wire();
		}
	}

	public void wire() {
		getInstance();
		/*
		Domaine domaine = domaineHome.getDefinedInstance();
		if (domaine != null) {
			getInstance().setDomaine(domaine);
		}
		*/
		
		Users user = usersHome.getDefinedInstance();
		if (user != null) {
			getInstance().setUser(user);
		}
	}

	public boolean isWired() {
		if (getInstance().getDomaine() == null)
			return false;
		if (getInstance().getUser() == null)
			return false;
		return true;
	}

	public UserAffectationDomaine getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	public void domaineChanged(ValueChangeEvent event)
	{
		Domaine  domaineSelected = (Domaine)event.getNewValue();
		
		if(domaineSelected!=null)
		{
			getInstance().setDomaine(domaineSelected);
			logger.info(">>>>>>>>>>>>>>>>>>>> [UserAffectationDomaine : domaineChanged] La valeur domaine a été changé :"+domaineSelected
					.getLibelleDomaine());
		}
	}

}
