package com.agritrace.session;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;
import org.jboss.seam.log.Log;

import com.agritrace.entity.userRoles.UserAffectationCampagne;
import com.agritrace.entity.userRoles.UserAffectationDomaine;
import com.agritrace.entity.userRoles.Users;

@Name("usersHome")
public class UsersHome extends EntityHome<Users> {

	@In
	EntityManager entityManager;
	
	@Logger
	Log logger;
	
	public void setUsersIdUser(Integer id) {
		setId(id);
	}

	public Integer getUsersIdUser() {
		return (Integer) getId();
	}

	@Override
	protected Users createInstance() {
		Users users = new Users();
		return users;
	}

	public void load() {
		if (isIdDefined()) {    
			wire();
		}
	}

	public void wire() {
		getInstance();
	}

	public boolean isWired() {
		return true;
	}

	public Users getDefinedInstance() {
		return isIdDefined() ? getInstance() : null;
	}
	
	
	
/*
	@Override
	public String persist() 
	{
		//Récupérer une instance d'un utilisateur ayant le profil Administrateur 
		
		List<Users> listeAdmin = (List<Users>) entityManager.createQuery("select user from Users user where user.libelleRole = :roleAdmin")
		.setParameter("roleAdmin", "Administrateur")
		.getResultList();
		
		if(listeAdmin.size()>0)
		{
			Users userAdmin = listeAdmin.get(0);
			
			logger.info(">>>>>>>>> Code User : "+userAdmin.getCode());
			
			getInstance().setCode(userAdmin.getCode());
		}
		
		return super.persist();
	}
*/
	
	public List<UserAffectationCampagne> getUserAffectationsCampagnes() {
		return getInstance() == null ? null
				: new ArrayList<UserAffectationCampagne>(getInstance()
						.getUserAffectationsCampagnes());
	}

	public List<UserAffectationDomaine> getUserAffectationsDomaines() {
		return getInstance() == null ? null
				: new ArrayList<UserAffectationDomaine>(getInstance()
						.getUserAffectationsDomaines());
	}
}
