package com.agritrace.session;

import java.io.Serializable;
import java.util.Date;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;

import org.jboss.seam.Component;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.faces.Validator;
import org.jboss.seam.annotations.intercept.BypassInterceptors;
import org.jboss.seam.log.Log;



@Name("validatorDate")
@Validator
@BypassInterceptors
public class ValidatorDate implements javax.faces.validator.Validator, Serializable 
{
	
	private static final long serialVersionUID = 1L;

	@Logger
	Log logger;
	
	public void validate(FacesContext context, UIComponent cmp, Object value) throws ValidatorException 
	{
		
		if (value != null) 
		{
			Date dateChoosed = (Date)value;
			
			CampagneSession campagneSession = (CampagneSession)Component.getInstance("campagneSession");
			
			////On fait un test si la date choisie est comprise entre l'intervalle des deux dates 
			////de la campagne
			
			if(dateChoosed.before(campagneSession.getCampagne().getDateDebut()) || dateChoosed.after(campagneSession.getCampagne().getDateFin()))
			{
				throw new ValidatorException(new FacesMessage("La date doit être comprise entre l'intervale des dates de la compagne en cours !!!"));
			}
		}
	}

}
